Lua_DragContainerItem = class("Lua_DragContainerItem", Lua_DisplayObject);
function Lua_DragContainerItem:ctor(p, skin)
	self.frameBuild = false;
	self._selected = false;
	self:superCall("ctor", p, skin, false);
end

function Lua_DragContainerItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_DragContainerItem:clean()
	self._selected = false;
	self.cellWidth  = 0;
	self.cellHeight = 0;
end

function Lua_DragContainerItem:checkInBound(posX, posY)
	local minX = self.centerPosX - self.w / 2;
	local maxX = self.centerPosX + self.w / 2;
	local minY = self.centerPosY - self.h / 2;
	local maxY = self.centerPosY + self.h / 2;
	if posX >= minX and posX <= maxX and posY >= minY and posY <= maxY then
		return true;
	end
	return false
end

function Lua_DragContainerItem:dispose()
	if self.subList ~= nil then
		self.subList:dispose();
		self.subList = nil;
	end
	self._selected = false;
	self.cellWidth  = 0;
	self.cellHeight = 0;
	self:superCall("dispose");
end

function Lua_DragContainerItem.Get:selected()
	return self._selected;
end

function Lua_DragContainerItem:setCustomParam(customParam)
	
end

function Lua_DragContainerItem:setData(data)
end

function Lua_DragContainerItem:setSubList(subList)
	self.subList = subList;
	if subList ~= nil then
		subList.isSubList = true;
	end
end

function Lua_DragContainerItem:setCellSeqIndex(idx)
	self.cellSeqIndex = idx;
	self.content.name = self.classname..self.cellSeqIndex;
end

function Lua_DragContainerItem:onSelectionChange(bSelected)
	self._selected = bSelected;
end

function Lua_DragContainerItem:onPressClick()

end

function Lua_DragContainerItem:onLongPressClick()

end

function Lua_DragContainerItem:onMouseDownHandle()

end

function Lua_DragContainerItem:onMouseUpHandle()

end

function Lua_DragContainerItem:getWidth()
    return 0;
end

function Lua_DragContainerItem:getHeight()
    return 0;
end