checkRequire("class");
checkRequire("Lua_MsgUtil");
Lua_EventOwner = class("Lua_EventOwner");
function Lua_EventOwner:ctor()
	-- self.lua_eventList = Array();
	-- self.lua_ceventList = Array();
	-- self.lua_timeList = Array();
end

function Lua_EventOwner:dispose()
	self.isDispose_2 = true;
	local len = 0;
	if self.lua_eventList ~= nil then
		len = self.lua_eventList:getSize();
		while (len > 0) do
			local t = self.lua_eventList[len];
			Lua_MsgUtil.removeEventListener(t.str, t.tb, t.fun);
			self.lua_eventList:remove(len);
			t.tb = nil;
			t.fun = nil;
			t.str = nil;
			len = len - 1;
		end
		self.lua_eventList = nil;
	end

	if self.lua_ceventList ~= nil then
		len = self.lua_ceventList:getSize();
		while (len > 0) do
			local t = self.lua_ceventList[len];
			MsgUtil.removeEventListener(t.str, t.key);
			self.lua_ceventList:remove(len);
			t.tb = nil;
			t.fun = nil;
			t.str = nil;
			t.key = nil;
			len = len - 1;
		end
		self.lua_ceventList = nil;
	end

	if self.lua_timeList ~= nil then
		len = self.lua_timeList:getSize();
		while (len > 0) do
			local t = self.lua_timeList[len];
			Lua_CommonUtil.removeTimer(t.tb, t.fun);
			self.lua_timeList:remove(len);
			t.tb = nil;
			t.fun = nil;
			t.funName = nil;
			len = len - 1;
		end
		self.lua_timeList = nil;
	end

	for k, v in pairs(self) do
		if k == "data" or k == "_data" then
			self[k] = nil;
		elseif type(v) == "table" and v.dispose ~= nil and v.isDispose_2 ~= true and type(v.dispose) == "function" then
			v:dispose();
		end
	end
end

function Lua_EventOwner:addLuaEvent(str, tb, fun)
	if Lua_MsgUtil.addEventListener(str, tb, fun) == true then
		if self.lua_eventList == nil then
			self.lua_eventList = Array();
		end
		self.lua_eventList:add({str = str, tb = tb, fun = fun});
	end
end

function Lua_EventOwner:removeLuaEvent(str, tb, fun)
	Lua_MsgUtil.removeEventListener(str, tb, fun);
	if self.lua_eventList ~= nil then
		local len = self.lua_eventList:getSize();
		for i = 1, len do
			local t = self.lua_eventList[i];
			if t.str == str and t.tb == tb and t.fun == fun then
				t.tb = nil;
				t.fun = nil;
				t.str = nil;
				self.lua_eventList:remove(i);
				break;
			end
		end
	end
end

function Lua_EventOwner:addCSharpEvent(str, tb, fun)
	local bNeedAdd = false
	if self.lua_ceventList == nil then
		self.lua_ceventList = Array();
		bNeedAdd = true;
	else
		bNeedAdd = true;
		local len = self.lua_ceventList:getSize();
		for i = 1, len do
			local t = self.lua_ceventList[i];
			if t.str == str and t.tb == tb and t.fun == fun then
				bNeedAdd = false;
				break;
			end
		end
	end

	if bNeedAdd == false then
		return;
	end

	local s = MsgUtil.addEventListener(str, tb, fun);
	self.lua_ceventList:add({str = str, tb = tb, fun = fun, key = s});
end

function Lua_EventOwner:removeCSharpEvent(str, tb, fun)
	if self.lua_ceventList ~= nil then
		local len = self.lua_ceventList:getSize();
		for i = 1, len do
			local t = self.lua_ceventList[i];
			if t.str == str and t.tb == tb and t.fun == fun then
				MsgUtil.removeEventListener(str, t.key);
				self.lua_ceventList:remove(i);
				t.tb = nil;
				t.fun = nil;
				t.str = nil;
				t.key = nil;
				break;
			end
		end
	end
end

function Lua_EventOwner:addTimer(funName, interval, tb, fun)
	if fun == nil then
		return;
	end

	if self.lua_timeList == nil then
		self.lua_timeList = Array();
	end

	if Lua_CommonUtil.addTimer(funName, interval, tb, fun, nil, -1) then
		local len = self.lua_timeList:getSize();
		for i = 1, len do
			local obj = self.lua_timeList[i];
			if obj.tb == tb and obj.fun == fun then
				return;
			end
		end
		self.lua_timeList:add({funName = funName, tb = tb, fun = fun});
	else
		self.lua_timeList:add({funName = funName, tb = tb, fun = fun});
	end
end

function Lua_EventOwner:removeTimer(tb, fun)
	if self.lua_timeList ~= nil then
		local len = self.lua_timeList:getSize();
		for i = 1, len do
			local obj = self.lua_timeList[i];
			if obj.tb == tb and obj.fun == fun then
				Lua_CommonUtil.removeTimer(obj.tb, obj.fun);
				self.lua_timeList:remove(i);
				obj.tb = nil;
				obj.fun = nil;
				obj.funName = nil;
				break;
			end
		end
	end
end