Lua_Window = class("Lua_Window", Lua_EventOwner);
Lua_Window.frameBuild = true;
function Lua_Window:ctor()
	self.w = 703;
	self.h = 500;
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;

	self._windowName = "windowName";
	self.skinName = nil;

	self.isFullPaving = false; -- 是否是全铺界面，是的话，显示完成会把场景隐藏
	self.isFullSizeWin = false;
	self.isSingleShowWin = false; -- 打开时只显示该窗口，其他窗口将设置active = false
	self.isStickTop = false; -- 置顶显示，比它层级高的界面将设置active = false

	self.openSound = "win_open_01";
	self.closeSound = "win_close_01";
	self.winSceneId = 0;
	self.bActive = true;

	self.showBlackMask = false;
	self.maskSprite = "xui_common_window_013";
	-- self.maskAlpha = 255; -- 0-255
	self.blackAlpha = 1; -- 0-1
	self.showBlurMask = false;

	self.showWinBg = false;
	self.isFullSizeBg = false; -- 背景平铺
	self.winBgPath = nil;
	self.winBgAtlas = nil;
	self.winBgSprite = nil;
	self.winBgPosX = 0;
	self.winBgPosY = 0;

	self.showTitleBg = false;
	self.titleBgPath = nil;
	self.titleBgAtlas = nil;
	self.titleBgSprite = nil;
	self.titleBgPosY = 0;

	self.showTitle = false;
	self.titleText = nil;
	self.titleAtlas = nil;
	self.titleSprite = nil;
	self.titleNamePosX = 0;
	self.titleNamePosY = 0;

	self.bShowTitleDeco = false;

	self.showClose = false;
	self.btnCloseAtlas = "common_altas_1";
	self.btnCloseSprite = "ui_common_button_002_n";
	self.btnClosePosX = 0;
	self.btnClosePosY = 0;

	self.isClickClose = false;
	self.showCloseText = false;
	self.closeTextPosY = 0;

	self.showBackBtn = false;
	self.bInitComplete = false;
	self.showWinBgComplete = false;

	local screenOffsetH = GlobalVar.screenOffsetTopH + GlobalVar.screenOffsetBottomH;
	self.width = MainWinDefine.V_width;
	self.height = MainWinDefine.V_height - screenOffsetH;
	self.adaptHeight = MainWinDefine.V_height - MainWinDefine.DEFAULT_SHOW_HEIGHT - screenOffsetH;

	self:superCall("ctor");
end

function Lua_Window:buildPanel(go)
	MsgUtil.callFunc("FPS_INTERMISSION_HIGHT");
	self.windowObj = UICreate.createGameObject(go, 0, 0, 0);
	self.windowObj.name = self.windowName;
	local rtf = self.windowObj:AddComponent(typeof(UnityEngine.RectTransform));
	LuaUtil.setRectSize(rtf, 0, 0);

	self.canvas = self.windowObj:AddComponent(typeof(UnityEngine.Canvas));
	self.canvas.pixelPerfect = false;
	self.canvas.overrideSorting = true;

	self.mgr = self.windowObj:AddComponent(typeof(UnityEngine.UI.GraphicRaycaster));
	self.mgr.blockingMask = UnityEngine.LayerMask.GetMask("UI");

	local content = UICreate.createGameObject(self.windowObj, 0, 0, 0);
	content.name = "content";
	self.content = content;
	self.content:SetActive(self.bActive);

	self.rectTf = self.content:AddComponent(typeof(UnityEngine.RectTransform));
	if self.isFullSizeWin then
		LuaUtil.setRectSize(self.rectTf, self.width, self.height);
	else
		LuaUtil.setRectSize(self.rectTf, 0, 0);
	end
	local offsetY = -(GlobalVar.screenOffsetTopH / 2) + (GlobalVar.screenOffsetBottomH / 2);
	LuaUtil.setObjPos(self.content, 0, offsetY, 0);

	self:buildMask();

	if Lua_Window.frameBuild == true and self.skinName ~= nil then
		self.skinBuilded = false;
		self.skinTable = checkRequire(self.skinName);
		self.conTable = {};
		self.conTable["content"] = self["content"];
		self.itemIndex = 1;
		self.content:SetActive(false);
		Lua_CommonUtil.addTimer("BUILD_SKIN", 0.001, self, self.onBuildingItem);
	else
		self.skinBuilded = true;
		self:buildFromSkin();
		self:buildShowItem();
	end
end

function Lua_Window:onBuildingItem()
	local isEnd = false;
	for i = 1,5 do
		isEnd = Lua_WindowUtil.buildFromSkinEachFrame(self, self.skinTable, self.conTable, self.itemIndex);
		if isEnd == true then
			break;
		else
			self.itemIndex = 1 + self.itemIndex;
		end
	end

	if isEnd == true then
		self.conTable = nil;
		self.skinTable = nil;
		Lua_CommonUtil.removeTimer(self, self.onBuildingItem);
		self.skinBuilded = true;
		self.content:SetActive(self.bActive);
		self:buildShowItem();
		if self.delayShowWin == true then
			self:doShowWin();
		else
			self:updateChatIcon(self.bActive)
			if self.bActive then
				if self.windowObj ~= nil then
					DataCenter.winTweenManager:createWinTween(self.windowName, self.windowObj.transform);
				end
				Lua_MsgUtil.callFunc("WIN_SHOW_COMPLETE", self.windowName);
				self:checkWinGuide();-- 引导数据检测
			end
		end
		
		-- if self.isSingleShowWin == true then
		-- 	WindowMananger.getInstance():hideWinsToBackStage(self.windowName);
		-- end
	end
end

function Lua_Window:buildFromSkin()
	if self.skinName ~= nil then
		Lua_WindowUtil.buildFromSkin(self, self.skinName, self.content);
	end
end

function Lua_Window:addPreLoadRes(resName, resType, keepTime, isOne)
	if keepTime == nil then 
		keepTime = 30; 
	end

	if isOne == nil then
		isOne = true;
	end

	if self.windowName == nil or self.windowName == "windowName" then
		if self.preLoadArr == nil then
			self.preLoadArr = Array();
		end
		self.preLoadArr:add({ resName = resName, resType = resType, keepTime = keepTime, isOne = isOne });
	else
		WindowMananger.getInstance():addWinPreLoadResInfo(self.windowName, resType, resName, keepTime, isOne);
	end
end

function Lua_Window:removePreLoadRes(resName, resType)
	WindowMananger.getInstance():removeWinPreLoadResInfo(self.windowName, resType, resName);
end

function Lua_Window:initSkinPreLoadRes()
	Lua_WindowUtil.initWinSkinPreLoadInfo(self.windowName, self.skinName);
end

function Lua_Window.Set:windowName(value)
	self._windowName = value;
	if value ~= nil and value ~= "windowName" then
		if self.preLoadArr ~= nil then
			local len = self.preLoadArr:getSize();
			while (len > 0) do
				local obj = self.preLoadArr[len];
				WindowMananger.getInstance():addWinPreLoadResInfo(value, obj.resType, obj.resName, obj.keepTime, obj.isOne);
				self.preLoadArr:remove(len);
				len = len - 1;
			end

			self.preLoadArr:dispose();
			self.preLoadArr = nil;
		end
	end
end

function Lua_Window.Get:windowName()
	return self._windowName;
end

function Lua_Window:buildMask()
	if self.showBlackMask == true then
		if self.maskBg == nil then
			self.maskBg = UICreate.createUIAtlasImage(self.windowObj, "common_altas_1", self.maskSprite, 0, 0, 2048, 2048);
			self.maskBg.name = "maskBg";
			self.maskBg.siblingIndex = 0;
			self.maskBg.alpha = 0.01;
		end
	elseif self.showBlurMask == true then
		if self.blurImg == nil then
			self.blurImg = UICreate.createScreenShotBlurImg(self.windowObj, 0, 0, 0, 0);
			self.blurImg.name = "blurImg";
			self.blurImg.siblingIndex = 0;
			self.blurImg.alpha = 0.01;
		end
	end

	if self.maskBg ~= nil then
		self.maskBg:setEnable(self.bActive);
		self.maskBg.clickScale = false;
		self.maskBg.clickSound = nil;
		self.maskBg:addClickFuntion(self, self.onMaskClick);
	elseif self.blurImg ~= nil then
		self.blurImg:setEnable(self.bActive);
		self.blurImg.clickScale = false;
		self.blurImg.clickSound = nil;
		self.blurImg:addClickFuntion(self, self.onMaskClick);
	end
end

function Lua_Window:buildShowItem()
	self:addLuaEvent("Guide_SyncWin_GuideData", self, self.checkWinGuide);
	if self.isFullSizeWin then
		self:addLuaEvent("SCREEN_RESIZE_LUA", self, self.onScreenResize);
	end

	if self.maskBg ~= nil then
		self.maskBg.alpha = self.blackAlpha;
	elseif self.blurImg ~= nil then
		self.blurImg.alpha = 1;
	end

	if self.showWinBg and self.winBg == nil then
		if self.winBgPath == nil then
			self.winBg = UICreate.createUIAtlasImage(self.content, self.winBgAtlas, self.winBgSprite, self.winBgPosX, self.winBgPosY, self.w, self.h);
		else
			self.winBg = UICreate.createImage(self.content, self.winBgPath, self.winBgPosX, self.winBgPosY, 0, 0);
		end

		self.winBg.name = "winBg";
		self.winBg.siblingIndex = 0;
		if self.isFullSizeWin then
			self.winBg.anchorValue = 1;
			self.winBg.pivotValue = 1;
			if self.isFullSizeBg then
				self.winBg:setLocation(self.winBgPosX, self.winBgPosY + GlobalVar.screenOffsetTopH, 0);
			else
				self.winBg:setLocation(self.winBgPosX, self.winBgPosY, 0);
			end
		end
	end

	if self.winBg then
		self.winBg.clickScale = false;
		self.winBg.clickSound = nil;
		self.winBg:addClickFuntion(self, self.onWinBgClick);
		if self.isFullPaving then
			self:checkWinBgShow();
			self.winBg:addLoadCompleteFun(self, self.onWinBgLoaded);
		end
	end

	if self.showTitleBg and self.titleBg == nil then
		self:createTitleBg(self.titleBgPosY)
	end

	if self.showTitle and self.titleName == nil then
		self:createTitleName(self.titleNamePosX, self.titleNamePosY)
	end

	if self.bShowTitleDeco then
		self:createTitleDeco();
	end

	if self.showClose and self.btnClose == nil then
		self:createBtnClose(self.btnClosePosX, self.btnClosePosY, 0, self.btnCloseAtlas, self.btnCloseSprite);
	end
	if self.btnClose then
		self.btnClose.name = "btnClose";
		self.btnClose.siblingIndex = 3;
		self.btnClose:resetSize();
		self.btnClose:addClickFuntion(self, self.onBtnCloseClick);
	end

	if self.isClickClose and self.showCloseText and self.closeText == nil then
		self:createCloseTips(0, self.closeTextPosY, 0);
	end

	if self.showBackBtn and self.backBtn == nil then
		self:createBackBtn();
	end

	if self.backBtn then
		self.backBtn:addClickFuntion(self, self.onBackBtnClick);
	end
end

function Lua_Window:createTitleBg(posY)
	if self.titleBgPath == nil then
		self.titleBg = UICreate.createUIAtlasImage(self.content, self.titleBgAtlas, self.titleBgSprite, 0, 0, 0, 0);
		self.titleBg:resetSize();
	else
		self.titleBg = UICreate.createImage(self.content, self.titleBgPath, 0, 0, 0, 0);
	end

	if self.isFullSizeWin then
		self.titleBg.anchorValue = 1;
		self.titleBg.pivotValue = 1;
	else
		self.titleBg:setLocation(0, posY, 0);
	end

	self.titleBg.name = "titleBg";
	self.titleBg.siblingIndex = 1;
end

function Lua_Window:createTitleName(posX, posY)
	if self.titleName == nil then
		if self.titleText then
			self.titleName = UICreate.createLabel(self.content, self.titleText, 0, 0, 100, 40, 40);
			self.titleName.pivot = UIUtils.Pivot.Center;
			self.titleName.fontName = "huakang_font";
			self.titleName.alignmentValue = 4;
			self.titleName.horizontalOverflowValue = 1;
			self.titleName.bApplyGradient = true;
			self.titleName.gradientTop = Lua_ColorDefine.transColor("A47851");
			self.titleName.gradientBottom = Lua_ColorDefine.transColor("764F47");
			self.titleName:resetSize()
		else
			self.titleName = UICreate.createUIAtlasImage(self.content, self.titleAtlas, self.titleSprite, 0, 0, 0, 0);
			self.titleName:resetSize();
		end
	end
	
	self.titleName.siblingIndex = 2;
	self.titleName.name = "titleName";
	self.titleName:setLocation(posX, posY, 0);
end

function Lua_Window:createTitleDeco(posY)
	if self.titleName == nil then
		return;
	end

	local posX = self.titleName.width / 2 + 22;
	posY = posY == nil and self.titleNamePosY or posY;
	if self.titleDeco_1 == nil then
		self.titleDeco_1 = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_line_003", 0, 0, 0, 0);
		self.titleDeco_1.pivot = UIUtils.Pivot.Left;
	end
	if self.titleDeco_2 == nil then
		self.titleDeco_2 = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_line_003", 0, 0, 0, 0);
		self.titleDeco_2.pivot = UIUtils.Pivot.Left;
	end
	self.titleDeco_1:setScale(-1, 1, 1);
	self.titleDeco_1:setLocation(-posX, posY, 0);
	self.titleDeco_2:setLocation(posX, posY, 0);
end

function Lua_Window:createBtnClose(posX, posY, posZ, atlas, sprite)
	if self.btnClose == nil then
		self.btnClose = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
		self.btnClose.name = "btnClose";
		self.btnClose.siblingIndex = 3;
		self.btnClose:resetSize();
		self.btnClose:addClickFuntion(self, self.onBtnCloseClick);
	end
	self.btnClose:setAltas(atlas, sprite)
	self.btnClose:setLocation(posX, posY, posZ);
end

function Lua_Window:createCloseTips(posX, posY, posZ)
	if self.closeText == nil then
		self.closeText = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_button_015", 0, 0, 0, 0);
		self.closeText.name = "closeImgTip";
	end
	self.closeText:setLocation(posX, posY, posZ);
end

function Lua_Window:createBackBtn(posX, posY, atlas, sprite)
	if self.backBtn == nil then
		posX = posX or 62.5;
		posY = posY or 53.5;
		atlas = atlas or "common_altas_1";
		sprite = sprite or "xui_common_button_026";
		self.backBtn = UICreate.createUIAtlasImage(self.content, atlas, sprite, posX, posY, 0, 0);
		self.backBtn.name = "backBtn";
		self.backBtn.anchorValue = 6;
		self.backBtn:addClickFuntion(self, self.onBackBtnClick);
	end
end

function Lua_Window:onMaskClick(go)
	if self.isClickClose == true then
		self:hide();
	end
end

function Lua_Window:onWinBgClick(go)
	
end

function Lua_Window:onBtnCloseClick(go)
	self:hide();
end

function Lua_Window:onBackBtnClick(go)
	self:hide();
end

function Lua_Window:showWin(param)
	self.showData = param;
end

function Lua_Window:hide()
	Lua_WindowUtil.openWin(self.windowName, Lua_WinParam.ACTION_CLOSE);
end

function Lua_Window:resetActive(bActive)
	local bChange = false;
	if self.bActive ~= bActive then
		bChange = true;
		if self.content ~= nil then
			self.content:SetActive(bActive);
		end
		if self.maskBg ~= nil then
			self.maskBg:setEnable(bActive);
		end
		if self.blurImg ~= nil then
			self.blurImg:setEnable(bActive);
		end
	end

	self.bActive = bActive;
	-- self:updateShowPos();
	if bActive == true then
		self:showWinScene();
		-- if self.isSingleShowWin == true then
		-- 	WindowMananger.getInstance():hideWinsToBackStage(self.windowName);
		-- end
	else
		self:hideWinScene();
	end
	self:updateChatIcon(bActive)
	self:checkWinBgShow();

	if bChange and self.skinBuilded then
		Lua_WindowUtil.winActiveState.windowName = self.windowName;
		Lua_WindowUtil.winActiveState.state = bActive;
		Lua_MsgUtil.callFunc("WIN_ACTIVE_CHANGE", Lua_WindowUtil.winActiveState);
	end
end

-- 不要手动执行这个方法实现内部对象的适配，会导致多次迭代器循环查找刷新panel，并且panel有对DragContainer和DragList修改高度的话，会造成二次重绘
function Lua_Window:onScreenResize()
	local screenOffsetH = GlobalVar.screenOffsetTopH + GlobalVar.screenOffsetBottomH;
	self.width = MainWinDefine.V_width;
	self.height = MainWinDefine.V_height - screenOffsetH;
	self.adaptHeight = MainWinDefine.V_height - MainWinDefine.DEFAULT_SHOW_HEIGHT - screenOffsetH;

	self:updateShowPos();

	if self.rectTf ~= nil then
		LuaUtil.setRectSize(self.rectTf, self.width, self.height);
	end

	if self.blurImg ~= nil then
		self.blurImg:SetDimensions(self.width, self.height);
	end

	for _, v in pairs(self) do
		if type(v) == "table" and v.onScreenResize ~= nil then
			v:onScreenResize(self.adaptHeight);
		end
	end
end

function Lua_Window:updateShowPos()
	local offsetY = -(GlobalVar.screenOffsetTopH / 2) + (GlobalVar.screenOffsetBottomH / 2);
	if self.content ~= nil then
		LuaUtil.setObjPos(self.content, 0, offsetY, 0);
	end
	-- if self.bActive == true then
	-- 	if self.content ~= nil then
	-- 		LuaUtil.setObjPos(self.content, 0, offsetY, 0);
	-- 	end
	-- 	if self.maskBg ~= nil then
	-- 		self.maskBg:setLocation(0, 0, 0);
	-- 	end
	-- 	if self.blurImg ~= nil then
	-- 		self.blurImg:setLocation(0, 0, 0);
	-- 	end
	-- else
	-- 	if self.content ~= nil then
	-- 		LuaUtil.setObjPos(self.content, 2000, offsetY, 0);
	-- 	end
	-- 	if self.maskBg ~= nil then
	-- 		self.maskBg:setLocation(2000, 0, 0);
	-- 	end
	-- 	if self.blurImg ~= nil then
	-- 		self.blurImg:setLocation(2000, 0, 0);
	-- 	end
	-- end
end

function Lua_Window:updateWindowDepth(value, zIndex)
	-- if self.canvas == nil then
	-- 	return;
	-- end
	-- self.canvas.sortingOrder = value;
	if self.zIndex == nil then
		self.zIndex = zIndex;
		self:checkWinBgShow();
	else
		self.zIndex = zIndex;
	end
end

function Lua_Window:setBlackMaskFun(val)
	if self.maskBg ~= nil then
		self.maskBg:setEnable(val);
	end
end

function Lua_Window:setShowData(v)
	if self.bActive == true then
		self:showWinScene();
	end
	
	if self.skinBuilded == true or Lua_Window.frameBuild == false then
		self:doShowWin();
		-- if self.isSingleShowWin == true then
		-- 	WindowMananger.getInstance():hideWinsToBackStage(self.windowName);
		-- 	print("Lua_Window:setShowData", self.windowName);
		-- end
	else
		self.delayShowWin = true;
	end
end

function Lua_Window:doShowWin()
	self.delayShowWin = false;
	self.bInitComplete = true;
	if self.windowName == DataCenter.loginData.waitInitedWinName then
		DataCenter.loginData:completeEnterGame();
	end
    local l = Lua_WindowUtil.getWinListData(self.windowName, true);
    if l == nil then
    	-- self:showWin(nil);
    else
    	local len = l:getSize()
        for i = 1, len do
            self:showWin(l[i]);
        end
    end

    self:updateChatIcon(self.bActive)
	if self.bActive then
		if self.windowObj ~= nil then
			DataCenter.winTweenManager:createWinTween(self.windowName, self.windowObj.transform);
		end
		Lua_MsgUtil.callFunc("WIN_SHOW_COMPLETE", self.windowName);
		self:checkWinGuide();-- 引导数据检测
	end
end

function Lua_Window:setWinSceneId(sceneId)
	if self.winSceneId == sceneId then
		return;
	end

	self.winSceneId = sceneId;
	if self.bActive == true then
		self:showWinScene();
	end
end

function Lua_Window:showWinScene()
	if self.winSceneId > 0 and Scene3DManager.instance.curShowSceneId ~= self.winSceneId then
		Scene3DManager.instance:OpenSceneBySceneId(self.winSceneId, 0, self, self.onShoWinwScene, self.onWinSceneLoaded);
	end
end

function Lua_Window:hideWinScene()
	if self.winSceneId > 0 then
		-- Scene3DManager.instance:hideScene(self.winSceneId, 0);
		Scene3DManager.instance:removeCallBack(self.winSceneId, 0, self);
	end
end

function Lua_Window:onShoWinwScene(sceneId)
    if sceneId == self.winSceneId then
        
    end
end

function Lua_Window:onWinSceneLoaded(sceneId)
	if sceneId == self.winSceneId then
        
    end
end

function Lua_Window:updateChatIcon(state)
	if DataCenter.chatData then
		DataCenter.chatData:checkChatIconStateByWinName(self.windowName, state);
	end
end

-- 背景加载完成
function Lua_Window:onWinBgLoaded()
	self:checkWinBgShow();
end

function Lua_Window:checkWinBgShow()
	if strIsNullOrEmpty(self.windowName) or self.zIndex == nil then
		return;
	end

	local bWinbgShow = false;
	if self.isDispose_3 or not self.isFullPaving or not self.bActive then
		bWinbgShow = false;
	else
		if self.winBg == nil or not self.winBg.isActive or not self.winBg.bLoadedState then
			bWinbgShow = false;
		else
			bWinbgShow = true;
		end
	end

	if self.showWinBgComplete ~= bWinbgShow then
		self.showWinBgComplete = bWinbgShow;
		-- MsgUtil.callFunc("WINDOW_FullPAVING_WINBG_SHOW", self.zIndex);
		MsgUtil.callFunc("WINDOW_FullPAVING_WINBG_SHOW", self.windowName);
	end
end

function Lua_Window:onCheckWinGuiding(winName)
	if winName ~= nil and winName == self.windowName then
		self:checkWinGuide();
	end
end

-- 检测引导数据
function Lua_Window:checkWinGuide()
	if strIsNullOrEmpty(self.windowName) then
		return;
	end

	local guideId, info = DataCenter.guideCommonData:getWinGuideData(self.windowName);
	if info ~= nil then
		self:updateGuide(guideId, info);
	end
end

-- 引导同步
function Lua_Window:updateGuide(guideId, info)
	
end

function Lua_Window:dispose()
	if self.preLoadArr ~= nil then
		self.preLoadArr:dispose();
		self.preLoadArr:clear();
		self.preLoadArr = nil;
	end

	if self.maskBg ~= nil then
		self.maskBg:dispose();
		self.maskBg = nil;
	end

	if self.winSceneId > 0 then
		if self.windowName == "Lua_MainLineWindow" then
			Scene3DManager.instance:removeCallBack(self.winSceneId, 0, self);
			Scene3DManager.instance:hideScene(self.winSceneId, 0);
		else
			Scene3DManager.instance:destroyScene(self.winSceneId, 0);
		end
		self.winSceneId = 0;
	end

	if self.showData ~= nil then
		if type(self.showData) == "table" and self.showData.modelScenePanel ~= nil then
			self.showData.modelScenePanel:dispose();
			self.showData.modelScenePanel = nil;
		end
		self.showData = nil;
	end
	
	Lua_WindowUtil.clearWinData(self.windowName)
	Lua_MsgUtil.clearDelayFuns(self.windowName);
	DataCenter.winTweenManager:removeWinTween(self.windowName);
	Lua_CommonUtil.removeTimer(self, self.onBuildingItem);
	DataCenter.popupWinManager:removeDataByName(self.windowName)
	self:updateChatIcon(false)
	self:superCall("dispose");

	self.mgr = nil;
	self.rectTf = nil;
	self.canvas = nil;
	self.conTable = nil;
	if self.skinTable ~= nil then
		for i, v in ipairs(self.skinTable) do
			self[v.name] = nil;
		end
		self.skinTable = nil;
	end
	
	self.winBg = nil;
	self.titleBg = nil;
	self.titleName = nil;
	self.titleDeco_1 = nil;
	self.titleDeco_2 = nil;
	self.btnClose = nil;
	self.backBtn = nil;
	self.closeText = nil;

	if self.isDispose_3 ~= true then
		self.isDispose_3 = true;
		if self.content ~= nil and IsNil(self.content) == false then
			UnityEngine.GameObject.Destroy(self.content);
			self.content = nil;
		end

		if self.windowObj ~= nil and IsNil(self.windowObj) == false then
			UnityEngine.GameObject.Destroy(self.windowObj);
			self.windowObj = nil;
		end
	end
end