local version_time = "version_time";
DataCenter = nil;
local isInit = false;
NotiConst = nil;
function initDebug()
    --local breakInfoFun, xpcallFun = require("LuaDebug")("localhost", 7003);
end

function getLuaVersion()
    return "1.0.0.230804001"; -- 主版本.子版本.阶段版本.日期版本
end

function getCVersion() 
    if c_version == nil then
        c_version = tonumber(tostring(LanUtil.getValue(578)));
    end
    return c_version;
end

function getVersionStr()
    return version .. "." .. version_time;
end

-- 包号
function getPackNum()
    if DataCenter.roleData ~= nil and DataCenter.roleData.market > 0 then
        return DataCenter.roleData.market;
    end
    if market == nil then
        market = ServerConfig.market;
    end
    return market;
end

-- 渠道
function getChannelName()
    if channel == nil then
        channel = ServerConfig.channel;
    end
    return channel;
end

function initReflection()
    if DataCenter.initReflection == nil then
        DataCenter.initReflection = 1;
        require "tolua.reflection";
        tolua.loadassembly("Assembly-CSharp");
        tolua.loadassembly("mscorlib");
        if CommonUtil.isApplePlatform == false and CommonUtil.isGooglePlatform64 == false then
            if not Lua_PlatformUtil.IsWindowsEditor() or GlobalVar.luaDecodeType == 2 then
                tolua.loadassembly("work");
            end
        end
        local BindingFlags = require 'System.Reflection.BindingFlags'
    end
end

function initDefRequire()
    checkRequire("Time");
    checkRequire("coroutine");
    checkRequire("Array");
    checkRequire("ProtoPublic_pb");
    checkRequire("Lua_EventOwner");
    checkRequire("Lua_DisplayObject");
    checkRequire("Lua_Window");
    checkRequire("Lua_ColorDefine");
    checkRequire("Lua_AxisDefine");
    checkRequire("Lua_WinParam");
    checkRequire("Lua_WindowUtil");
    checkRequire("Lua_PlatformUtil");
    checkRequire("Lua_CommonUtil");
    checkRequire("Lua_BitOperation");
    checkRequire("Lua_TimeTransform");
    -- checkRequire("Lua_SocketManager");
    checkRequire("Lua_LoadFileType");
    checkRequire("Lua_DragContainer");
    checkRequire("Lua_DragList");
    checkRequire("Lua_ProxyManager");
    checkRequire("Lua_Rectangle");
    checkRequire("uilang");
    checkRequire("Lua_StringArray");
    checkRequire("Lua_SDKInterface");
    checkRequire("Lua_GameFindObjUtil");
    checkRequire("Lua_BezierUtils");
end

function initLua()
    initDefRequire()
    DataCenter = {};
    DataCenter.gcSetPauseVal = 200;
    DataCenter.bConfigLoaded = false;
    DataCenter.bCameraDragRange = false;
    DataCenter.sdkInterface = Lua_SDKInterface.new();
    DataCenter.gameFindObjUtil = Lua_GameFindObjUtil.new();
    LuaUtil.setSceneDataExtendVal("FurEffShow", false);

    -- window层级
    Lua_MainWinDefine =
    {
        BASE_LAYER = MainWinDefine.BASE_LAYER; -- 主菜单层 500
        NEW_TIPS_LAYER = MainWinDefine.NEW_TIPS_LAYER; -- 智能提示层 1000
        MAIN_WINDOW_LAYER = MainWinDefine.MAIN_WINDOW_LAYER; -- 低于主菜单栏之下窗口层 1500
        MAIN_MENU_LAYER = MainWinDefine.MAIN_MENU_LAYER; -- 主菜单栏窗口层 2500
        MAIN_MENU_TOP_LAYER = MainWinDefine.MAIN_MENU_TOP_LAYER; -- 高于主菜单栏窗口层 3500
        NORMAL_WINDOW_LAYER = MainWinDefine.NORMAL_WINDOW_LAYER; -- 一级窗口层 4500
        NORMAL_TOP_LAYER = MainWinDefine.NORMAL_TOP_LAYER; -- 二级窗口层 5500
        TIPS_WINDOW_LAYER = MainWinDefine.TIPS_WINDOW_LAYER; -- 提示窗口 6500
        GUIDE_WINDOW_LAYER = MainWinDefine.GUIDE_WINDOW_LAYER; -- 引导窗口 7000
        MAX_TOP_LAYER = MainWinDefine.MAX_TOP_LAYER; -- 最顶层窗口 7500
        MASK_LAYER = MainWinDefine.MASK_LAYER; -- 遮罩层 8500
    };

    -- Lua_SocketManager.getInstace():init();
    Lua_ColorDefine.initColor();
    Lua_ProxyManager.initProxy();
    initComponentStyle();
    isInit = true;
end

function initComponentStyle()
    -- C#已添加 这里方便查看
    -- UICreate.addStyle(1, "4287582499", "xui_common_button_006_n", "xui_common_button_006_n"); -- 8F5123
    -- UICreate.addStyle(2, "4284504917", "xui_common_toggle_001_b", "xui_common_toggle_001_f"); -- 605B55
    -- UICreate.addStyle(3, "4285882704", "xui_common_button_007_n", "xui_common_button_007_n"); -- 756150
    UICreate.addStyle(14, "4287582499", "xui_common_button_010", "xui_common_button_010"); -- 8F5123
    UICreate.addStyle(15, "4286212702", "xui_common_button_020", "xui_common_button_020"); -- 7A6A5E
    UICreate.addStyle(16, "4285229931", "xui_common_button_006_d", "xui_common_button_006_d"); -- 6B6B6B
    UICreate.addStyle(17, "4287582499", "xui_common_button_004_n", "xui_common_button_004_n"); -- 8F5123
    UICreate.addStyle(18, "4285882704", "xui_common_button_005_n", "xui_common_button_005_n"); -- 756150
    UICreate.addStyle(19, "4285882704", "xui_lxg_toggle_1_b", "xui_lxg_toggle_1_f"); -- 756150
    UICreate.setStyleUIAtlas(19, "common_altas_4");
    UICreate.addStyle(20, "4287582499", "xui_common_button_027_n", "xui_common_button_027_n"); -- 8F5123
    UICreate.setStyleUIAtlas(20, "common_altas_3");
    UICreate.addStyle(21, "4294967295", "xui_yxjj_xui_tipsprogress_1_b", "xui_yxjj_xui_tipsprogress_1_f"); -- FFFFFF
    UICreate.setStyleUIAtlas(21, "activities_atlas_2");
    UICreate.addStyle(22, "4285098345", "xui_common_button_028", "xui_common_button_028"); -- 696969
    UICreate.setStyleUIAtlas(22, "common_altas_3");
    UICreate.addStyle(23, "4285229931", "xui_common_button_027_d", "xui_common_button_027_d"); -- 6B6B6B
    UICreate.setStyleUIAtlas(23, "common_altas_3");

    UICreate.addStyle(4, "4287323700", "ui_common_button_006_n", "ui_common_button_006_n"); -- 8B5E34
    UICreate.addStyle(5, "4287323700", "xui_common_button_006_n", "xui_common_button_006_n"); -- 8F5123
    UICreate.addStyle(6, "4286151033", "ui_common_button_008_d", "ui_common_button_008_d"); -- 797979
    UICreate.addStyle(7, "4286212703", "xui_common_button_007_n", "xui_common_button_007_n"); -- 756150
    UICreate.addStyle(8, "4286867025", "ui_yxsd_toggle_001_f", "ui_yxsd_toggle_001_b"); -- 846651
    UICreate.addStyle(9, "4286867025", "ui_djc_toggle_001_b", "ui_djc_toggle_001_f"); -- 846651
    UICreate.addStyle(10, "4286212703", "ui_common_button_044_n", "ui_common_button_044_n"); -- 7A6A5F
    UICreate.addStyle(11, "4282204751", "ui_common_button_042_n", "ui_common_button_042_n"); -- 3D424F
    UICreate.addStyle(12, "4286867025", "ui_common_toggle_003_b", "ui_common_toggle_003_f"); -- 846651
    UICreate.addStyle(13, "4282204751", "ui_common_button_055_n", "ui_common_button_055_n"); -- 3D424F
end

function addLuaWindow()
    initLua();
end

function setWindowTable(winName)
    local c = checkRequire(winName);
    local win = c.new();
    win.windowName = winName;
    WindowMananger.getInstance():setWinTable(winName, win);
end

function openWin(winName, win, winRoot)
    if win ~= nil then
        win:buildPanel(winRoot);
    end
end

function closeWin(winName)
    if strIsNullOrEmpty(winName) then return; end
    Lua_WindowUtil.clearWinData(winName);
    Lua_MsgUtil.callFunc("Win_Close", winName);
end

-- local aaa = 0;
-- function onEnterFrame()
--     if isInit ~= true then
--         return;
--     end

--     DataCenter.frameStartTime = getTime();
--     Lua_CommonUtil.frameScript();
--     Lua_MsgUtil.checkRemoveEvent();
--     if DataCenter.frameStartTime - aaa > 30 then
--         aaa = DataCenter.frameStartTime;
--         LuaGC();
--     end
-- end

local gcTime = 0;
local gcIntervalTime = 600;
local isGc = false;
function onMonoLateUpdate()
    if isInit ~= true then
        return;
    end

    DataCenter.audioManager:frameScript()
    if DataCenter.mainLinePreViewController ~= nil then
         DataCenter.mainLinePreViewController:frameScript();
    end
    
    local canGC = true;
    if DataCenter.mainLineCamActController ~= nil then -- 主线镜头动画不执行gc
        canGC = not DataCenter.mainLineCamActController:frameScript();
    end
    if isGc and canGC then
        if DataCenter.loginData ~= nil and DataCenter.loginData.tweeningState then -- 执行动画时不GC
            canGC = false;
        elseif DataCenter.crackShotData ~= nil and DataCenter.crackShotData.isCrackShotTween then -- 百发百中时不GC
            canGC = false;
        end
    end
    
    if isGc and not canGC then
        isGc = false;
        gcTime = DataCenter.frameStartTime + gcIntervalTime;
        collectgarbage("collect");
        collectgarbage("setpause", DataCenter.gcSetPauseVal); -- 进入游戏场景后是100，其他200
        collectgarbage("setstepmul", 5000);
        LanUtil.systemGcCollect();
        LoadManager.getInstance():clearResource();

        -- -- local c = collectgarbage("count")
        -- -- print("回收前collectgarbage count = " .. c.. " kb");
        -- if collectgarbage("step", 256) == true then
        --     isGc = false;
        --     gcTime = DataCenter.frameStartTime + gcIntervalTime;
        --     -- c = collectgarbage("count")
        --     -- print("回收后collectgarbage count = " .. c.. " kb");
        -- end
    else
        if DataCenter.frameStartTime > gcTime then
            isGc = true;
        end
    end    

    Lua_MsgUtil.checkRemoveEvent();
    Lua_CommonUtil.lateUpdateFrame();
end

function onEnterFrame()
    if isInit ~= true then
        return;
    end

    DataCenter.frameStartTime = getTime();
    Lua_CommonUtil.frameScript();
    if DataCenter.effectManager ~= nil then
        DataCenter.effectManager:playCollectedEffect();
    end
end

function sendMsg(msgid, msg, socketType)
    -- if msg ~= nil then
    --     local pb_data = msg:SerializeToString();
    --     ProtolBuffer.data = pb_data;
    -- end
    -- ProtolBuffer.msgid = msgid;
    -- if socketType == nil then
    --     socketType = Lua_Connection.MAIN_SOCKET;
    -- end
    -- LuaUtil.sendSocket(socketType);
    if DataCenter == nil or DataCenter.connectionManager == nil then
        return;
    end
    DataCenter.connectionManager:sendSocket(msgid, msg, socketType);
end

function checkMsgListener(msgid)
    return Lua_MsgUtil.checkMsgListener(msgid);
end

function receiveMsg(mp)
    return Lua_MsgUtil.receiveMsg(mp);
end

function clearLua(bReconnect)
    if bReconnect ~= true then
        if DataCenter.bConfigLoaded then
            PlayerData.instance.data.sceneId = 0;
            CameraControl.Instance:SetFollowTarget(nil);
            ThingUtil.instance:removeAll(0);
            Scene3DManager.instance:destoryAllScene();
        end
        -- UploadManager.getInstance():dispose();
    end

    Lua_WindowUtil.clearAllWinData();
    if DataCenter ~= nil then
        Lua_CommonUtil.clearAllTimer();
        -- Lua_SocketManager.getInstace():dicconnectAll();
        for k, v in pairs(DataCenter) do
            if type(v) == "table" and v.dispose ~= nil then
                v:dispose(bReconnect);
            end
        end
    end
end