Lua_Rectangle = class("Lua_Rectangle");
function Lua_Rectangle:ctor(x, y, width, height)
	self:Set(x, y, width, height);
end

function Lua_Rectangle:Set(x, y, width, height)
	self.x = x;
	self.y = y;
	self.width = width;
	self.height = height;
end

-- 相交
function Lua_Rectangle:intersects(rect)
	return self.x < rect.x + rect.width and rect.x < self.x + self.width and self.y < rect.y + rect.height and rect.y < self.y + self.height;
end

-- 相交矩形
function Lua_Rectangle:intersectRectangle(rect)
	local rec = Lua_Rectangle.new();
	local x1 = Mathf.Max(self.x, rect.x);
	local x2 = Mathf.Min(self.x + self.width, rect.x + rect.width);
	local y1 = Mathf.Max(self.y, rect.y);
	local y2 = Mathf.Min(self.y + self.height, rect.y + rect.height);
	if x2 >= x1 and y2 >= y1 then
		rec.x = x1;
		rec.y = y1;
		rec.width = x2 - x1;
		rec.height = y2 - y1;
	end
	return rec;
end

function Lua_Rectangle:containPoint(px, py)
	return px >= self.x and px <= self.x + self.width and py >= self.y and py <= self.y + self.height;
end

function Lua_Rectangle:containeRect(rect)
	return self.x <= rect.x and self.x + self.width >= rect.x + rect.width and self.y <= rect.y and self.y + self.height >= rect.y + rect.height;
end

function Lua_Rectangle:toString()
	return "["..self.x..","..self.y..","..self.width..","..self.height.."]";
end