Lua_ColorDefine = { };
Lua_ColorDefine.TYPE_WHITE = 1;
Lua_ColorDefine.TYPE_GREEN = 2;
Lua_ColorDefine.TYPE_BLUE = 3;
Lua_ColorDefine.TYPE_PURPLE = 4;
Lua_ColorDefine.TYPE_ORANGE = 5;
Lua_ColorDefine.TYPE_RED = 6;

function Lua_ColorDefine.initColor()
    Lua_ColorDefine.maxAlpha = tonumber("FF000000", 16);

    -- 白
    Lua_ColorDefine.WHITE = Lua_ColorDefine.transColor("9D9D9D");
    -- 绿
    Lua_ColorDefine.GREEN = Lua_ColorDefine.transColor("479154");
    -- 蓝
    Lua_ColorDefine.BLUE = Lua_ColorDefine.transColor("179FC9");
    -- 紫
    Lua_ColorDefine.PURPLE = Lua_ColorDefine.transColor("C714B6");
    -- 橙
    Lua_ColorDefine.ORANGE = Lua_ColorDefine.transColor("F8C013");
    -- 红
    Lua_ColorDefine.RED = Lua_ColorDefine.transColor("ED4C30");

    -- 白
    Lua_ColorDefine.WHITE_2 = Lua_ColorDefine.transColor("C1C4C9");
    -- 绿
    Lua_ColorDefine.GREEN_2 = Lua_ColorDefine.transColor("63BD7D");
    -- 蓝
    Lua_ColorDefine.BLUE_2 = Lua_ColorDefine.transColor("96ECFD");
    -- 紫
    Lua_ColorDefine.PURPLE_2 = Lua_ColorDefine.transColor("D180F6");
    -- 橙
    Lua_ColorDefine.ORANGE_2 = Lua_ColorDefine.transColor("F8EF8A");
    -- 红
    Lua_ColorDefine.RED_2 = Lua_ColorDefine.transColor("F09080");

    -- 白
    Lua_ColorDefine.WHITE_STR = "9D9D9D";
    -- 绿
    Lua_ColorDefine.GREEN_STR = "479154";
    -- 蓝
    Lua_ColorDefine.BLUE_STR = "179FC9";
    -- 紫
    Lua_ColorDefine.PURPLE_STR = "C714B6";
    -- 橙
    Lua_ColorDefine.ORANGE_STR = "F8C013";
    -- 红
    Lua_ColorDefine.RED_STR = "ED4C30";

    -- 白
    Lua_ColorDefine.WHITE_STR_2 = "C1C4C9";
    -- 绿
    Lua_ColorDefine.GREEN_STR_2 = "63BD7D";
    -- 蓝
    Lua_ColorDefine.BLUE_STR_2 = "96ECFD";
    -- 紫
    Lua_ColorDefine.PURPLE_STR_2 = "D180F6";
    -- 橙
    Lua_ColorDefine.ORANGE_STR_2 = "F8EF8A";
    -- 红
    Lua_ColorDefine.RED_STR_2 = "F09080";
end

function Lua_ColorDefine.transColorStr(color, alpha)
    return tostring(Lua_ColorDefine.transColor(color, alpha));
end

function Lua_ColorDefine.transColor(color, alpha)
    local alphaVal = Mathf.Ceil(Lua_ColorDefine.maxAlpha * (alpha == nil and 1 or alpha));
    local colorVal = tonumber(color, 16)
    return alphaVal + colorVal;
end

function Lua_ColorDefine.getColorStr(color, str)
    return string.format("%s%s%s%s%s", "<color=#", color, ">", str, "</color>")
end

function Lua_ColorDefine.getColorName(colorType)
    return LanUtil.getValue(109000 + colorType - 1);
end

function Lua_ColorDefine.getItemColor(colorType, dark)
    if colorType == 2 then
        if dark == true then
            return Lua_ColorDefine.GREEN_2;
        else
            return Lua_ColorDefine.GREEN;
        end
    elseif colorType == 3 then
        if dark == true then
            return Lua_ColorDefine.BLUE_2;
        else
            return Lua_ColorDefine.BLUE;
        end
    elseif colorType == 4 then
        if dark == true then
            return Lua_ColorDefine.PURPLE_2;
        else
            return Lua_ColorDefine.PURPLE;
        end
    elseif colorType == 5 then
        if dark == true then
            return Lua_ColorDefine.ORANGE_2;
        else
            return Lua_ColorDefine.ORANGE;
        end
    elseif colorType == 6 then
        if dark == true then
            return Lua_ColorDefine.RED_2;
        else
            return Lua_ColorDefine.RED;
        end
    end
    if dark == true then
        return Lua_ColorDefine.WHITE_2;
    else
        return Lua_ColorDefine.WHITE;
    end
end

--道具品质色 dark 默认 fase
function Lua_ColorDefine.getItemColorStr(colorType, dark)
    if colorType == 2 then
        if dark == true then
            return Lua_ColorDefine.GREEN_STR_2;
        else
            return Lua_ColorDefine.GREEN_STR;
        end
    elseif colorType == 3 then
        if dark == true then
            return Lua_ColorDefine.BLUE_STR_2;
        else
            return Lua_ColorDefine.BLUE_STR;
        end
    elseif colorType == 4 then
        if dark == true then
            return Lua_ColorDefine.PURPLE_STR_2;
        else
            return Lua_ColorDefine.PURPLE_STR;
        end
    elseif colorType == 5 then
        if dark == true then
            return Lua_ColorDefine.ORANGE_STR_2;
        else
            return Lua_ColorDefine.ORANGE_STR;
        end
    elseif colorType == 6 then
        if dark == true then
            return Lua_ColorDefine.RED_STR_2;
        else
            return Lua_ColorDefine.RED_STR;
        end
    end
    if dark == true then
        return Lua_ColorDefine.WHITE_STR_2;
    else
        return Lua_ColorDefine.WHITE_STR;
    end
end

-- 广播道具色值
function Lua_ColorDefine.getBroadcastColorStr(colorType)
    if colorType == 2 then
        return "459252";
    elseif colorType == 3 then
        return "159EC5";
    elseif colorType == 4 then
        return "C616B7";
    elseif colorType == 5 then
        return "DE6D29";
    elseif colorType == 6 then
        return "E01B1B";
    end
    return "FFFFFF";
end