-- 获得英雄展示界面
Lua_GuideHeroShowWindow = class("Lua_GuideHeroShowWindow", Lua_Window);
function Lua_GuideHeroShowWindow:ctor()
	self:superCall("ctor");

	self.skinName = "GuideHeroShowWindow_skin";
	self.windowName = "Lua_GuideHeroShowWindow";
	self.isFullSizeWin = true;
	self.isFullSizeBg = true
	self.showWinBg = true;
	self.isClickClose = false;
	self.showBlackMask = false;
	self.winBgPath = "/images/recruit/ui_xmb_bg_03.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_GuideHeroShowWindow:dispose()
	if self.roleImage ~= nil then
		self.roleImage:dispose();
		self.roleImage = nil;
	end

	self:superCall("dispose");
end

function Lua_GuideHeroShowWindow:buildShowItem()
	self:superCall("buildShowItem");

end

function Lua_GuideHeroShowWindow:onWinBgClick(go)
	self:hide();
end

function Lua_GuideHeroShowWindow:showWin(param)
	self:superCall("showWin", param);
	if param == nil then 
		self:hide();
		return;
	end

	local cfg = Lua_HeroConfigData.getConfig(param);
	if cfg == nil then
		self:hide();
		return;
	end

	local url = cfg.uiModelUrl;
	local modelName = cfg.uiModelAvatarName;
	if strIsNullOrEmpty(modelName) or strIsNullOrEmpty(url) then
		self:hide();
		return;
	end

	self.roleImage = UICreate.createModelEffImg(self.content, url, modelName, 0, 0, 900, 900);
	self.roleImage:setCamField(1.3, 1, 100, true);
	self.roleImage:setCamPos(0, 3.1, -10);
	self.roleImage:setModelEffDir(180);
	self.roleImage:setCamRot(12, 0, 0);
	self.roleImage:showLight();
	self.roleImage.canRot = true;
	self.roleImage.name = "roleImage";
end