-- 引导回顾界面
Lua_GuideReviewWindow = class("Lua_GuideReviewWindow", Lua_Window);
function Lua_GuideReviewWindow:ctor()
    self:superCall("ctor");
    
    self.showBlackMask = true;
	self.layer = MainWinDefine.GUIDE_WINDOW_LAYER;
	self.windowName = "Lua_GuideReviewWindow";
	self.skinName = "GuidReviewWindow_skin";
	self.blackAlpha = 0.01;
	self.maskSprite = "black_mask";
end

function Lua_GuideReviewWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end

	DataCenter.guideUtil.reviewWinParam.guideId = nil;
	DataCenter.guideUtil.reviewWinParam.guideStep = nil;
	Lua_MsgUtil.callFunc("GuideReviewWindow_Close");
	self:superCall("dispose");
end

function Lua_GuideReviewWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.closeBtn:addClickFuntion(self, self.onBtnCloseClick);
	self:showDialogInfo();
end

function Lua_GuideReviewWindow:showDialogInfo()
	local guideId = DataCenter.guideUtil.reviewWinParam.guideId;
	local step = DataCenter.guideUtil.reviewWinParam.guideStep;
	if guideId == nil or guideId <= 0 or step == nil or step <= 0 then
		self:hide();
		return;
	end

	local num = 0;
	local arr = nil;
	while (num < step) do
		num = num + 1;
		local cfg = DataCenter.guideUtil:getGuideStepCfg(guideId, num);
		if cfg == nil then
			break;
		end

		if not strIsNullOrEmpty(cfg.dialogContent) then
			if (cfg.isNarrator ~= nil and cfg.isNarrator == 1) 
				or (cfg.isUseRoleName ~= nil and cfg.isUseRoleName == 1) 
				or not strIsNullOrEmpty(cfg.dialogTitle) then
				if arr == nil then arr = Array(); end
				arr:add(cfg);
			end
		end
	end

	if arr == nil or arr:getSize() <= 0 then
		self:hide();
		return;
	end

	if self.dragContainer == nil then
		self.dragContainer = Lua_DragContainer.new(self.content, 634, 960, Lua_AxisDefine.Vertical);
		self.dragContainer:setLocation(0, 17, 0);
	end

	self.dragContainer:clearList();
	local len = arr:getSize();
	for i = 1, len do
		local cfg = arr[i];
		if cfg.isNarrator ~= nil and cfg.isNarrator == 1 then
			self.dragContainer:addSubContainer(Lua_GuideReviewNarratorCell, cfg, false);
		else
			self.dragContainer:addSubContainer(Lua_GuideReviewCell, cfg, false);
		end
	end
	self.dragContainer:updateChildPos();
	self.dragContainer:moveToIndex(1, true);
end

































Lua_GuideReviewCell = class("Lua_GuideReviewCell", Lua_DragContainerItem);
function Lua_GuideReviewCell:ctor(p)
    self:superCall("ctor", p, "GuideReviewCell_skin");
end

function Lua_GuideReviewCell:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_GuideReviewCell:dispose()
    self:superCall("dispose");
end

function Lua_GuideReviewCell:setData(cfg)
	if cfg.isUseRoleName ~= nil and cfg.isUseRoleName == 1 then
		self.titleTxt.text = DataCenter.roleData.name;
		self.desTxt.text = LanUtil.formateStr(cfg.dialogContent, DataCenter.roleData.name);
	else
		self.titleTxt.text = cfg.dialogTitle;
		self.desTxt.text = cfg.dialogContent;
	end

	self.desTxt:resetSize();
end

function Lua_GuideReviewCell:getWidth()
    return 634;
end

function Lua_GuideReviewCell:getHeight()
    return self.desTxt.height + 50;
end













Lua_GuideReviewNarratorCell = class("Lua_GuideReviewNarratorCell", Lua_DragContainerItem);
function Lua_GuideReviewNarratorCell:ctor(p)
    self:superCall("ctor", p, "GuideReviewNarratorCell_skin");
end

function Lua_GuideReviewNarratorCell:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_GuideReviewNarratorCell:dispose()
    self:superCall("dispose");
end

function Lua_GuideReviewNarratorCell:setData(cfg)
	self.desTxt.text = cfg.dialogContent;
	self.desTxt:resetSize();
end

function Lua_GuideReviewNarratorCell:getWidth()
    return 634;
end

function Lua_GuideReviewNarratorCell:getHeight()
    return self.desTxt.height + 60;
end