-- 引导界面
checkRequire("Lua_GuideVo");
checkRequire("Lua_GuideButtonState");
checkRequire("Lua_GuideBearTipPanel");
checkRequire("Lua_GuideImgDialogPanel");
checkRequire("Lua_GuideModelEffDialogPanel");
Lua_GuideWindow = class("Lua_GuideWindow", Lua_Window);
function Lua_GuideWindow:ctor()
    self:superCall("ctor");
    
    self.isFullSizeWin = true;
    self.skinName = "GuideWindow_skin";
	self.blackAlpha = 0.01;
	self.maskSprite = "black_mask";
	self.showClose = false;
	self.showBlackMask = true;
	self.layer = MainWinDefine.GUIDE_WINDOW_LAYER;
	self.windowName = "Lua_GuideWindow";
	self.curGuideId = 0;
	self.curGuideStep = 0;
	self.playSpeed = 1;
	self.isAutoNextStep = false;
	self.findTargetSign = 0;
	self.guideData = DataCenter.guideData;
	self.guideCommonData = DataCenter.guideCommonData;
	self.stepCheckConditionTime = 0;
	self.stepResidueTime = 0;
	self.testPlayTime = 0;
	self.bCheckTolerateErr = true; -- 是否容错
	self:clearTolerateErrData();
end

function Lua_GuideWindow:dispose()
	self.cameraViewHandle = nil;
	if self.btnTabState ~= nil then
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Skip]:dispose();
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Review]:dispose();
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Hide]:dispose();
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Auto]:dispose();
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Skip] = nil;
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Review] = nil;
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Hide] = nil;
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Auto] = nil;
		self.btnTabState = nil;
	end

	if self.winBg ~= nil then self.winBg:clearTween(); end
	if self.maskBg ~= nil then self.maskBg:clearTween(); end
	if self.blurImg ~= nil then self.blurImg:clearTween(); end
	if self.templateTweenName ~= nil then
		DataCenter.winTweenManager:removeWinTween(self.templateTweenName);
	end

	self:clearTimer();
	self.curGuideVo = nil;
	self.templateType = nil;
	if self.templatePanel ~= nil then
		self.templatePanel:dispose();
		self.templatePanel = nil;
	end

	if self.clickObjEff ~= nil then
		self.clickObjEff:dispose();
		self.clickObjEff = nil;
	end

	if self.findTargetSign > 0 then
		DataCenter.gameFindObjUtil:removeFind(self.findTargetSign);
		self.findTargetSign = 0;
	end

	self.guideData.curGuideId = 0;
	DataCenter.chatData:playEnterBroadcast();
    DataCenter.popupWinManager:checkPopupWin();
    self.guideCommonData:syncPopupWins(nil);
    self.guideCommonData:syncWinGuideData(0, 0, nil, nil);

    
	self.bStopGuide = nil;
    self.guideData = nil;
	self.guideCommonData = nil;
	self:clearTolerateErrData();
	self:superCall("dispose");
end

function Lua_GuideWindow:buildPanel(go)
	self:superCall("buildPanel", go);

end

function Lua_GuideWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.autoBtnRotCircleTime = DataCenter.guideUtil.autoBtnRotCircleTime;
	self.autoBtnRotTime = 0;
	self.bAutoPlay = DataCenter.guideData.bAutoPlay;
	self.bHideState = false;

	self.btnTabState = {};
	self.btnTabState[Lua_GuideDefine.GuideWin_Button_Skip] = Lua_GuideButtonState.new(Lua_GuideDefine.GuideWin_Button_Skip, self.skipBtn);
	self.btnTabState[Lua_GuideDefine.GuideWin_Button_Review] = Lua_GuideButtonState.new(Lua_GuideDefine.GuideWin_Button_Review, self.reviewBtn);
	self.btnTabState[Lua_GuideDefine.GuideWin_Button_Hide] = Lua_GuideButtonState.new(Lua_GuideDefine.GuideWin_Button_Hide, self.hideBtn);
	self.btnTabState[Lua_GuideDefine.GuideWin_Button_Auto] = Lua_GuideButtonState.new(Lua_GuideDefine.GuideWin_Button_Auto, self.autoBtn, self.autoTxt);
	self.reviewBtn:addClickFuntion(self, self.onReviewBtnClick);
	self.hideBtn:addClickFuntion(self, self.onHideBtnClick);
	self.autoBtn:addClickFuntion(self, self.onAutoBtnClick);
	self.skipBtn:addClickFuntion(self, self.onSkipBtnClick);
	if self.maskBg ~= nil then self.maskBg.clickScale = false; end
	if self.blurImg ~= nil then self.blurImg.clickScale = false; end
	if self.btnSpr ~= nil then LuaUtil.setRectSize(self.btnSpr, self.width, self.height); end

	self:addLuaEvent("GuideReviewWindow_Close", self, self.onGuideReviewWindowClose);
	self:addLuaEvent("Guide_Condition_Update", self, self.onConditonUpdate);
	self:addLuaEvent("Guide_WinSync_Complete", self, self.onWinSyncGuide); -- 界面同步给引导的数据
	self:addLuaEvent("Guide_Skip_CurGuiding", self, self.onSkipBtnClick);
	-- self:addLuaEvent("Guide_WinLoading_Open", self, self.onOpenWhenLoadingWin); -- 当加载窗口时，打开引导窗口阻挡 
end

-- 正式跑引导前，事先运行逐字播放-初始化，防止乱码
function Lua_GuideWindow:beforeTxt(scaleDelayTime)
	if self.testPlayTime <= 1 then
		local playTime = 1;
		if self.examplerTxt == nil then
			self.examplerTxt = UICreate.createLabel(self.content, "***", 0, 0, 10, 10, 34);
			self.examplerTxt.name = "examplerTxt";
			self.examplerTxtLen = self.examplerTxt.showTextLen;
		end

		self.testPlayTime = self.testPlayTime + scaleDelayTime
		local rate = self.testPlayTime / playTime;
		local num = Mathf.Floor(rate  * self.examplerTxtLen);
		if num < self.examplerTxtLen then
			self.examplerTxt:setTextShowIndex(num);
		else
			local content = self.examplerTxt.text;
			self.examplerTxt.text = nil;
			self.examplerTxt.text = content;
		end
	else
		if self.examplerTxt ~= nil then
			self.examplerTxt:dispose();
			self.examplerTxt = nil;
		end
	end
end

function Lua_GuideWindow:onGuideReviewWindowClose()
	if self.bHideState then
		self.bHideState = false;
		self:chechHideState();
	end
end

-- 引导条件更新
function Lua_GuideWindow:onConditonUpdate(conditionType)
	if self.curGuideStepVo == nil then
		return;
	end

	-- 检测该步骤可以继续执行的条件
	local changeState = self.curGuideStepVo:checkConditon(conditionType);
	-- print("Lua_GuideWindow onConditonUpdate", conditionType, self.bStopGuide, changeState)
	if self.bStopGuide then
		return;
	end

	if conditionType == Lua_GuideDefine.Trigger_Condition_OpenWin then -- 界面
		if not self.guideCommonData:checkPopupWinGuiding() then -- 非弹框引导
			self.bStopGuide = true;
			self.windowObj:SetActive(false);
			-- print("onConditonUpdate 非弹框引导");
			return;
		end
	end

	if changeState == -1 then -- 重置该引导
		self.bResetStepVo = true;
		self.isAutoNextStep = false;

		local step = (self.curGuideStepVo.config.repeatStepId - 1) or 0;
		self.curGuideStep = step;
		self.bRepeatStep = true;
	end

	if changeState == 2 or changeState == 3 then
		if self.curGuideStepVo.isCompleteEvent then -- -- 已完成，不响应点击事件
			if self.curGuideStepVo.isCompleteConditionsNext then -- 完成，执行下一步
				-- print("1111 self.bResetStepVo 完成执行下一步");
				self.bResetStepVo = true;
				self.isAutoNextStep = false;
				return;
			elseif self.maskObj ~= nil then
				self.maskObj.bHandleTarget = false;
			end
		end
	end

	if changeState == 1 or changeState == 3 then
		if self.curGuideStepVo.canOperate then -- 操作达到
			-- print("引导条件更新 onConditonUpdate initGuideStep", conditionType);
			self:initGuideStep();
		end
	end
end

-- 界面处理完成同步
function Lua_GuideWindow:onWinSyncGuide(gid)
	if gid ~= self.curGuideId then
		return;
	end

	local winGuideResult = self.guideCommonData.winGuideResult;
	if winGuideResult ~= nil then
		if winGuideResult == 1 then -- 完成
			-- print("2222 self.bResetStepVo 完成执行下一步");
			self.bResetStepVo = true;
			self.isAutoNextStep = false;
			return;
		elseif winGuideResult == -1 then -- 失败
			-- print("3333 self.bResetStepVo 完成执行下一步");
			self.bResetStepVo = true;
			self.isAutoNextStep = false;
			return;
		end
	end

	-- 隐藏点击特效 
	if self.guideCommonData.hideGuideEffect then
		self:hideTemplateAndBg();
		return;
	end

	-- 找到目标
	if self.guideCommonData.guideClickObjTarget ~= nil then
		self:startTolerateErr();
		self:completeWinSync(self.guideCommonData.guideClickObjTarget, nil, nil, nil, nil, self.guideCommonData.guideClickObjMaskParams);
		return;
	end

	-- 找到目标路径
	if not strIsNullOrEmpty(self.guideCommonData.guideClickObjPath) then
		local sceneId = self.guideCommonData.guideSceneId;
		local clickObjWin = self.guideCommonData.curGuideWinName;
		local clickObjPath = self.guideCommonData.guideClickObjPath;
		self.guideCommonData.curGuideWinName = nil;
		local config = self.curGuideStepVo.config;
		local clickObjMaskType = config.clickObjMaskType;
		if clickObjMaskType ~= Lua_GuideDefine.GuideWin_MaskObj_Circle 
			and clickObjMaskType ~= Lua_GuideDefine.GuideWin_MaskObj_Rectangle 
			and clickObjMaskType ~= Lua_GuideDefine.GuideWin_MaskObj_CircleRectangle then
			clickObjMaskType = nil;
		end

		if clickObjMaskType ~= nil then -- 遮罩需要查找
			self:findTarget(config, sceneId, clickObjWin, clickObjPath);
			if self.findTargetSign <= 0 or DataCenter.gameFindObjUtil:bFindedTarget(self.findTargetSign) then
				self:onFindTargetComplete(self.findTargetSign);
			else
				self:hideTemplateAndBg();
			end
			return;
		end

		local posType = (clickObjPos ~= nil and #clickObjPos > 0) and clickObjPos[1] or 2;
		if posType == 2 then
			local showHandEff = config.showHandEff;
			if showHandEff ~= nil and showHandEff == 1 then -- 手势需要查找
				self:findTarget(config, sceneId, clickObjWin, clickObjPath);
				if self.findTargetSign <= 0 or DataCenter.gameFindObjUtil:bFindedTarget(self.findTargetSign) then
					self:onFindTargetComplete(self.findTargetSign);
				else
					self:hideTemplateAndBg();
				end
				return;
			end

			local clickObjEffUrl = config.clickObjEffUrl;
			local clickObjEffModelName = config.clickObjEffModelName;
			if not strIsNullOrEmpty(clickObjEffUrl) and not strIsNullOrEmpty(clickObjEffModelName) then -- 特效需要查找
				self:findTarget(config, sceneId, clickObjWin, clickObjPath);
				if self.findTargetSign <= 0 or DataCenter.gameFindObjUtil:bFindedTarget(self.findTargetSign) then
					self:onFindTargetComplete(self.findTargetSign);
				else
					self:hideTemplateAndBg();
				end
				return;
			end
		end

		self.findTargetSign = 0;
		self:onFindTargetComplete(self.findTargetSign);
		return;
	end

	-- 找到目标定位
	local px = self.guideCommonData.guideClickObjPosX;
	local py = self.guideCommonData.guideClickObjPosY;
	if px ~= nil and py ~= nil then
		local w = self.guideCommonData.guideClickObjWidth;
		local h = self.guideCommonData.guideClickObjHeight;
		w = (w == nil or w < 0) and 0 or w;
		h = (h == nil or h < 0) and 0 or h;
		self:completeWinSync(nil, px, py, w, h, self.guideCommonData.guideClickObjMaskParams);
		return;
	end
end

function Lua_GuideWindow:onScreenResize()
	self:superCall("onScreenResize");
	if self.btnSpr ~= nil then
		LuaUtil.setRectSize(self.btnSpr, self.width, self.height);
	end

	if self.maskObj ~= nil then
		local offsetY = -(GlobalVar.screenOffsetTopH / 2) + (GlobalVar.screenOffsetBottomH / 2);
		self.maskObj:setLocation(0, -offsetY);
		self.maskObj:SetDimensions(MainWinDefine.bgWidth, MainWinDefine.bgHeight);
	end
end

function Lua_GuideWindow:showWin(param)
	self:superCall("showWin", param);
	
	if param == nil then 
		self:hide();
		return;
	end

	self.bAutoPlay = DataCenter.guideData.bAutoPlay;
	self.guideCommonData:syncGuideStep(nil);
	self.guideCommonData:syncWinGuideData(nil, nil);
	if type(param) == "table" then -- 原则上用于测试
		self.isTestGuide = true;
		self.curGuideId = param.guideId;
		self.guideData.curGuideId = self.curGuideId;
		self.curGuideVo = Lua_GuideVo.new(self.curGuideId);
		if self.curGuideVo == nil then
			self:hide();
			return;
		end

		self.intervalTime = -1;
		self.stepResidueTime = 0;
		-- print("3333 self.bResetStepVo 完成执行下一步");
		self.bResetStepVo = true;
		self.curGuideStep = param.guideStep;
		self.guideData.curGuideStep = self.curGuideStep;
		self.curFrameTime = getTime();
		self:frameScript(-1);
		self:printGuideInfo();
		-- print("1self.curGuideId = ", self.curGuideId, self.curGuideStep);
		if not self.bAddGuideTime then
			self.bAddGuideTime = true;
	        Lua_CommonUtil.addTimer("frameScript", 0.01, self, self.frameScript);
		end
	else
		-- 播放当前引导
		self.isTestGuide = false;
		self.curGuideId = param;
		self.guideData.curGuideId = self.curGuideId;
		self.curGuideVo = self.guideData.curGuideVo;
		if self.curGuideVo == nil then
			-- print("showWin self.curGuideVo == nil", self.curGuideId);
			self:hide();
			return;
		end

		self.intervalTime = -1;
		self.stepResidueTime = 0;
		-- print("4444 self.bResetStepVo 完成执行下一步");
		self.bResetStepVo = true;
		self.curGuideStep = self.guideData:getGuidePlayedStep();
		self.guideData.curGuideStep = self.curGuideStep;
		self.curFrameTime = getTime();
		self:frameScript(-1);
		self:printGuideInfo();
		-- print("2self.curGuideId = ", self.curGuideId, self.curGuideStep);
		if not self.bAddGuideTime then
			self.bAddGuideTime = true;
	        Lua_CommonUtil.addTimer("frameScript", 0.01, self, self.frameScript);
		end
	end
end

function Lua_GuideWindow.Get:bStopGuide()
	-- winShowHide
	return self._bStopGuide;
end

function Lua_GuideWindow.Set:bStopGuide(value)
	self._bStopGuide = value;
	if self.guideCommonData ~= nil then
		self.guideCommonData.bStopGuide = value;
	end
end

function Lua_GuideWindow:initGuide()
	-- print("引导初始化，导航栏显示", self.curGuideId, self.curGuideStep)
	-- 引导初始化，导航栏显示
	if self.curGuideStep == nil or self.curGuideStep > 1 then 
		return;
	end

	local config = DataCenter.guideUtil:getGuideCfg(self.curGuideId);
	if config == nil then
		return;
	end

	-- 显示底部导航栏
	if config.showNavigationBar ~= nil and config.showNavigationBar == 1 then
		-- print("引导初始化，导航栏显示 显示底部导航栏")
		DataCenter.mainMenuData:resetNavigationBar(true);
	end
end

function Lua_GuideWindow:onReviewBtnClick()
	if not self.bHideState then
		self.bHideState = true;
		self:chechHideState();
	end

	if DataCenter.guideUtil.reviewWinParam == nil then
		DataCenter.guideUtil.reviewWinParam = {};
	end
	DataCenter.guideUtil.reviewWinParam.guideId = self.curGuideId;
	DataCenter.guideUtil.reviewWinParam.guideStep = self.curGuideStep;
	Lua_WindowUtil.openWin("Lua_GuideReviewWindow", Lua_WinParam.ACTION_OPEN);
	self.isAutoNextStep = false;
	self.bAutoPlay = DataCenter.guideData.bAutoPlay;
end

function Lua_GuideWindow:onHideBtnClick()
	if self.bStopGuide then
		return;
	end

	self.bAutoPlay = DataCenter.guideData.bAutoPlay;
	self.isAutoNextStep = false;
	self.bHideState = not self.bHideState;
	self:chechHideState();
end

function Lua_GuideWindow:chechHideState()
	if self.bStopGuide then
		return;
	end

	self.btnSpr:SetActive(not self.bHideState);
	if self.templatePanel ~= nil and self.templatePanel.showBeautiful ~= nil then
		self.templatePanel:showBeautiful(self.bHideState);
	end
end

function Lua_GuideWindow:onAutoBtnClick()
	if self.bStopGuide then
		return;
	end

	if self.bHideState then -- 实际应该不存在这个情况，按钮都隐藏了
		self.bHideState = false;
		self:chechHideState();
	end

	if self.bResetStepVo then
		return;
	end

	self.isAutoNextStep = false;
	self.bAutoPlay = not self.bAutoPlay;
	DataCenter.guideData.bAutoPlay = self.bAutoPlay;
	if self.bAutoPlay then
		OperateAlert.show("开始自动播放剧情");
		if self.intervalTime == 0 then -- 跳转下一步
			-- print("5555 self.bResetStepVo 完成执行下一步");
			self.bResetStepVo = true;
			-- self.bAutoPlay = false;
		end
	end
end

function Lua_GuideWindow:onSkipBtnClick()
	if self.bStopGuide then
		return;
	end

	if self.bHideState then -- 实际应该不存在这个情况，按钮都隐藏了
		self.bHideState = false;
		self:chechHideState();
	end

	if self.bResetStepVo then
		return;
	end

	if self.curGuideStepVo == nil or self.curGuideStepVo.isEmpty then
		return;
	end

	local btnList = self.curGuideStepVo.config.btnList;
	if btnList ~= nil and #btnList >= 0 then
		local bCanSkip = false;
		for i = 1, #btnList do
			local list = btnList[i];
			if list ~= nil and list[1] == 1 then
				bCanSkip = true;
				break;
			end
		end

		if not bCanSkip then
			return;
		end
	end

	-- 跳过当前引导
	self.bAutoPlay = false;
	self.isAutoNextStep = false;
	-- print("6666 self.bResetStepVo 完成执行下一步", self.curGuideStep);
	self.bResetStepVo = true;
	local skipStep = self.curGuideStepVo.skipStep;
	if skipStep > 0 then
		self.curGuideStep = skipStep;
	else
		self.curGuideStep = DataCenter.guideUtil:getMaxStepByGuideId(self.curGuideId, self.curGuideStep);
	end
	-- 跳过剧情时保存到服务端
	Lua_ProxyManager.getProxy("Lua_GuideProxy"):sSaveGuide(self.curGuideId, self.curGuideStep); 
	self:checkButtonState(nil);
	-- print(self.curGuideId, self.curGuideStep)
end

function Lua_GuideWindow:clearTimer()
	if self.bAddGuideTime then
		self.bAddGuideTime = false;
		Lua_CommonUtil.removeTimer(self, self.frameScript);
	end
end

function Lua_GuideWindow:frameScript(param)
	local t = getTime();
    local dt = (t - self.curFrameTime); -- 等比加速
	local scaleDelayTime = dt * self.playSpeed;
    self.curFrameTime = t;
    self:beforeTxt(scaleDelayTime);

    if not DataCenter.loginData.isEnterGameWorld then -- 未进入游戏场景先不播引导
		return;
	end

	local bTolerateErr = self:checkTolerateErrTime(dt);
	if bTolerateErr then
		-- print("引导卡住终止")
		return;
	end

	local bStartStep = self.bResetStepVo;
	if self.bStopGuide then -- 暂停引导，不执行后续逻辑
		if not self.guideCommonData:checkPopupWinGuiding() then -- 非弹框引导
			self.windowObj:SetActive(Lua_WindowUtil.bLoadingWindow());
			return;
		end

		bStartStep = true;
		self.bStopGuide = false;
		self.windowObj:SetActive(true);
		-- print("暂停引导，不执行后续逻辑", DataCenter.guideCommonData.bOpenGuideAllowPopupWin);
	end

	if self.bHideState then
		-- 无需暂停文字播放
		if self.templatePanel ~= nil and self.templatePanel.frameScript ~= nil then
			self.templatePanel:frameScript(dt, scaleDelayTime);
		end
		return;
	end

	if self.bResetStepVo then -- 重置步骤vo
		self.bAutoPlay = DataCenter.guideData.bAutoPlay;
		DataCenter.guideCommonData.antiRepeatClick = nil;
		self.guideData:syncGuideStep(self.curGuideId, self.curGuideStep, self.isTestGuide, self.bRepeatStep); -- 同步给服务端
		self.bRepeatStep = false;

		self.bResetStepVo = false;
		self.curGuideStep = self.curGuideStep + 1;
		self.guideData.curGuideStep = self.curGuideStep;
		if self.curGuideStepVo == nil then
			self.curGuideStepVo = Lua_GuideStepVo.new(self.curGuideId, self.curGuideStep);
		else
			self.curGuideStepVo:reset(self.curGuideId, self.curGuideStep);
		end
		if self.maskObj ~= nil then
			self.maskObj:clearTarget();
		end
		self:showMaskSp(true); -- 步骤重置，弹窗之前先将遮罩显示出来
		self:clearTolerateErrData();

		-- 检测弹框
		self.stepCheckConditionTime = 0;
		-- print("引导进程", self.curGuideId, self.curGuideStep);
		self.guideCommonData:syncGuideStep(self.curGuideStepVo, param ~= nil and param == -1);
		if self.curGuideStepVo.canPopupWin then
			DataCenter.popupWinManager:checkPopupWin();-- 检测是否有弹框需要弹
		end
		if not self.curGuideStepVo.isEmpty then
			-- self:checkMaskState(self.curGuideStepVo.config); -- 背景遮罩
			self.curGuideStepVo:checkConditon();
			if not self.curGuideStepVo.isEmpty then
				local completeConditionsNext = self.curGuideStepVo.config.completeConditionsNext;
				if completeConditionsNext == 1 then
					if not self.curGuideStepVo.isCompleteEvent then
						self.stepCheckConditionTime = self.curGuideStepVo.checkConditionTime;
					end
				elseif completeConditionsNext == 2 then
					if not self.curGuideStepVo.canOperate then
						self.stepCheckConditionTime = self.curGuideStepVo.checkConditionTime;
					elseif not self.curGuideStepVo.isCompleteEvent then
						local operateConditions = self.curGuideStepVo.config.operateConditions;
						if operateConditions == nil or #operateConditions <= 0 then
							self.stepCheckConditionTime = self.curGuideStepVo.checkConditionTime;
						end
					end
				end
			end

			-- if not self.curGuideStepVo.canOperate or not self.curGuideStepVo.isCompleteEvent then
			-- 	self.stepCheckConditionTime = self.curGuideStepVo.checkConditionTime;
			-- end
		end

		if not self.guideCommonData:checkPopupWinGuiding() then -- 非弹框引导
			self.bStopGuide = true;
			self.windowObj:SetActive(Lua_WindowUtil.bLoadingWindow());
			if self.templatePanel ~= nil then
				self.templatePanel:setEnable(false);
			end
			if self.clickObjEff ~= nil then
				self.clickObjEff:setEnable(false);
			end
			if self.winBg ~= nil then 
				self.winBg:setEnable(false); 
			end
			self:checkButtonState();
			-- print("frameScript 非弹框引导");
			return;
		end
	end

	if self.curGuideStepVo == nil or self.curGuideStepVo.isEmpty then -- 结束
		DataCenter.guideCommonData:setInheritWindowName(nil);
		self:checkButtonState(nil); -- 结束时，按钮隐藏
		local nextGuideId;
		if not self.isTestGuide then 
			nextGuideId = DataCenter.guideUtil:getGuideNextId(self.curGuideId);
		end
		self.guideData.curGuideId = 0;
		self.guideData:checkPlayGuide(nextGuideId);
		if not self.isDispose_3 and self.guideData.curGuideId <= 0 then
			self:hide();
		end		
		return;
	end

	self:rotAutoBtn(dt); -- 自动按钮旋转
	local config = self.curGuideStepVo.config;
	if not bStartStep and self.stepCheckConditionTime > 0 then -- 步骤条件超时检测
		self.stepCheckConditionTime = self.stepCheckConditionTime - dt;
		if self.stepCheckConditionTime <= 0 then
			self.stepCheckConditionTime = 0;
			self:onConditonUpdate(nil); -- 再检测一次
			local completeConditionsNext = config.completeConditionsNext;
			if completeConditionsNext == 1 then
				if not self.curGuideStepVo.isCompleteEvent then
					-- print("7777 self.bResetStepVo 完成执行下一步");
					self.bResetStepVo = true;
					self.isAutoNextStep = false;
				end
			elseif completeConditionsNext == 2 then
				if not self.curGuideStepVo.canOperate then
					-- print("8888 self.bResetStepVo 完成执行下一步");
					self.bResetStepVo = true;
					self.isAutoNextStep = false;
				elseif not self.curGuideStepVo.isCompleteEvent then
					local operateConditions = self.curGuideStepVo.config.operateConditions;
					if operateConditions == nil or #operateConditions <= 0 then
						-- print("9999 self.bResetStepVo 完成执行下一步");
						self.bResetStepVo = true;
						self.isAutoNextStep = false;
					end
				end
			end
			return;
		end
	end
	
	if bStartStep then -- 初始化
		self.playSpeed = 1;
		self.intervalTime = -1;
		self:initGuide();
		self:printGuideInfo();
		if self.curGuideStepVo.isCompleteEvent and self.curGuideStepVo.isCompleteConditionsNext then -- 完成执行下一步
			-- print("frameScript 完成执行下一步");
			-- print("1010 self.bResetStepVo 完成执行下一步");
			self.bResetStepVo = true;
			self.isAutoNextStep = false;
			self.stepResidueTime = 0;
			self:initGuideStep();
		else
			if self.findTargetSign > 0 then
				DataCenter.gameFindObjUtil:removeFind(self.findTargetSign);
				self.findTargetSign = 0;
			end

			if self.curGuideStepVo.needCheckTimeOut then
				self.stepResidueTime = DataCenter.guideUtil.guideStepSkipOverTime;
			else
				self.stepResidueTime = 0;
			end
			-- print("self.curGuideStepVo.canOperate = ", self.curGuideStepVo.canOperate)
			if self.curGuideStepVo.canOperate then -- 操作达到
				-- print("操作达到 initGuideStep", self.curGuideStepVo.canOperate);
				self:initGuideStep();
			else
				self:checkButtonState(nil);
				self:hideTemplateAndBg();
			end
		end
	else
		-- 按钮状态更新
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Skip]:frameScript(dt, scaleDelayTime);
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Review]:frameScript(dt, scaleDelayTime);
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Hide]:frameScript(dt, scaleDelayTime);
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Auto]:frameScript(dt, scaleDelayTime);

		-- 模板更新
		if self.templatePanel ~= nil and self.templatePanel.frameScript ~= nil then
			self.templatePanel:frameScript(dt, scaleDelayTime);
		end

		if self.intervalTime > 0 then
			self.intervalTime = self.intervalTime - scaleDelayTime;
			if self.intervalTime <= 0 then -- 下一步
				self.intervalTime = 0;
				if self.bAutoPlay or self.isAutoNextStep then
					-- print("1212 self.bResetStepVo 完成执行下一步");
					self.bResetStepVo = true;
					self.isAutoNextStep = false;
				end
			end
		end

		-- 超时未完成该步骤则显示跳过按钮
		-- local bFindedTarget = self.maskObj ~= nil and self.maskObj.bGetTarget;
		if self.stepResidueTime > 0 then
			-- print("步骤检测时长self.stepResidueTime", self.stepResidueTime)
			self.stepResidueTime = self.stepResidueTime - dt;		
			if self.stepResidueTime <= 0 then
				-- print("步骤检测显示按钮")
				self.btnTabState[Lua_GuideDefine.GuideWin_Button_Skip]:immediatelyShowBtn();
			end
		end
	end
end

-- 引导步骤衔接遮罩
function Lua_GuideWindow:showMaskSp(bShow)
	if bShow then
		if self.maskBg == nil then 
			self.maskBg = UICreate.createUIAtlasImage(self.windowObj, "common_altas_1", self.maskSprite, 0, 0, 2048, 2048);
			self.maskBg.name = "maskBg";
			self.maskBg.siblingIndex = 0;
			self.maskBg:addClickFuntion(self, self.onMaskClick);
			self.maskBg.clickScale = false;
		end
		self.maskBg.alpha = 0.01;
		self.maskBg:setEnable(true);
	else
		if self.maskBg ~= nil then
			self.maskBg:setEnable(false);
		end
	end
end

function Lua_GuideWindow:hideTemplateAndBg()
	if self.maskObj ~= nil then
		self.maskObj:setEnable(false);
	end
	if self.templatePanel ~= nil then
		self.templatePanel:setEnable(false);
	end
	if self.clickObjEff ~= nil then
		self.clickObjEff:setEnable(false);
	end
	if self.winBg ~= nil then 
		self.winBg:clearTexture();
		self.winBg:setEnable(false); 
	end
end

-- 更新场景相机参数
function Lua_GuideWindow:initSceneCam(config)
	if config == nil then
		return;
	end

	local camPanAngle = config.camPanAngle;
	local camTitleAngle = config.camTitleAngle;
	local camDistance = config.camDistance;
	local camLookAt = config.camLookAt;
	if camPanAngle ~= nil or camTitleAngle ~= nil or camDistance ~= nil or (camLookAt ~= nil and #camLookAt >= 3) then
		if self.cameraViewHandle == nil then
			self.cameraViewHandle = CameraControl.Instance.cameraViewHandle;
		end

		camPanAngle = camPanAngle ~= nil and camPanAngle or self.cameraViewHandle.currentPanAngle;
		camTitleAngle = camTitleAngle ~= nil and camTitleAngle or self.cameraViewHandle.currentTiltAngle;
		camDistance = camDistance ~= nil and camDistance or self.cameraViewHandle.currentDistance;
		-- print("initSceneCam", camPanAngle, camTitleAngle, camDistance);
		self.cameraViewHandle:rotCamTo(camPanAngle, camTitleAngle, camDistance);
		if camLookAt ~= nil and #camLookAt >= 3 then
			self.cameraViewHandle:updateLookAtY(camLookAt[1], camLookAt[2], camLookAt[3]);
		end
		MsgUtil.callFunc("CAM_ANGLECHANGE_SYNCMAPCLICKWIN");
	end
end

-- 查找目标对象
function Lua_GuideWindow:findTarget(config, sceneId, clickObjWin, clickObjPath)
	local delayCheckTime = DataCenter.guideUtil:getWinTweenTime(clickObjWin);
	if config.clickObjDelayCheck ~= nil then -- 遮罩定位延迟时间
		delayCheckTime = delayCheckTime + (config.clickObjDelayCheck / 1000);
	end

	self:startTolerateErr();

	-- print("delayCheckTime = ", delayCheckTime, clickObjWin);
	if sceneId ~= nil then
		local fightId = 0;
		if sceneId <= 0 then -- 查找当前
			sceneId = DataCenter.sceneData.openSceneId;
			fightId = DataCenter.fightData.curPlayFightRecordId;
		end
		self.findTargetSign = DataCenter.gameFindObjUtil:findSceneObject(sceneId, fightId, clickObjPath, nil, delayCheckTime <= 0, DataCenter.guideUtil.findObjLimitTime, delayCheckTime, self, self.onFindTargetComplete);
	else
		self.findTargetSign = DataCenter.gameFindObjUtil:findWinObject(clickObjWin, clickObjPath, nil, delayCheckTime <= 0, DataCenter.guideUtil.findObjLimitTime, delayCheckTime, self, self.onFindTargetComplete);
	end
end

-- 初始化步骤显示
function Lua_GuideWindow:initGuideStep()
	if self.curGuideStepVo == nil then
		return;
	end

	local config = self.curGuideStepVo.config;
	if config == nil then
		return;
	end
	
	-- 抛出步骤事件
	if config.eventName ~= nil then
		Lua_MsgUtil.callFunc(config.eventName);
	end

	-- 更新场景相机参数
	self:initSceneCam(config);
	self:checkMaskState(config); -- 背景遮罩
	self.guideCommonData:resetAllowPopupWinsState();
	if self.bResetStepVo then
		return;
	end

	local completeConditionsNext = config.completeConditionsNext;
	if completeConditionsNext == 2 then
		if self.curGuideStepVo.canOperate then -- 满足条件则继续步骤
			local operateConditions = self.curGuideStepVo.config.operateConditions;
			if operateConditions ~= nil and #operateConditions > 0 then
				self.stepCheckConditionTime = 0;
			end
		end
	end

	-- 需要同步界面，等界面数据返回再执行
	if config.syncWinInfo ~= nil and not strIsNullOrEmpty(config.syncWinInfo.winName) then
		local info = config.syncWinInfo.data;
		local winName = self.guideCommonData.inheritWindowName or config.syncWinInfo.winName; -- inheritWindowName继承后的窗口名
		self.guideCommonData:syncWinGuideData(winName, info);
		Lua_MsgUtil.callFunc("Guide_SyncWin_GuideData", winName);
		return;
	end

	local sceneId = config.sceneId;
	local clickObjWin = config.clickObjWin;
	local clickObjPath = config.clickObjPath;
	if (not strIsNullOrEmpty(clickObjWin) or sceneId ~= nil) and not strIsNullOrEmpty(clickObjPath) then
		local clickObjMaskType = config.clickObjMaskType;
		if clickObjMaskType ~= Lua_GuideDefine.GuideWin_MaskObj_Circle 
			and clickObjMaskType ~= Lua_GuideDefine.GuideWin_MaskObj_Rectangle 
			and clickObjMaskType ~= Lua_GuideDefine.GuideWin_MaskObj_CircleRectangle then
			clickObjMaskType = nil;
		end

		if clickObjMaskType ~= nil then -- 遮罩需要查找
			self:findTarget(config, sceneId, clickObjWin, clickObjPath);
			if self.findTargetSign <= 0 or DataCenter.gameFindObjUtil:bFindedTarget(self.findTargetSign) then
				self:onFindTargetComplete(self.findTargetSign);
			else
				self:hideTemplateAndBg();
			end
			return;
		end

		local posType = (clickObjPos ~= nil and #clickObjPos > 0) and clickObjPos[1] or 2;
		if posType == 2 then
			local showHandEff = config.showHandEff;
			if showHandEff ~= nil and showHandEff == 1 then -- 手势需要查找
				self:findTarget(config, sceneId, clickObjWin, clickObjPath);
				if self.findTargetSign <= 0 or DataCenter.gameFindObjUtil:bFindedTarget(self.findTargetSign) then
					self:onFindTargetComplete(self.findTargetSign);
				else
					self:hideTemplateAndBg();
				end
				return;
			end

			local clickObjEffUrl = config.clickObjEffUrl;
			local clickObjEffModelName = config.clickObjEffModelName;
			if not strIsNullOrEmpty(clickObjEffUrl) and not strIsNullOrEmpty(clickObjEffModelName) then -- 特效需要查找
				self:findTarget(config, sceneId, clickObjWin, clickObjPath);
				if self.findTargetSign <= 0 or DataCenter.gameFindObjUtil:bFindedTarget(self.findTargetSign) then
					self:onFindTargetComplete(self.findTargetSign);
				else
					self:hideTemplateAndBg();
				end
				return;
			end
		end
	end
	
	-- 无需对象获取，t=0
	self.findTargetSign = 0;
	self:onFindTargetComplete(self.findTargetSign);
end

-- 找到目标对象
function Lua_GuideWindow:onFindTargetComplete(t)
	-- print("onFindTargetComplete", t, self.findTargetSign, DataCenter.gameFindObjUtil:bFindedTarget(self.findTargetSign));
	if self.curGuideStepVo == nil then
		return;
	end

	local config = self.curGuideStepVo.config;
	if config == nil then
		return;
	end

	local bShowMaskObj = self:checkMaskObjState(config, nil, nil, nil, nil, nil, self.guideCommonData.guideClickObjMaskParams);-- 选择框
	self:checkBgState(config) -- 检测背景
	self:checkButtonState(config);-- 按钮状态检测
	self:createContentTemplate(config.contentTemplate, config.contentTweenClassName);
	-- print("onFindTargetComplete", bShowMaskObj, self.maskObj ~= nil, self.maskObj ~= nil and self.maskObj.isShrinkEnd or "null");
	if not bShowMaskObj or (self.maskObj ~= nil and self.maskObj.isShrinkEnd) then
		self:checkClickObjEffAndHandEff(config, bShowMaskObj); -- 挖空区域特效和手势
	else
		if self.clickObjEff ~= nil then
			self.clickObjEff:setEnable(false);
		end
	end
	
	self.guideCommonData:syncWinGuideData(nil, nil);
	self.intervalTime = (config.stepCountTime == nil) and 0 or (config.stepCountTime / 1000);
	self.isAutoNextStep = (config.isAutoNextStep ~= nil) and (config.isAutoNextStep == 1) or false;
	if self.isAutoNextStep then self.bAutoPlay = true; end
	DataCenter.gameFindObjUtil:removeFind(self.findTargetSign);
	self.findTargetSign = 0;
end

-- 界面数据完成同步
function Lua_GuideWindow:completeWinSync(target, px, py, w, h, maskParams)
	if target == nil and (px == nil or py == nil or w == nil or h == nil) then
		return;
	end

	if self.curGuideStepVo == nil then
		return;
	end

	local config = self.curGuideStepVo.config;
	if config == nil then
		return;
	end
	
	local bShowMaskObj = self:checkMaskObjState(config, target, px, py, w, h, maskParams); -- 选择框
	self:checkBgState(config); -- 检测背景
	self:checkButtonState(config);-- 按钮状态检测
	self:createContentTemplate(config.contentTemplate, config.contentTweenClassName);
	if not bShowMaskObj or (self.maskObj ~= nil and self.maskObj.isShrinkEnd) then
		self:checkClickObjEffAndHandEff(config, bShowMaskObj, target, px, py, w, h); -- 挖空区域特效和手势
	else
		if self.clickObjEff ~= nil then
			self.clickObjEff:setEnable(false);
		end
	end
	
	self.intervalTime = (config.stepCountTime == nil) and 0 or (config.stepCountTime / 1000);
	self.isAutoNextStep = (config.isAutoNextStep ~= nil) and (config.isAutoNextStep == 1) or false;
	if self.isAutoNextStep then self.bAutoPlay = true; end
	self.guideCommonData:syncWinGuideData(nil, nil);
end

-- 选择框
function Lua_GuideWindow:checkMaskObjState(config, target, px, py, w, h, maskClickParam)
	local clickObjMaskType = config.clickObjMaskType;
	if clickObjMaskType ~= Lua_GuideDefine.GuideWin_MaskObj_Circle 
		and clickObjMaskType ~= Lua_GuideDefine.GuideWin_MaskObj_Rectangle 
		and clickObjMaskType ~= Lua_GuideDefine.GuideWin_MaskObj_CircleRectangle then
		clickObjMaskType = nil;
	end

	if clickObjMaskType == nil then
		if self.maskObj ~= nil then 
			self.maskObj:setEnable(false);
		end
		return false;
	end

	local clickObjWin = config.clickObjWin;
	local clickObjPath = config.clickObjPath;
	local clickObjPos = config.clickObjPos;
	local clickObjSize = config.clickObjSize;
	if strIsNullOrEmpty(clickObjWin) 
		and strIsNullOrEmpty(clickObjPath) 
		and strIsNullOrEmpty(self.guideCommonData.guideClickObjPath)
		and (clickObjSize == nil or #clickObjSize <= 0)
		and target == nil
		and (px == nil or py == nil or w == nil or h == nil) then
		if self.maskObj ~= nil then 
			self.maskObj:setEnable(false);
		end
		return false;
	end

	if self.maskObj == nil then
		local offsetY = -(GlobalVar.screenOffsetTopH / 2) + (GlobalVar.screenOffsetBottomH / 2);
		self.maskObj = UICreate.createMask(self.content, 0, -offsetY, MainWinDefine.bgWidth, MainWinDefine.bgHeight);
		self.maskObj:addShrinkCallBack(self, self.onShrinkComplete, self.onShrinkFail);
		self.maskObj:addSelectedCall(self, self.onMaskObjSelected);
		-- self.maskObj:addInitCallBack(self, self.onMaskObjInit);
		self.maskObj:addClickFuntion(self, self.onMaskObjClick);
		self.maskObj.siblingIndex = 0;
	else
		self.maskObj:setEnable(true);
	end

	self.maskObj.mTypeValue = clickObjMaskType;
	-- print("config.clickObjPressType = ", config.clickObjPressType)
	if config.clickObjPressType ~= nil then
		if config.clickObjPressType ~= 2 and config.clickObjPressType ~= 3 then
			self.maskObj.bTargetCanPress = true;
			-- print("2222config.clickObjPressType = ", self.maskObj.bTargetCanPress)
		else
			self.maskObj.bTargetCanPress = false;
			-- print("3333config.clickObjPressType = ", self.maskObj.bTargetCanPress)
		end
		if config.clickObjPressType == 0 or config.clickObjPressType == 2 then
			self.maskObj.bTargetCanLongPress = true;
		else
			self.maskObj.bTargetCanLongPress = false;
		end
	else
		self.maskObj.bTargetCanPress = true;
		self.maskObj.bTargetCanLongPress = false;
	end
	local posType = (clickObjPos ~= nil and #clickObjPos > 0) and clickObjPos[1] or 2;
	local rx = (clickObjPos ~= nil and #clickObjPos > 1) and clickObjPos[2] or 0;
	local ry = (clickObjPos ~= nil and #clickObjPos > 2) and clickObjPos[3] or 0;
	local rw = (clickObjSize ~= nil and #clickObjSize > 0) and clickObjSize[1] or 0;
	local rh = (clickObjSize ~= nil and #clickObjSize > 1) and clickObjSize[2] or rw;
	local angle = (clickObjSize ~= nil and #clickObjSize > 2) and clickObjSize[3] or 0;
	if maskClickParam ~= nil then
		posType = maskClickParam.posType or posType;
		rx = maskClickParam.posX or rx;
		ry = maskClickParam.posY or ry;
		angle = maskClickParam.angle or angle;
	end

	local maskObjBHandleTarget;
	if config.openPathId then
		maskObjBHandleTarget = false;
	else
		maskObjBHandleTarget = not self.curGuideStepVo.isCompleteEvent;
	end

	if self.findTargetSign ~= nil and self.findTargetSign > 0 then
		-- print("setTargetFindInfo self.curGuideStepVo.isCompleteEvent = ", self.curGuideStepVo.isCompleteEvent)
		self.maskObj:setTargetFindInfo(self.findTargetSign, posType, rx, ry, rw, rh, maskObjBHandleTarget);
		if not self:checkObjInBound() then -- 超范围重新执行该步骤
			return;
		end
	else
		if px == nil then px = 0; end 
		if py == nil then py = 0; end 
		if w == nil then w = 0; end 
		if h == nil then h = 0; end 
		px = px + rx;
		py = py + ry;
		w = w + rw;
		h = h + rh;

		-- print("target",  target.name, self.maskObj, target, posType, px, py, w, h, maskObjBHandleTarget)
		self.maskObj:setTarget(target, posType, px, py, w, h, maskObjBHandleTarget);
		if not self:checkObjInBound() then -- 超范围重新执行该步骤
			return;
		end
	end
	local clickObjMaskAlpha = config.clickObjMaskAlpha; -- 透明度
	if clickObjMaskAlpha ~= nil then
		self.maskObj.alpha = clickObjMaskAlpha;
	end

	self.maskObj.rotAngle = angle;
	local clickObjMaskShrink = config.clickObjMaskShrink; -- 动画表现
	if clickObjMaskShrink ~= nil and #clickObjMaskShrink > 1 then
		local t = clickObjMaskShrink[1];	
		local w = clickObjMaskShrink[2];
		local h = #clickObjMaskShrink > 2 and clickObjMaskShrink[3] or w;
		self.maskObj:setShrinkValue(t, w, h);
	end
	return true;
end

-- 背景遮罩
function Lua_GuideWindow:checkMaskState(config)
	local mask = nil;
	local maskType = config.maskType;
	if self.maskBg ~= nil then self.maskBg:clearTween(); end
	if self.blurImg ~= nil then self.blurImg:clearTween(); end
	if maskType == Lua_GuideDefine.GuideWin_Mask_Blur then -- 模糊遮罩
		if self.maskBg ~= nil then self.maskBg:setEnable(false); end
		if self.blurImg == nil then
			self.blurImg = UICreate.createScreenShotBlurImg(self.windowObj, 0, 0, 0, 0);
			self.blurImg.name = "blurImg";
			self.blurImg.siblingIndex = 0;
			self.blurImg:addClickFuntion(self, self.onMaskClick);
			self.blurImg.clickScale = false;
		else
			self.blurImg:setEnable(true);
		end
		mask = self.blurImg;
	elseif maskType == Lua_GuideDefine.GuideWin_Mask_Black then -- 黑色遮罩
		if self.blurImg ~= nil then self.blurImg:setEnable(false); end
		if self.maskBg == nil then
			self.maskBg = UICreate.createUIAtlasImage(self.windowObj, "common_altas_1", self.maskSprite, 0, 0, 2048, 2048);
			self.maskBg.name = "maskBg";
			self.maskBg.siblingIndex = 0;
			self.maskBg:addClickFuntion(self, self.onMaskClick);
			self.maskBg.clickScale = false;
		else
			self.maskBg:setEnable(true);
		end
		mask = self.maskBg;
	else -- 都不显示
		if self.maskBg ~= nil then self.maskBg:setEnable(false); end
		if self.blurImg ~= nil then self.blurImg:setEnable(false); end
	end

	if mask ~= nil then
		local maskAlpha = config.maskAlpha;
		local startAlpha = (maskAlpha ~= nil and #maskAlpha > 0) and maskAlpha[1] or nil;
		local endAlpha = (maskAlpha ~= nil and #maskAlpha > 1) and maskAlpha[2] or nil;
		if startAlpha == nil and endAlpha == nil then
			mask.alpha = 1;
		elseif endAlpha == nil then
			mask.alpha = startAlpha;
		else
			mask.alpha = startAlpha
			if startAlpha ~= endAlpha then -- 过渡动画
				local t = (maskAlpha ~= nil and #maskAlpha > 2) and maskAlpha[3] or DataCenter.guideUtil.maskAlphaTime;
				TweenUtil.getInstance():addTweenTargetAlpha(mask.mainContent, t, 0, endAlpha - startAlpha, false);
			end
		end 
	end
end

-- 检测背景
function Lua_GuideWindow:checkBgState(config)
	local bgUrl = config.bgUrl;
	if strIsNullOrEmpty(bgUrl) then
		if self.winBg ~= nil then 
			self.winBg:clearTexture();
			self.winBg:setEnable(false); 
		end
	else
		if self.winBg == nil then
			self.winBg = UICreate.createImage(self.content, bgUrl, 0, 0, 0, 0);
			-- self.winBg.resetBgSize = true;
			self.winBg.siblingIndex = 0;
			self.winBg.clickScale = false;
			self.winBg:addClickFuntion(self, self.onMaskClick);
		else
			self.winBg:setEnable(true);
			if self.winBg.url ~= bgUrl then
				self.winBg:SetDimensions(0, 0);
			end
			self.winBg:setUrl(bgUrl);
		end

		local bgAlpha = config.bgAlpha;
		local startAlpha = (bgAlpha ~= nil and #bgAlpha > 0) and bgAlpha[1] or nil;
		local endAlpha = (bgAlpha ~= nil and #bgAlpha > 1) and bgAlpha[2] or nil;
		if startAlpha == nil and endAlpha == nil then
			self.winBg.alpha = 1;
		elseif endAlpha == nil then
			self.winBg.alpha = startAlpha;
		else
			self.winBg.alpha = startAlpha
			if startAlpha ~= endAlpha then -- 过渡动画
				local t = (bgAlpha ~= nil and #bgAlpha > 2) and bgAlpha[3] or DataCenter.guideUtil.maskAlphaTime;
				TweenUtil.getInstance():addTweenTargetAlpha(self.winBg.mainContent, t, 0, endAlpha - startAlpha, false);
			end
		end 
	end
end

-- 按钮状态
function Lua_GuideWindow:checkButtonState(config)
	if config == nil then
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Skip]:setInfo(nil);
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Review]:setInfo(nil);
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Hide]:setInfo(nil);
		self.btnTabState[Lua_GuideDefine.GuideWin_Button_Auto]:setInfo(nil);
		return;
	end

	local btnList = config.btnList;
	if btnList ~= nil then
		for i = 1, #btnList do
			local arr = btnList[i];
			if arr ~= nil and #arr > 0 then
				local idx = arr[1];
				if idx ~= nil and self.btnTabState[idx] ~= nil then
					self.btnTabState[idx]:setTemplateInfo(arr);
				end
			end
		end
	end

	self.btnTabState[Lua_GuideDefine.GuideWin_Button_Skip]:updateTemplateInfo();
	self.btnTabState[Lua_GuideDefine.GuideWin_Button_Review]:updateTemplateInfo();
	self.btnTabState[Lua_GuideDefine.GuideWin_Button_Hide]:updateTemplateInfo();
	self.btnTabState[Lua_GuideDefine.GuideWin_Button_Auto]:updateTemplateInfo();
	if not self.btnTabState[Lua_GuideDefine.GuideWin_Button_Auto].bShow then
		self.bAutoPlay = false;
	end
end

-- 创建内容模板
function Lua_GuideWindow:createContentTemplate(templateType, contentTweenClassName)
	if self.templateTweenName ~= nil then
		DataCenter.winTweenManager:removeWinTween(self.templateTweenName);
	end

	if self.templateType == nil or self.templateType ~= templateType then
		if self.templatePanel ~= nil then
			self.templatePanel:dispose();
			self.templatePanel = nil;
		end

		self.templateType = templateType;
		if templateType == Lua_GuideDefine.GuideWin_Template_ImgDialogLeft
			or templateType == Lua_GuideDefine.GuideWin_Template_ImgDialogRight then --立绘对话左、右
			self.templatePanel = Lua_GuideImgDialogPanel.new(self.content, templateType);
			if self.templatePanel ~= nil and self.btnSpr ~= nil then
				UIUtils.setObjSiblingIndex(self.templatePanel.content, self.btnSpr, 0);
			end
		elseif templateType == Lua_GuideDefine.GuideWin_Template_ModelEffDialogLeft 
			or templateType == Lua_GuideDefine.GuideWin_Template_ModelEffDialogRight then --模型spine对话左、右
			self.templatePanel = Lua_GuideModelEffDialogPanel.new(self.content, templateType);
			if self.templatePanel ~= nil and self.btnSpr ~= nil then
				UIUtils.setObjSiblingIndex(self.templatePanel.content, self.btnSpr, 0);
			end
		elseif templateType == Lua_GuideDefine.GuideWin_Template_BearTipLeft 
			or templateType == Lua_GuideDefine.GuideWin_Template_BearTipRight then --浣熊tips左、右
			self.templatePanel = Lua_GuideBearTipPanel.new(self.content, templateType);
		end
	else
		self.templatePanel:setEnable(true);
	end

	if self.templatePanel ~= nil then 
		self.templatePanel:initInfo(self.curGuideStepVo.config);
		if self.maskObj ~= nil and self.maskObj.bGetTarget then
			if self.templatePanel.setShowPos ~= nil then
				local px = self.maskObj.centerPosX;
				local py = self.maskObj.centerPosY + self.maskObj.posY;
				local guideClickObjMaskParams = self.guideCommonData.guideClickObjMaskParams;
				if guideClickObjMaskParams ~= nil then
					px = guideClickObjMaskParams.offsetPanelX and guideClickObjMaskParams.offsetPanelX + px or px;
					py = guideClickObjMaskParams.offsetPanelY and guideClickObjMaskParams.offsetPanelY + py or py;
				end
				self.templatePanel:setShowPos(self.maskObj.mTypeValue, px, py, self.maskObj.centerRectW, self.maskObj.centerRectH, self.maskObj.diameter, self.width, self.height);
			end
		end
		if not strIsNullOrEmpty(contentTweenClassName) then -- 界面动画
			self.templateTweenName = DataCenter.winTweenManager:createWinTween(contentTweenClassName, self.templatePanel.content.transform);
		end
	end
end

-- 挖空区域特效和手势
function Lua_GuideWindow:checkClickObjEffAndHandEff(config, bCheckMaskObj, target, tx, ty, w, h)
	local px = 0;
	local py = 0;
	if bCheckMaskObj and self.maskObj ~= nil then
		px = self.maskObj.centerPosX;
		py = self.maskObj.centerPosY + self.maskObj.posY;
	else
		local clickObjPos = config.clickObjPos;
		local posType = (clickObjPos ~= nil and #clickObjPos > 0) and clickObjPos[1] or 2;
		px = (clickObjPos ~= nil and #clickObjPos > 1) and clickObjPos[2] or 0;
		py = (clickObjPos ~= nil and #clickObjPos > 2) and clickObjPos[3] or 0;
		if tx ~= nil then px = px + tx; end
		if ty ~= nil then py = py + ty; end
		if posType == 2 then -- 偏移
			if self.findTargetSign > 0 and DataCenter.gameFindObjUtil:bFindedTarget(self.findTargetSign) then -- 找到目标
				px = px + DataCenter.gameFindObjUtil:getTargetPosX(self.findTargetSign, self.content);
				py = py + DataCenter.gameFindObjUtil:getTargetPosY(self.findTargetSign, self.content);
			elseif target ~= nil then
				local pos = target.position;
				pos = self.content.transform:InverseTransformPoint(pos);
				px = px + pos.x;
				py = py + pos.y;
			end
		end
	end


	--特效偏移
	local rotX, rotY, rotZ = 0, 0, 0;
	local maskParams = self.guideCommonData.guideClickObjMaskParams;
	if maskParams ~= nil then
		px = px + (maskParams.effectPosX or 0);
		py = py + (maskParams.effectPosY or 0);
		rotX = maskParams.effectRotX or 0; 
		rotY = maskParams.effectRotY or 0;
		rotZ = maskParams.effectRotZ or 0;
	elseif config.effecctOffset ~= nil then
		px = px + config.effecctOffset[1];
		py = py + config.effecctOffset[2];
		rotX = config.effecctOffset[3] or 0; 
		rotY = config.effecctOffset[4] or 0;
		rotZ = config.effecctOffset[5] or 0;
	end

	-- print("checkClickObjEffAndHandEff", self.findTargetSign, DataCenter.gameFindObjUtil:bFindedTarget(self.findTargetSign), px, py);
	local clickObjEffUrl = config.clickObjEffUrl;
	local clickObjEffModelName = config.clickObjEffModelName;
	if strIsNullOrEmpty(clickObjEffUrl) or strIsNullOrEmpty(clickObjEffModelName) then
		if self.clickObjEff ~= nil then
			self.clickObjEff:setEnable(false);
		end
	else
		if self.clickObjEff == nil then
			self.clickObjEff = UICreate.createUIEffect(self.content, clickObjEffUrl, clickObjEffModelName, px, py);
			-- self.clickObjEff.name = "clickObjEff";
		else
			self.clickObjEff:setEnable(true);
			self.clickObjEff:setUrl(clickObjEffUrl, clickObjEffModelName);
			self.clickObjEff:setLocation(px, py);
		end
		self.clickObjEff:setRot(rotX, rotY, rotZ);
	end
end

function Lua_GuideWindow:checkObjInBound()
	if not self:bClickObjInBound(self.maskObj.centerPosX, self.maskObj.centerPosY + self.maskObj.posY) then
		-- print("超范围重新检测")
		self.bResetStepVo = true;
		self.isAutoNextStep = false;
		self.curGuideStep = self.curGuideStep - 1;
		return false;
	else
		return true;
	end
end

function Lua_GuideWindow:bClickObjInBound(px, py)
	local half_width = self.width / 2;
	local half_height = self.height / 2;
	local minPosX, maxPosX = -half_width, half_width;
	local minPosY, maxPosY = -half_height, half_height;
	-- print(px , minPosX, "...", maxPosX ,"...", py , minPosY ,"...", maxPosY)
	return not (px < minPosX or px > maxPosX or py < minPosY or py > maxPosY);
end

-- 自动按钮旋转
function Lua_GuideWindow:rotAutoBtn(dt)
	if self.bAutoPlay then
		if not self.btnTabState[Lua_GuideDefine.GuideWin_Button_Auto].bShow then
			return;
		end

		self.autoBtnRotTime = self.autoBtnRotTime + dt;
		if self.autoBtnRotTime >= self.autoBtnRotCircleTime then
			self.autoBtnRotTime = self.autoBtnRotTime - self.autoBtnRotCircleTime;
		end
		local rate = (self.autoBtnRotTime / self.autoBtnRotCircleTime) * 360;
		self.autoBtn:setRot(0, 0, -rate);
	end
end

function Lua_GuideWindow:onMaskClick()
	if self.curGuideStepVo == nil then
		return;
	end

	-- 隐藏状态点击，则取消隐藏状态
	if self.bHideState then
		self.bHideState = false;
		self:chechHideState();
		return;
	end

	if self.bResetStepVo then
		return;
	end

	local config = self.curGuideStepVo.config;
	if config ~= nil then
		local completeConditionsNext = config.completeConditionsNext;
		if completeConditionsNext ~= nil then
			if completeConditionsNext == 1 then
				if not self.curGuideStepVo.isCompleteEvent then
					return;
				end
			elseif completeConditionsNext == 2 then
				if not self.curGuideStepVo.canOperate or not self.curGuideStepVo.isCompleteEvent then
					return;
				end
			end
		end

		-- 黑色遮罩，初始化挖空遮罩暂不往后执行
		if self.curGuideVo.bShowMaskObj then
			if self.maskObj == nil then
				return;
			end

			-- 需要获取目标的，还未获取目标
			if not strIsNullOrEmpty(config.clickObjPath) and (not strIsNullOrEmpty(config.sceneId) or not strIsNullOrEmpty(config.clickObjWin)) then
				if not self.maskObj.bGetTarget then
					return;
				end
			end
		end

		-- 文本加速
		-- 无文本或者文本无逐字播放（这情况是否要加个时间限定，以便玩家能瞄完内容），跳到下一步骤，同理跳过
		self.playSpeed = (config.clickAutoMul == nil) and 1 or config.clickAutoMul;
		if config.syncWinInfo ~= nil and not self.curGuideStepVo.isCompleteEvent then
			return; -- 同步界面引导的，需要完成条件成立才执行结束
		end
	end
	if self.intervalTime == 0 then
		-- print("1313 self.bResetStepVo 完成执行下一步");
		self.bResetStepVo = true;
		self.bAutoPlay = false;
		self.isAutoNextStep = false;
	end
end

-- 挖空遮罩区域点击
function Lua_GuideWindow:onMaskObjSelected()
	if self.bResetStepVo then
		return;
	end

	local config = self.curGuideStepVo.config;
	if config ~= nil and config.openPathId ~= nil then
		if self.intervalTime == 0 then
			-- print("1414 self.bResetStepVo 完成执行下一步");
			self.bResetStepVo = true;
			self.bAutoPlay = false;
			self.isAutoNextStep = false;
			DataCenter.funcPathUtil:gotoFunction(config.openPathId);
		end
		return;
	end
	-- print("Lua_GuideWindow:onMaskObjSelected()");
	self:onMaskClick();
end

function Lua_GuideWindow:onMaskObjClick()
	local config = self.curGuideStepVo.config;
	if config ~= nil and config.clickObjClickNext ~= nil and config.clickObjClickNext == 1 then -- 点击挖空遮罩执行下一步
		self:onMaskClick();
	end
end

-- 挖空遮罩位置确认完成
function Lua_GuideWindow:onMaskObjInit()
	-- if self.curGuideStepVo == nil then return; end
	-- local config = self.curGuideStepVo.config;
	-- if config == nil then
	-- 	return;
	-- end

	-- self:checkBgState(config); -- 检测背景
	-- self:checkButtonState(config);-- 按钮状态检测
	-- self:createContentTemplate(config.contentTemplate, config.contentTweenClassName);
	-- self.intervalTime = (config.stepCountTime == nil) and 0 or (config.stepCountTime / 1000);
	-- self.isAutoNextStep = (config.isAutoNextStep ~= nil) and (config.isAutoNextStep == 1) or false;
	-- if self.isAutoNextStep then self.bAutoPlay = true; end
	-- if self.maskObj ~= nil and self.maskObj.isShrinkEnd and self.maskObj.bGetTarget then
	-- 	self:checkClickObjEffAndHandEff(config); -- 挖空区域特效和手势
	-- end
end

-- 挖空遮罩shrink动画完成
function Lua_GuideWindow:onShrinkComplete()
	if self.curGuideStepVo == nil then return; end
	local config = self.curGuideStepVo.config;
	if config == nil then
		return;
	end

	self:checkClickObjEffAndHandEff(config, true); -- 挖空区域特效和手势
end

-- 挖空遮罩shrink动画失败
function Lua_GuideWindow:onShrinkFail()
	self:onShrinkComplete();
end

-- 本地调试用
function Lua_GuideWindow:printGuideInfo()
	if not Lua_PlatformUtil.IsWindowsEditor() then
		return;
	end

	if self.printGuideInfoTxt == nil then
	    self.printGuideInfoTxt = UICreate.createLabel(self.content, "", 0, -20, 500, 40, 20);
	    self.printGuideInfoTxt.pivotValue = 0;
	    self.printGuideInfoTxt.anchorValue = 0;
		self.printGuideInfoTxt.alignmentValue = 6;
		self.printGuideInfoTxt.verticalOverflowValue = 1;
		self.printGuideInfoTxt.bSupportRichText = false;
		self.printGuideInfoTxt.colorStr = Lua_ColorDefine.transColorStr("ff0000");
	end

	local str = "引导ID:"..self.curGuideId;
	str = str .. "\n引导步骤:" .. self.curGuideStep;
	self.printGuideInfoTxt.text = str;
end




function Lua_GuideWindow:checkTolerateErrTime(dt)
	if not self.bCheckTolerateErr then
		return;
	end

	local checkTolerateErrCount = 1;
	local tolerateErrType;
	-- print("111guide", self.curGuideId, "step", self.curGuideStep, self.bTolerateErring, self.tolerateErrTime, self.bStopGuide, self.maskObj ~= nil and self.maskObj.bGetTarget or false)
	if self.bTolerateErring and self.tolerateErrTime ~= nil and --self.tolerateErrTime > 0 and
		self.bStopGuide ~= true and self.maskObj ~= nil and self.maskObj.bGetTarget ~= true then
			-- print("查找UIguide", self.curGuideId, "step", self.curGuideStep )
			tolerateErrType = 1; --查找UI
			checkTolerateErrCount = DataCenter.guideUtil.findGuideTargetCount;
	-- elseif self.bStopGuide and Lua_WindowUtil.bLoadingWindow() ~= self.windowObj.activeSelf then
	end

	if tolerateErrType ~= nil then
		self.tolerateErrTime = self.tolerateErrTime - dt;
		-- print("222guide", self.curGuideId, "step", self.curGuideStep, "剩余时间", self.tolerateErrTime )
		if self.tolerateErrTime <= 0 then
			self.tolerateErrCount = self.tolerateErrCount + 1;
			-- print("333guide", self.curGuideId, "step", self.curGuideStep, "次数", self.tolerateErrCount)
			if self.tolerateErrCount >= checkTolerateErrCount then
				-- print("555显示按钮guide", self.curGuideId, "step", self.curGuideStep);
				self.btnTabState[Lua_GuideDefine.GuideWin_Button_Skip]:immediatelyShowBtn();
				-- self.bTolerateErring = false;
				return true;
			else
				self.tolerateErrTime = DataCenter.guideUtil.findGuideTargetTime;
				if tolerateErrType == 1 then
					-- print("444重新初始化数据guide", self.curGuideId, "step", self.curGuideStep, self.tolerateErrTime)
					self:initGuideStep();
				end
			end
		end
	end
end

function Lua_GuideWindow:startTolerateErr() 
	if self.bTolerateErring ~= true then
		self.bTolerateErring = true;
		self.tolerateErrTime = DataCenter.guideUtil.findGuideTargetTime;
		self.tolerateErrCount = 0;
		-- print("开始容错检测guide", self.curGuideId, "step", self.curGuideStep, self.bTolerateErring, self.tolerateErrTime, self.tolerateErrCount)
	end
end

function Lua_GuideWindow:clearTolerateErrData()
	self.bTolerateErring = nil;
	self.tolerateErrTime = nil;
	self.tolerateErrCount = nil;
	-- print("重置数据guide", self.curGuideId, "step", self.curGuideStep)
end