-- 引导步骤的按钮状态
Lua_GuideButtonState = class("Lua_GuideButtonState");
function Lua_GuideButtonState:ctor(btnType, btn, btnTxt)
	self:superCall("ctor");

	self.btn = btn;
	self.btnTxt = btnTxt;
	self.btnType = btnType;
	self.bEnable = false;
	self.delayTime = 0;
	self:checkBtnState();
end

function Lua_GuideButtonState:dispose()
	self.btn = nil;
	self.btnTxt = nil;
	self.templateInfo = nil;
end

function Lua_GuideButtonState:setTemplateInfo(info)
	self.templateInfo = info;
end

function Lua_GuideButtonState:updateTemplateInfo()
	self:setInfo(self.templateInfo);
	self.templateInfo = nil;
end

-- 数据
function Lua_GuideButtonState:setInfo(info)
	if info == nil or #info <= 0 then
		self.bEnable = false;
		self:checkBtnState();
		return;
	end

	if info[1] ~= self.btnType then
		return;
	end

	self.bEnable = true;
	self.delayTime = #info > 1 and info[2] or 0;
	self.bClickShow = #info > 2 and (info[3] == 1) or false;
	self:checkBtnState();
end

function Lua_GuideButtonState:frameScript(dt, scaleDelayTime)
	if self.bEnable and self.delayTime > 0 then
		self.delayTime = self.delayTime - scaleDelayTime;
		self:checkBtnState();
	end
end

function Lua_GuideButtonState:checkBtnState()
	if self.btn ~= nil then 
		self.btn:setEnable(self.bEnable and (self.delayTime <= 0));
	end
	if self.btnTxt ~= nil then
		self.btnTxt:setEnable(self.bEnable and (self.delayTime <= 0));
	end
end

-- 立即显示按钮
function Lua_GuideButtonState:immediatelyShowBtn()
	self.delayTime = 0;
	self.bEnable = true;
	self:checkBtnState();
end

function Lua_GuideButtonState.Get:bShow()
	return self.bEnable and (self.delayTime <= 0);
end