-- 小熊提示左
Lua_GuideBearTipPanel = class("Lua_GuideBearTipPanel", Lua_DisplayObject);
function Lua_GuideBearTipPanel:ctor(p, templateType)
	if templateType == Lua_GuideDefine.GuideWin_Template_BearTipLeft then
		self:superCall("ctor", p, "GuideBearTipLeftPanel_skin");
	else
		self:superCall("ctor", p, "GuideBearTipRightPanel_skin");
	end
end

function Lua_GuideBearTipPanel:buildPanel(go)
	self:superCall("buildPanel", go);

end

function Lua_GuideBearTipPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.contentTxt.text = "";
end

function Lua_GuideBearTipPanel:dispose()

	self:superCall("dispose");
end

function Lua_GuideBearTipPanel:initInfo(cfg)
	self.contentTemplate = cfg.contentTemplate;
	self.contentTxt.text = cfg.dialogContent == nil and "" or cfg.dialogContent;
	self:updateBgAndTxtSetting();
	self.dialogPlayDelayTime = cfg.dialogPlayDelayTime ~= nil and (cfg.dialogPlayDelayTime / 1000) or 0;
	self.dialogPlayTime = cfg.dialogPlayTime ~= nil and (cfg.dialogPlayTime / 1000) or 0;
	if self.dialogPlayTime <= 0 then
		self.contentTxtLen = -1;
		self.dialogPlayedTime = -1;
		self.dialogPlayDelayTime = 0;
		self.contentTxt:setTextShowIndex(-1);
	else -- 开始逐字播放
		self.dialogPlayedTime = 0;
		self.contentTxtLen = self.contentTxt.showTextLen;
		self.contentTxt:setTextShowIndex(0);
	end

	local px = (cfg.contentTemplatePos ~= nil and #cfg.contentTemplatePos > 0) and cfg.contentTemplatePos[1] or 0;
	local py = (cfg.contentTemplatePos ~= nil and #cfg.contentTemplatePos > 1) and cfg.contentTemplatePos[2] or 0;
	self:setLocation(px, py);
end

function Lua_GuideBearTipPanel:frameScript(dt, scaleDelayTime)
	if self.dialogPlayDelayTime > 0 then
		self.dialogPlayDelayTime = self.dialogPlayDelayTime - scaleDelayTime;
		if self.dialogPlayDelayTime <= 0 then
			scaleDelayTime = -self.dialogPlayDelayTime;
			self.dialogPlayDelayTime = 0;
		else
			return;
		end
	end

	if self.dialogPlayedTime >= 0 then
		self.dialogPlayedTime = self.dialogPlayedTime + scaleDelayTime;
		local rate = self.dialogPlayedTime / self.dialogPlayTime;
		if rate >= 1 then
			self.dialogPlayedTime = -1;
			local content = self.contentTxt.text;
			self.contentTxt.text = nil;
			self.contentTxt.text = content;
		else
			local num = Mathf.Floor(rate * self.contentTxtLen);
			self.contentTxt:setTextShowIndex(num);
		end
	end
end

-- 更新位置，maskType 0 圆 1 矩形
function Lua_GuideBearTipPanel:setShowPos(maskType, cx, cy, cw, ch, diameter, winWidth, winHeight)
	local w = 300;
	local h = 100;
	local px = self.posX ~= nil and self.posX or 0;
	local py = self.posY ~= nil and self.posY or 0;
	px = px + cx;
	py = py + cy;

	px, py = self:getValidPosition(winWidth, winHeight, px, py);
	self:setLocation(px, py);
end

function Lua_GuideBearTipPanel:getValidPosition(winWidth, winHeight, px, py)
	winWidth = winWidth / 2;
	winHeight = winHeight / 2;
	--右边：65 上边：93
	local widthOver = 65;
	local heightOver = 93;
	local tipBgHalfW, tipBgHalfH = self.tipBg.width / 2, self.tipBg.height / 2;
	local bLeft = self.contentTemplate == Lua_GuideDefine.GuideWin_Template_BearTipLeft;
	local leftHalfW = bLeft and tipBgHalfW + widthOver or tipBgHalfW;
	local rightHalfW = bLeft and tipBgHalfW or tipBgHalfW + widthOver;
	local upHalfH = tipBgHalfH + heightOver;
	local downtHalfH = tipBgHalfH;

	if px < 0 and px - leftHalfW < -winWidth then
		px = -winWidth + leftHalfW;
	elseif px > 0 and px + rightHalfW > winWidth then
		px = winWidth - rightHalfW;
	end

	if py < 0 and py - downtHalfH < -winHeight then
		py = -winHeight + downtHalfH;
	elseif py > 0 and py + upHalfH > winHeight then
		py = winHeight - upHalfH;
	end
	return px, py;
end

function Lua_GuideBearTipPanel:updateBgAndTxtSetting()
	self.contentTxt:resetSize();
	local height = self.contentTxt.height + 41;
	local posY = 9;
	if height >= 149 then
		posY = posY + (height - 149) / 2;
	else
		height = 149;
	end
	self.tipBg:SetDimensions(490, height);
	self.contentTxt:setLocation(self.contentTxt.posX, posY);
end