-- 图片立绘对话左
Lua_GuideImgDialogPanel = class("Lua_GuideImgDialogPanel", Lua_DisplayObject);
function Lua_GuideImgDialogPanel:ctor(p, templateType)
	self.dialogPlayTime = 0;
	self.dialogPlayDelayTime = 0;
	self.dialogPlayedTime = -1;
	if templateType == Lua_GuideDefine.GuideWin_Template_ImgDialogLeft then
		self:superCall("ctor", p, "GuideImgDialogLeftPanel_skin");
	else
		self:superCall("ctor", p, "GuideImgDialogRightPanel_skin");
	end
end

function Lua_GuideImgDialogPanel:buildPanel(go)
	self:superCall("buildPanel", go);

end

function Lua_GuideImgDialogPanel:buildShowItem()
	self:superCall("buildShowItem");

	-- self.roleImage.resetBgSize = true;
	self.continueImg:setEnable(false);
	self:setRectAnchor(7);
	self:setLocation(0, 720);
end

function Lua_GuideImgDialogPanel:dispose()

	self:superCall("dispose");
end

function Lua_GuideImgDialogPanel:initInfo(cfg)
	local url = nil;
	if cfg.url ~= nil and cfg.femaleUrl ~= nil then
		url = DataCenter.roleData.sex == Lua_ThingDefine.FEMALE and cfg.femaleUrl or cfg.url;
	else
		url = cfg.url ~= nil and cfg.url or cfg.femaleUrl;
	end
	if strIsNullOrEmpty(url) then
		self.roleImage:clearTexture();
		self.roleImage:setEnable(false);
	else
		self.roleImage:setEnable(true);
		if self.roleImage.url ~= url then
			self.roleImage:SetDimensions(0, 0);
		end
		self.roleImage:setUrl(url);
	end

	if cfg.isUseRoleName ~= nil and cfg.isUseRoleName == 1 then
		if cfg.dialogTitle ~= nil then
			self.titleTxt.text = LanUtil.formateStr(cfg.dialogTitle, DataCenter.roleData.name);
		else
			self.titleTxt.text = DataCenter.roleData.name;
		end
		if cfg.dialogContent ~= nil then
			self.contentTxt.text = LanUtil.formateStr(cfg.dialogContent, DataCenter.roleData.name);
		else
			self.contentTxt.text = cfg.dialogContent == nil and "" or cfg.dialogContent;
		end
	else
		self.titleTxt.text = cfg.dialogTitle == nil and "" or cfg.dialogTitle;
		self.contentTxt.text = cfg.dialogContent == nil and "" or cfg.dialogContent;
		self.titleBg:setEnable(cfg.isNarrator ~= 1);
	end
	
	self.dialogPlayDelayTime = cfg.dialogPlayDelayTime ~= nil and (cfg.dialogPlayDelayTime / 1000) or 0;
	self.dialogPlayTime = cfg.dialogPlayTime ~= nil and (cfg.dialogPlayTime / 1000) or 0;
	if self.dialogPlayTime <= 0 then
		self.contentTxtLen = -1;
		self.dialogPlayedTime = -1;
		self.dialogPlayDelayTime = 0;
		self.continueImg:setEnable(true);
		self.contentTxt:setTextShowIndex(-1);
	else -- 开始逐字播放
		self.dialogPlayedTime = 0;
		self.continueImg:setEnable(false);
		self.contentTxtLen = self.contentTxt.showTextLen;
		self.contentTxt:setTextShowIndex(0);
	end
end

function Lua_GuideImgDialogPanel:frameScript(dt, scaleDelayTime)
	if self.dialogPlayDelayTime > 0 then
		self.dialogPlayDelayTime = self.dialogPlayDelayTime - scaleDelayTime;
		if self.dialogPlayDelayTime <= 0 then
			scaleDelayTime = -self.dialogPlayDelayTime;
			self.dialogPlayDelayTime = 0;
		else
			return false;
		end
	end

	if self.dialogPlayedTime >= 0 then
		self.dialogPlayedTime = self.dialogPlayedTime + scaleDelayTime;
		local rate = self.dialogPlayedTime / self.dialogPlayTime;
		if rate >= 1 then
			self.dialogPlayedTime = -1;
			self.continueImg:setEnable(true);
			local content = self.contentTxt.text;
			self.contentTxt.text = nil;
			self.contentTxt.text = content;
		else
			local num = Mathf.Floor(rate * self.contentTxtLen);
			self.contentTxt:setTextShowIndex(num);
			return false;
		end
	end

	return true;
end

function Lua_GuideImgDialogPanel:showBeautiful(bShow)
	self.contentSpr:SetActive(not bShow);
end