-- 模型或特效或spine立绘对话左
Lua_GuideModelEffDialogPanel = class("Lua_GuideModelEffDialogPanel", Lua_DisplayObject);
function Lua_GuideModelEffDialogPanel:ctor(p, templateType)
	self.dialogPlayTime = 0;
	self.dialogPlayDelayTime = 0;
	self.dialogPlayedTime = -1;
	self.templateType = templateType;
	if templateType == Lua_GuideDefine.GuideWin_Template_ModelEffDialogLeft then
		self:superCall("ctor", p, "GuideModelEffDialogLeftPanel_skin");
	else
		self:superCall("ctor", p, "GuideModelEffDialogRightPanel_skin");
	end
end

function Lua_GuideModelEffDialogPanel:buildPanel(go)
	self:superCall("buildPanel", go);

end

function Lua_GuideModelEffDialogPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.continueImg:setEnable(false);

	-- 创建好方便动画
	self.roleImage = UICreate.createModelEffImg(self.content, "", "", 0, 0, MainWinDefine.bgHeight, MainWinDefine.bgHeight);
	self.roleImage.siblingIndex = 0;
	self.roleImage:setCamField(1.5, 1, 100, true);
	self.roleImage:setCamPos(0.25, 1.3, -10);
	self.roleImage:setModelEffDir(180);
	self.roleImage:showLight();
	self.roleImage.canRot = false;
	self.roleImage.name = "roleImage";
	self:setRectAnchor(7);
	self:setLocation(0, 720);
end

function Lua_GuideModelEffDialogPanel:dispose()
	if self.roleImage ~= nil then
		self.roleImage:dispose();
		self.roleImage = nil;
	end

	LuaUtil.setSceneDataExtendVal("FurEffShow", false);
	self:superCall("dispose");
end

function Lua_GuideModelEffDialogPanel:initInfo(cfg)
	local url = nil;
	local modelName = nil;
	if cfg.femaleUrl ~= nil and cfg.femaleModelName ~= nil and cfg.url ~= nil and cfg.modelName ~= nil then
		if DataCenter.roleData.sex == Lua_ThingDefine.FEMALE then
			url = cfg.femaleUrl;
			modelName = cfg.femaleModelName;
		else
			url = cfg.url;
			modelName = cfg.modelName;
		end
	else
		if cfg.url ~= nil and cfg.modelName ~= nil then
			url = cfg.url;
			modelName = cfg.modelName;
		elseif cfg.femaleUrl ~= nil and cfg.femaleModelName ~= nil then
			url = cfg.femaleUrl;
			modelName = cfg.femaleModelName;
		end
	end


	if strIsNullOrEmpty(url) or strIsNullOrEmpty(modelName) then
		self.roleImage:clearModelEff(false);
		self.roleImage:setEnable(false);
		LuaUtil.setSceneDataExtendVal("FurEffShow", false);
	else
		self.roleImage:setEnable(true);
		self.roleImage:setUrl(url, modelName);
		if DataCenter.guideUtil:isFurModel(modelName) then
			-- self.roleImage:setShader("Default No-Alpha Blend One");
			LuaUtil.setSceneDataExtendVal("FurEffShow", true);
		else
			-- self.roleImage:setShader("Default No-Alpha");
			LuaUtil.setSceneDataExtendVal("FurEffShow", false);
		end

		local modelCam = cfg.modelCam;
		if modelCam ~= nil then
			if #modelCam > 0 then
				self.roleImage:setCamField(modelCam[1], 1, 100, true);
			end

			if #modelCam > 1 then
				local mx = modelCam[2];
				local my = (#modelCam > 2) and modelCam[3] or 0;
				local mz = (#modelCam > 3) and modelCam[4] or 0;
				self.roleImage:setCamPos(mx, my, mz);
			end
		end

		local sca = (modelCam ~= nil and #modelCam > 4) and modelCam[5] or 1;
		self.roleImage:setScale(sca, 1, 1);
	end

	if cfg.isUseRoleName ~= nil and cfg.isUseRoleName == 1 then
		if cfg.dialogTitle ~= nil then
			self.titleTxt.text = LanUtil.formateStr(cfg.dialogTitle, DataCenter.roleData.name);
		else
			self.titleTxt.text = DataCenter.roleData.name;
		end
		if cfg.dialogContent ~= nil then
			self.contentTxt.text = LanUtil.formateStr(cfg.dialogContent, DataCenter.roleData.name);
		else
			self.contentTxt.text = cfg.dialogContent == nil and "" or cfg.dialogContent;
		end
	else
		self.titleTxt.text = cfg.dialogTitle == nil and "" or cfg.dialogTitle;
		self.contentTxt.text = cfg.dialogContent == nil and "" or cfg.dialogContent;
	end
	
	self.dialogPlayDelayTime = cfg.dialogPlayDelayTime ~= nil and (cfg.dialogPlayDelayTime / 1000) or 0;
	self.dialogPlayTime = cfg.dialogPlayTime ~= nil and (cfg.dialogPlayTime / 1000) or 0;
	if self.dialogPlayTime <= 0 then
		self.contentTxtLen = -1;
		self.dialogPlayedTime = -1;
		self.dialogPlayDelayTime = 0;
		self.continueImg:setEnable(true);
		self.contentTxt:setTextShowIndex(-1);
	else -- 开始逐字播放
		self.dialogPlayedTime = 0;
		self.continueImg:setEnable(false);
		self.contentTxtLen = self.contentTxt.showTextLen;
		self.contentTxt:setTextShowIndex(0);
	end
end

function Lua_GuideModelEffDialogPanel:frameScript(dt, scaleDelayTime)
	if self.dialogPlayDelayTime > 0 then
		self.dialogPlayDelayTime = self.dialogPlayDelayTime - scaleDelayTime;
		if self.dialogPlayDelayTime <= 0 then
			scaleDelayTime = -self.dialogPlayDelayTime;
			self.dialogPlayDelayTime = 0;
		else
			return;
		end
	end

	if self.dialogPlayedTime >= 0 then
		self.dialogPlayedTime = self.dialogPlayedTime + scaleDelayTime;
		local rate = self.dialogPlayedTime / self.dialogPlayTime;
		if rate >= 1 then
			self.dialogPlayedTime = -1;
			self.continueImg:setEnable(true);
			local content = self.contentTxt.text;
			self.contentTxt.text = nil;
			self.contentTxt.text = content;
		else
			local num = Mathf.Floor(rate * self.contentTxtLen);
			self.contentTxt:setTextShowIndex(num);
		end
	end
end

function Lua_GuideModelEffDialogPanel:showBeautiful(bShow)
	self.contentSpr:SetActive(not bShow);
end