-- 引导模块
checkRequire("Lua_GuideData");
checkRequire("Lua_GuideUtil");
checkRequire("Lua_GuideDefine");
checkRequire("Lua_GuideCommonData");
Lua_GuideProxy = class("Lua_GuideProxy");
function Lua_GuideProxy:ctor()
	self:superCall("ctor");
    DataCenter.guideData = Lua_GuideData.new();
    DataCenter.guideUtil = Lua_GuideUtil.new();
    DataCenter.guideCommonData = Lua_GuideCommonData.new();

    Lua_MsgUtil.addLuaMsg(80202001, self, self.rUpdateServerGuide); --网关登陆验证
    Lua_MsgUtil.addEventListener("FUNCTION_OPEN",self, self.onFuncOpenCheck); --功能开启触发引导
    Lua_MsgUtil.addEventListener("INIT_FUNCTION_OPEN",self, self.onFuncOpenCheck); --功能开启触发引导
    Lua_MsgUtil.addEventListener("FUNCTION_OPENWIN_CLOSE", self, self.onFuncOpenCheck); -- 功能开启后 功能弹窗关闭时
    Lua_MsgUtil.addEventListener("UPDATE_EXPLORER_TOUR_INFO",self, self.onMainLineTaskCheck); --任务触发引导
    Lua_MsgUtil.addEventListener("UPDATE_ROLE_LEVEL",self, self.onLevelUpCheck); --等级触发引导
    Lua_MsgUtil.addEventListener("UPDATE_MAINLINE_INFO",self, self.onMainLineCheck); --主线推图触发引导
    Lua_MsgUtil.addEventListener("SCENE_SHOW", self, self.onSceneShow); -- 场景显示
    Lua_MsgUtil.addEventListener("SCENE_HIDE", self, self.onSceneHide); -- 场景隐藏
    Lua_MsgUtil.addEventListener("WIN_SHOW_COMPLETE", self, self.onWinShow); -- 界面显示
    Lua_MsgUtil.addEventListener("WIN_ACTIVE_CHANGE", self, self.onWinActive); -- 界面状态变化
    Lua_MsgUtil.addEventListener("ADD_PACK_ITEMS", self, self.onPackUpdate); -- 背包道具增加
    Lua_MsgUtil.addEventListener("REMOVE_PACK_ITEMS", self, self.onPackUpdate); -- 背包道具减少
    Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.onMoneyUpdate); -- 货币变化
    Lua_MsgUtil.addEventListener("INIT_HERO_INFO", self, self.onHeroUpdate); -- 英雄初始化
    Lua_MsgUtil.addEventListener("UPDATE_HERO_INFO", self, self.onHeroUpdate); -- 单个英雄更新
    Lua_MsgUtil.addEventListener("UPDATE_HERO_LINEUP_INFO", self, self.onLineUpInfoUpdate); -- 布阵更新
    Lua_MsgUtil.addEventListener("LineUp_LocationInfo_Update", self, self.onLineUpInfoUpdate); -- 布阵本地数据更新
    Lua_MsgUtil.addEventListener("LineUp_Actifact_LocationInfo_Update", self, self.onLineUpActifactInfoUpdate); -- 布阵界面神器本地数据更新
    Lua_MsgUtil.addEventListener("UPDATE_COLLECTION_CABINET_INFO", self, self.onCollectionItemUpdate); -- 藏品柜
    Lua_MsgUtil.addEventListener("FIGHTPLAY_ENTER", self, self.onFightState); -- 战斗状态
    Lua_MsgUtil.addEventListener("FIGHTPLAY_COMPLETE", self, self.onFightState); -- 战斗状态
    Lua_MsgUtil.addEventListener("UPDATE_FIGHTTYPE_RESULT_WIN", self, self.onFightTypeResultWin); -- 战斗类型结算窗口
    
    MsgUtil.addEventListener("WIN_DISPOSE", self, self.onWinDispose); -- 界面销毁
end

---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-- 上行
-- 保存引导
function Lua_GuideProxy:sSaveGuide(gid, step) 
    local cmd = ProtoPublic_pb.Proto10202001();
    cmd.guide_id = gid;
    cmd.guide_step = step;
    sendMsg(10202001, cmd);
end








---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-- 下行
-- 引导信息
function Lua_GuideProxy:rUpdateServerGuide(mp)
    if mp.errno ~= 0 then 
        return;
    end

    local msg = ProtoPublic_pb.Proto80202001();
    msg:ParseFromString(mp.data);
    DataCenter.guideData:updateServerInfo(msg);
end









---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-- 事件监听
-- 功能开启触发引导
function Lua_GuideProxy:onFuncOpenCheck(openDic)
    DataCenter.guideData:funOpenCheck(openDic);
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_FunOpen);
end

-- 主线冒险任务触发引导
function Lua_GuideProxy:onMainLineTaskCheck(taskType)
    DataCenter.guideData:mainLineTaskStageCheck();
    DataCenter.guideData:mainLineTaskCheck(taskType);
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_MainLineTask);
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_MainLineStage);
end

-- 等级触发引导
function Lua_GuideProxy:onLevelUpCheck()
    DataCenter.guideData:levelUpCheck();
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_Level);
end

-- 主线推图触发引导
function Lua_GuideProxy:onMainLineCheck()
    DataCenter.guideData:mainlineCheck();
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_MainLine);
end

-- 场景显示
function Lua_GuideProxy:onSceneShow(sceneId)
    DataCenter.guideData:sceneShowCheck(sceneId);
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_SceneShow);
end

-- 场景关闭
function Lua_GuideProxy:onSceneHide(sceneId)
    DataCenter.guideData:sceneShowCheck(sceneId);
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_SceneShow);
end

-- 界面显示
function Lua_GuideProxy:onWinShow(winName)
    -- Lua_MsgUtil.callFunc("Guide_WinLoading_Open", false);
    DataCenter.guideData:winShowCheck(winName);
    DataCenter.guideCommonData:syncPopupWinState(winName, 1);
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_OpenWin);
end

-- 界面状态变化
function Lua_GuideProxy:onWinActive(winStateTab)
    DataCenter.guideData:winShowCheck();
    if Lua_WindowUtil.winActiveState ~= nil then
        local state = Lua_WindowUtil.winActiveState.state and 1 or 2;
        DataCenter.guideCommonData:syncPopupWinState(Lua_WindowUtil.winActiveState.winName, state);
    end
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_OpenWin);
end

-- 界面销毁
function Lua_GuideProxy:onWinDispose(winName)
    DataCenter.guideData:winShowCheck(winName);
    DataCenter.guideCommonData:syncPopupWinState(winName, 2);
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_OpenWin);
end

-- 背包变化
function Lua_GuideProxy:onPackUpdate(obj)
    DataCenter.guideData:itemCheck();
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_Item);
end

-- 货币变化
function Lua_GuideProxy:onMoneyUpdate(dic)
    DataCenter.guideData:itemCheck();
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_Item);    
end

-- 英雄数据更新
function Lua_GuideProxy:onHeroUpdate()
    DataCenter.guideData:heroCheck();
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_Hero);    
end

-- 布阵数据变化
function Lua_GuideProxy:onLineUpInfoUpdate(lineupType)
    DataCenter.guideData:lineUpCheck();
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_LineUp);    
end

-- 布阵神器数据变化
function Lua_GuideProxy:onLineUpActifactInfoUpdate()
    DataCenter.guideData:lineUpArtifactCheck();
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_Artifact);    
end

-- 藏品柜
function Lua_GuideProxy:onCollectionItemUpdate()
    DataCenter.guideData:collectionItemCheck();
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_CollectionItem);    
end

-- 战斗状态
function Lua_GuideProxy:onFightState(templateId)
    DataCenter.guideData:onFightState(templateId);
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_FightState); 
end

-- 战斗类型结算窗口
function Lua_GuideProxy:onFightTypeResultWin()
    print("Lua_GuideProxy:onFightTypeResultWin")
    DataCenter.guideData:fightTypeResultWinCheck();
    Lua_MsgUtil.callFunc("Guide_Condition_Update", Lua_GuideDefine.Trigger_Condition_FightTypeResultWin); 
end
