-- 进度条加载页
Lua_LoadingScreenWindow = class("Lua_LoadingScreenWindow", Lua_Window);
function Lua_LoadingScreenWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.MAX_TOP_LAYER;
	self.windowName = "Lua_LoadingScreenWindow";
	self.isFullSizeWin = true;
    self.isFullSizeBg = true
	self.showWinBg = true;
	self.winBgPath = "/images/loading/login_bg.jpg";
end

function Lua_LoadingScreenWindow:buildPanel(go)
	self:superCall("buildPanel", go);
    self:addCSharpEvent("FIEL_VERSION_LOADED", self, self.onFielVersionLoaded);
end

function Lua_LoadingScreenWindow:buildShowItem()
	self:superCall("buildShowItem");
    self.winBg.anchorValue = 4;
    self.winBg.pivotValue = 4;

	self.tipsTxt = UICreate.createLabel(self.content, nil, 0, 90, self.width, 31, 22);
    self.tipsTxt.name = "tipsTxt";
    self.tipsTxt.anchorValue = 7;
    self.tipsTxt.pivotValue = 4;
    self.tipsTxt.alignmentValue = 4;
    self.tipsTxt.horizontalOverflowValue = 1;
    self.tipsTxt.verticalOverflowValue = 1;
    self.tipsTxt.colorStr = "4289590267";
    self.tipsTxt:setEnable(false);

    self.pb = UICreate.createProgressBar(self.content, "common_altas_1", "xui_cjjs_tipsprogress_1_b", "common_altas_1", "xui_cjjs_tipsprogress_1_f", 0, 151, 658, 10);
    self.pb.anchorValue = 7;
    self.pb:setMouseEnable(false);
    self.pb:setMaxValue(500);
    self.pb:setValue(100);

    self.proTxt = UICreate.createLabel(self.content, nil, 0, 126, self.width, 31, 18);
    self.proTxt.name = "proTxt";
    self.proTxt.anchorValue = 7;
    self.proTxt.pivotValue = 4;
    self.proTxt.alignmentValue = 4;
end

function Lua_LoadingScreenWindow:dispose()
	self:superCall("dispose");
end

function Lua_LoadingScreenWindow:showWin(param)
	self:superCall("showWin", param);

    if param == nil then
        param = Lua_LoadingScreenData.instance;
        if param == nil then
            return;
        end
    end

    if self.pb ~= nil then
        self.pb:setMaxValue(param.maxValue);
        self.pb:setValue(param.curValue);
    end

    local per = 1;
    if param.maxValue > 0 then
        per = Mathf.Floor(param.curValue * 100 / param.maxValue);
    end
    if param.str ~= nil then
        self.proTxt.text = LanUtil.formateStr(param.str, per);
    else
        self.proTxt.text = LanUtil.StringProfile3(per, "%");
    end

    if GlobalVar.bShowLoadingWinBg == true then
        if param.ltype == Lua_LoadingScreenData.LOADING_CODE or param.ltype == Lua_LoadingScreenData.LOADING_RES then
            if self._lastBg == nil then
                self.winBgPath = "/images/loading/" .. PlayerData.instance.phpData:getLoadingScreensStrByIdx(0);
                self._lastBg = self.winBgPath;
                self.winBg:setUrl(self.winBgPath, 99);
            end
            self.winBg:setEnable(true);
            self.tipsTxt:setEnable(false);
        elseif param.ltype == Lua_LoadingScreenData.LOADING_NOR then
            if LuaUtil.setRandomLoadingTipsShow(self.tipsTxt) == true then
                self.tipsTxt:setEnable(true);
            end

            if self._lastBg == nil then
                local str = PlayerData.instance.phpData:getLoadingScreensRandomStr();
                self._lastBg = "/images/loading/" .. str;
                self.winBgPath = self._lastBg;
                self.winBg:setUrl(self._lastBg, 99);
            end
            self.winBg:setEnable(true);
        end
    elseif param.ltype == Lua_LoadingScreenData.LOADING_LOGIN then
        self.winBg:setEnable(false);
        if LuaUtil.setRandomLoadingTipsShow(self.tipsTxt) == true then
            self.tipsTxt:setEnable(true);
        end
    else
        self.winBg:setEnable(false);
        self.tipsTxt:setEnable(false);
    end
end

function Lua_LoadingScreenWindow:onFielVersionLoaded(obj)
    local url = self.winBg.url;
    self.winBg:clearTexture();
    self.winBg:clearLoadRes();
    self.winBg:setUrl(url);
end