-- 创角界面
Lua_CreateRoleWindow = class("Lua_CreateRoleWindow", Lua_Window)
function Lua_CreateRoleWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_CreateRoleWindow";
    self.skinName = "CreateRoleWindow_skin";
    self.openSound = nil;
    self.closeSound = nil;
    self.showWinBg = true;
    self.isFullSizeWin = true;
    self.isFullSizeBg = true;
    self.isSingleShowWin = true;

    self.winBgPath = "/images/loading/xui_cjjs_bg_1.jpg";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
    self:addPreLoadRes("/images/loading/xui_cjjs_bg_2.png", Lua_LoadFileType.IMG);

    self.lastTime = 0;
    self.isRotState = false;
    self.startDir = 0;
    self.startMousePosX = 0;
    self.gender = 0;
end

function Lua_CreateRoleWindow:buildPanel(go)
    self:superCall("buildPanel", go);
    self:addLuaEvent("BACK_RANDOM_NAME", self, self.updateRandomName); -- 更新随机名
end

function Lua_CreateRoleWindow:buildShowItem()
    self:superCall("buildShowItem");
    DataCenter.gameReported:loginReportedData(Lua_GameReported.REPORT_ENTER_CREATEROLE_WIN);

    local nameLimit = Lua_CommonUtil.getCommonConfig("name_character_limit", 3)
    self.txtInput.characterLimit = nameLimit[2];
    self.txtInput.bCheckChinese = true;
    self.txtInput:addValidateInfo('A', 'Z');
    self.txtInput:addValidateInfo('a', 'z');
    self.txtInput:addValidateInfo('0', '9');
    self.txtInput:setDefaultLangValue(123723);
    
    self.btnRandom:addClickFuntion(self, self.onRandomClick);
    self.btnSure:addClickFuntion(self, self.onSureClick);
    self.maleIcon:addClickFuntion(self, self.onChooseMale);
    self.femaleIcon:addClickFuntion(self, self.onChooseFemale);
    
    -- AudioUtil.playCreateRoleMusic();
    Lua_WindowUtil.openWin("LoginBgWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_ServerListWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_ServerSelectWindow", Lua_WinParam.ACTION_CLOSE);
    -- Lua_WindowUtil.openWin("Lua_CreateRoleAniShowWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_LoadingScreenWindow", Lua_WinParam.ACTION_CLOSE);

    local min = Lua_ThingDefine.MALE * 100;
    local max = (Lua_ThingDefine.FEMALE + 1) * 100 - 1;
    local value = Mathf.Random(min, max);
    local gender = Mathf.Floor(value / 100);
    self:updateGender(gender);
end

function Lua_CreateRoleWindow:dispose()
    self:superCall("dispose");
end

--更新形象
function Lua_CreateRoleWindow:updateGender(value)
    if self.gender ~= value then
        self.gender = value;
        if value == Lua_ThingDefine.MALE then
            self.selectBg:setLocation(-112, 65, 0);
            self.selectIcon:setLocation(-112, 65, 0);
        else
            self.selectBg:setLocation(108, 65, 0);
            self.selectIcon:setLocation(108, 65, 0);
        end
        self:onRandomClick();
    end
end

--更新随机名字
function Lua_CreateRoleWindow:updateRandomName(str)
    self.txtInput.text = str;
end

function Lua_CreateRoleWindow:onChooseMale(go)
    self:updateGender(Lua_ThingDefine.MALE);
end

function Lua_CreateRoleWindow:onChooseFemale(go)
    self:updateGender(Lua_ThingDefine.FEMALE);
end

function Lua_CreateRoleWindow:onRandomClick(go)
    Lua_ProxyManager.getProxy("Lua_LoginProxy"):onRandomName(self.gender);
end

function Lua_CreateRoleWindow:onSureClick(go)
    local nameStr = self.txtInput.text;
    nameStr = string.gsub(nameStr, " ", "");
    nameStr = string.gsub(nameStr, "\n", "");
    nameStr = string.gsub(nameStr, "\r", "");
    
    if DataCenter.loginData:checkRoleNameIsInvalid(nameStr) then
        return;
    end

    local t = getTime();
    if t - self.lastTime < 3 then
        return;
    end
    self.lastTime = t;
    Lua_ProxyManager.getProxy("Lua_LoginProxy"):sCreateRole(nameStr, self.gender);
    DataCenter.gameReported:loginReportedData(Lua_GameReported.REPORT_CLICK_CREATEROLE_BTN);
    Lua_MsgUtil.callFunc("TRG_SINGLE_GUIDE", DataCenter.guideUtil.create_role_gid2);
end