-- 登录界面
Lua_LoginWindow = class("Lua_LoginWindow", Lua_Window);
function Lua_LoginWindow:ctor()
    self:superCall("ctor");
    
    self.windowName = "Lua_LoginWindow";
    self.skinName = "LoginWindow_skin";
    self.isFullSizeWin = true;
    self.openSound = nil;
    self.closeSound = nil;
end

function Lua_LoginWindow:buildShowItem()
    self:superCall("buildShowItem");

    GlobalVar.isInGame = 0;
    MsgUtil.callFunc("LOGIN_BG_CHANGE", "/images/loading/login_bg.jpg");

    self.versionTxt.text = LanUtil.formateStr(123729, PragramVersion.SHOW_VERSION);
    -- self.versionTxt.text = "<color=#ab9c89>为</color>\n[0x02|common_altas_1|ui_common_icon_40|39|36]*20";
    -- self.versionTxt.text = "为\n[0x02|common_altas_1|ui_common_icon_40|39|36]*20";
    -- self.versionTxt.alignmentValue = 0;
    -- self.versionTxt.verticalOverflowValue = 1;
    -- self.versionTxt:setLocation(-300, -500);
    
    self.accountInput.bCheckChinese = false;
    -- self.accountInput:addValidateInfo('A', 'Z');
    -- self.accountInput:addValidateInfo('a', 'z');
    -- self.accountInput:addValidateInfo('0', '9');
    if Lua_PlatformUtil.IsNoSdk() then
        self.accountInput:onEndEdit(self, self.onAccountInputEnd);
    end

    self.pwdInput.contentTypeValue = 7;
    self.pwdInput.bCheckChinese = false;
    self.pwdInput:addValidateInfo('A', 'Z');
    self.pwdInput:addValidateInfo('a', 'z');
    self.pwdInput:addValidateInfo('0', '9');
    
    self:addCSharpEvent(EventsDefine.PLAYER_SETUP_UPDATE, self, self.updateAccount);
    self:updateAccount();

    self.btnCleanCache:setEnable(true);
    self.btnCleanCache:addClickFuntion(self, self.onCleanCacheHandler);

    self.btnMessageLogin:setEnable(false);
    -- self.btnMessageLogin:setEnable(true);
    -- self.btnMessageLogin:addClickFuntion(self, self.onMessageLoginHandler);

    self.btnAutoCreateRole:setEnable(false);

    self.btnBlur:setEnable(true);
    self.btnBlur:setLocation(75, 350);
    self.btnBlur:addClickFuntion(self, self.onScreenShotBlurTest);

    self.btnLoadingType:setEnable(true);
    self.btnLoadingType:setLocation(75, 400);
    self.btnLoadingType.label = DataCenter.loginData.bLoadingVideoType and "视频加载" or "进度加载";
    self.btnLoadingType:addClickFuntion(self, self.onLoadingTypeHandler);

    if DataCenter.guideData.bOpenGuide then
        self.btnGudie.label = "关闭引导";
    else
        self.btnGudie.label = "开启引导";
    end
    self.btnGudie:setEnable(true);
    self.btnGudie:setLocation(75, 450);
    self.btnGudie:addClickFuntion(self, self.onGudieClick);

    self.btnLocalServer.label = DataCenter.loginData.bLocalServer and "本地列表" or "后台列表";
    self.btnLocalServer:setLocation(75, 500);
    self.btnLocalServer:addClickFuntion(self, self.onBtnLocalServerClick);

    self.registerText:setEnable(false)
    if Lua_PlatformUtil.IsBanShu() then
        self.registerText:setEnable(true)
        self.registerText:setLangValue(380021);
        self.registerText:resetSize();
        self.registerText:addUrlClickFuntion(self, self.onRegister);
    end

    -- 显示著作权信息
    if ServerConfig.bShowZhuzuoInfo then
        self.tipsTtile:setLangValue(123702);
        self.tipsDes:setLangValue(123703);
    else--健康公告
        self.tipsTtile:setLangValue(123700);
        self.tipsDes:setLangValue(123701);
    end
  	
    self.btnLogin:addClickFuntion(self, self.onStartClick);
  	Lua_WindowUtil.openWin("Lua_StartWindow", Lua_WinParam.ACTION_CLOSE);
  	Lua_WindowUtil.openWin("Lua_ServerSelectWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_LoginWindow:dispose()
    if self.shotImg ~= nil then
        self.shotImg:dispose();
        self.shotImg = nil;
    end
    self:superCall("dispose");
end

function Lua_LoginWindow:onAccountInputEnd()
    self.pwdInput.text = PlayerPrefsUtil.instance:getPassword(self.accountInput.text)
end

function Lua_LoginWindow:updateAccount()
    self.accountInput.text = PlayerPrefsUtil.instance:GetString(SetUpDefine.USERID, randomString(6, 9));
    self.pwdInput.text = PlayerPrefsUtil.instance:GetString(SetUpDefine.PASSWORD, "");
end

function Lua_LoginWindow:onScreenShotBlurTest()
    if self.shotImg == nil then
        self.shotImg = UICreate.createScreenShotBlurImg(self.content, 0, 0, 0, 0);
        self.shotImg.siblingIndex = 0;
    else
    	if self.shotImg ~= nil then
	        self.shotImg:dispose();
	        self.shotImg = nil;
	    end
    end
end

-- function Lua_LoginWindow:onMessageLoginHandler()
-- 	Lua_WindowUtil.openWin("Lua_LoginPhoneWindow", Lua_WinParam.ACTION_OPEN);
--     self:hide();
-- end

function Lua_LoginWindow:onLoadingTypeHandler()
    DataCenter.loginData.bLoadingVideoType = not DataCenter.loginData.bLoadingVideoType;
    self.btnLoadingType.label = DataCenter.loginData.bLoadingVideoType and "视频加载" or "进度加载";
end

function Lua_LoginWindow:onBtnLocalServerClick()
    DataCenter.loginData.bLocalServer = not DataCenter.loginData.bLocalServer;
    self.btnLocalServer.label = DataCenter.loginData.bLocalServer and "本地列表" or "后台列表";
end

function Lua_LoginWindow:onCleanCacheHandler()
    PlayerPrefsUtil.instance:DeleteAll();
    OperateAlert.show("清除成功！");
end

function Lua_LoginWindow:onGudieClick()
    if DataCenter.guideData.bOpenGuide then
        OperateAlert.show("引导已关闭");
        self.btnGudie.label = "开启引导";
        DataCenter.guideData.bOpenGuide = false;
    else
        OperateAlert.show("引导已开启");
        self.btnGudie.label = "关闭引导";
        DataCenter.guideData.bOpenGuide = true;
    end
end

function Lua_LoginWindow:onStartClick()
	local t = getTime();
    if self.clickTime ~= nil and t - self.clickTime < 0.3 then
        return;
    end
    self.clickTime = t;

    local nameStr = self.accountInput.text;
    if nameStr == nil then
        OperateAlert.showLangValue(123624);
        return;
    end

    nameStr = string.gsub(nameStr, " ", "");
    nameStr = string.gsub(nameStr, "\n", "");
    nameStr = string.gsub(nameStr, "\r", "");
    if nameStr == "" then
        OperateAlert.showLangValue(123624);
        return;
    end

    local password = self.pwdInput.text;
    if Lua_PlatformUtil.IsBanShu() then
        if strIsNullOrEmpty(password) then
            OperateAlert.showLangValue(380030);
            return;
        end
    end
    
    ServerConfig.userID = nameStr;
    PlayerPrefsUtil.instance:SetString(SetUpDefine.USERID, nameStr, false);
    PlayerPrefsUtil.instance:SetString(SetUpDefine.PASSWORD, password, false);
    if Lua_PlatformUtil.IsNoSdk() then
        PlayerPrefsUtil.instance:updateAccountInfo();
    end
    Lua_MsgUtil.callFunc("LOGIN_BACK_SEVER_SELECTED");
end

function Lua_LoginWindow:onRegister(urlStr)
    Lua_WindowUtil.openWin("Lua_RegisterWindow", Lua_WinParam.ACTION_OPEN, 380000);
end