-- 注册实名
Lua_RegisterWindow = class("Lua_RegisterWindow", Lua_Window);
function Lua_RegisterWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RegisterWindow";
	self.skinName = "RegisterWindow_skin";
	self.showBlackMask = true;
	self.winBgPath = "/images/common/ui_common_window_011.png"
	self.isClickClose = true;
	self.openSound = nil;
	self.closeSound = nil;
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_RegisterWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.pwShowHide = false;
	self.pwAgainShowHide = false;
	self.account_limit = Lua_CommonUtil.getCommonConfig("account_limit", 1, 12);
	self.password_limit = Lua_CommonUtil.getCommonConfig("password_limit", 3, {8, 16});
	self.name_limit = Lua_CommonUtil.getCommonConfig("name_limit", 1, 24);
	self.id_card_limit = Lua_CommonUtil.getCommonConfig("id_card_limit", 1, 24);
	self.age_limit = Lua_CommonUtil.getCommonConfig("age_limit", 1, 18);

	self.accountInput.characterLimit = self.account_limit;
	self.accountInput.bCheckChinese = false;
	self.accountInput:addValidateInfo('A', 'Z');
	self.accountInput:addValidateInfo('a', 'z');
	self.accountInput:addValidateInfo('0', '9');
	self.accountInput:setDefaultLangValue(380009)

	self.passwordInput.characterLimit = self.password_limit[2];
	self.passwordInput.contentTypeValue = 7;
	self.passwordInput.bCheckChinese = false;
	self.passwordInput:addValidateInfo('A', 'Z');
	self.passwordInput:addValidateInfo('a', 'z');
	self.passwordInput:addValidateInfo('0', '9');
	self.passwordInput:setDefaultLangValue(380010)

	self.pwAgainInput.characterLimit = self.password_limit[2];
	self.pwAgainInput.contentTypeValue = 7;
	self.pwAgainInput.bCheckChinese = false;
	self.pwAgainInput:addValidateInfo('A', 'Z');
	self.pwAgainInput:addValidateInfo('a', 'z');
	self.pwAgainInput:addValidateInfo('0', '9');

	self.nameInput.characterLimit = self.name_limit;
	-- self.nameInput.bCheckChinese = true;
	-- self.nameInput:addValidateInfo('A', 'Z');
	-- self.nameInput:addValidateInfo('a', 'z');
	-- self.nameInput:addValidateInfo('0', '9');
	self.nameInput:setDefaultLangValue(380011)

	self.idCardInput.characterLimit = self.id_card_limit;
	self.idCardInput.bCheckChinese = false;
	self.idCardInput:addValidateInfo('A', 'Z');
	self.idCardInput:addValidateInfo('a', 'z');
	self.idCardInput:addValidateInfo('0', '9');
	self.idCardInput:setDefaultLangValue(380012)

	self.desText:addUrlClickFuntion(self, self.onDesUrlClick);
	self.pwShowHide_1:addClickFuntion(self, self.onPwShowHide);
	self.pwShowHide_2:addClickFuntion(self, self.onPwShowHide);
	self.btnRegister:addClickFuntion(self, self.onRegister);
end

function Lua_RegisterWindow:dispose()
	self:superCall("dispose");
end

function Lua_RegisterWindow:showWin(param)
	self:superCall("showWin", param);
	if param == 380000 then
		self.accountInput.inputMouseEnable = true;
		self.passwordInput.inputMouseEnable = true;
		self.pwAgainInput.inputMouseEnable = true;
		self.nameInput.inputMouseEnable = true;
		self.idCardInput.inputMouseEnable = true;
	else
		self.accountInput.inputMouseEnable = false;
		self.passwordInput.inputMouseEnable = false;
		self.pwAgainInput.inputMouseEnable = false;
		self.nameInput.inputMouseEnable = false;
		self.idCardInput.inputMouseEnable = false;
	end
	self.desText:setLangValue(param);
	self.desText:resetSize();
end

function Lua_RegisterWindow:onDesUrlClick(urlStr)
	local arr = string.split(urlStr, "_")
	local param = {
		title = LanUtil.getValue(tonumber(arr[1])),
		des = LanUtil.getValue(tonumber(arr[2]))
	}
	Lua_WindowUtil.openWin("Lua_ContentTipsWindow", Lua_WinParam.ACTION_OPEN, param)
end

function Lua_RegisterWindow:onPwShowHide(go)
	if go.name == "pwShowHide_1" then
		self.pwShowHide = not self.pwShowHide;
		if self.pwShowHide then
			self.passwordInput.contentTypeValue = 4;
			self.pwShowHide_1:setAltas("login_atlas", "ui_fcm_label_02");
		else
			self.passwordInput.contentTypeValue = 7;
			self.pwShowHide_1:setAltas("login_atlas", "ui_fcm_label_01");
		end
		self.passwordInput:ForceLabelUpdate();
	else
		self.pwAgainShowHide = not self.pwAgainShowHide;
		if self.pwAgainShowHide then
			self.pwAgainInput.contentTypeValue = 4;
			self.pwShowHide_2:setAltas("login_atlas", "ui_fcm_label_02");
		else
			self.pwAgainInput.contentTypeValue = 7;
			self.pwShowHide_2:setAltas("login_atlas", "ui_fcm_label_01");
		end
		self.pwAgainInput:ForceLabelUpdate();
	end
end

function Lua_RegisterWindow:onRegister(go)
	local str = self.accountInput.text;
	if utf8.len(str) <= 0 then
		OperateAlert.showLangValue(380013);
		return;
	end

	str = self.passwordInput.text;
	if utf8.len(str) <= 0 then
		OperateAlert.showLangValue(380014);
		return;
	end

	if utf8.len(str) < self.password_limit[1] then
		OperateAlert.showLangValue(380016);
		return;
	end

	str = self.pwAgainInput.text;
	if utf8.len(str) <= 0 then
		OperateAlert.showLangValue(380015);
		return;
	end

	if str ~= self.passwordInput.text then
		OperateAlert.showLangValue(380017);
		return;
	end

	str = self.nameInput.text;
	if utf8.len(str) <= 0 then
		OperateAlert.showLangValue(380018);
		return;
	end

	if Lua_CommonUtil.checkIsInvalid(str, true, LanUtil.getValue(380034)) then
		return;
	end

	str = self.idCardInput.text;
	if utf8.len(str) <= 0 then
		OperateAlert.showLangValue(380019);
		return;
	end

	local param = { 
		uid = self.accountInput.text,
		password = self.pwAgainInput.text,
		v = PragramVersion.SHOW_VERSION,
		real_id = self.idCardInput.text,
		real_name = self.nameInput.text,
		package = ServerConfig.market,
		device = ServerConfig.device,
		sys_model = ServerConfig.sysModel,
		sys_version = ServerConfig.sysVersion,
		pefix_ext = DataCenter.sdkInterface.login_token
	 };
	local tokenStr = decodeTabToJson(param);
	UploadManager.getInstance():uploadPhpPost(UrlManager.prefixRequestRegisterStr, tokenStr, self, self.onRegisterSuccess, self.onRegisterError, true);
end

function Lua_RegisterWindow:onRegisterSuccess(text)
	if strIsNullOrEmpty(text) then
		self:onRegisterError();
		return;
	end

	local data = decodeJson(text);
	if data == nil then
		self:onRegisterError();
		return;
	end

	if data.code ~= nil then
		if tonumber(tostring(data.code)) ~= 1 and data.msg then
			self:onRegisterError(tostring(data.msg));
			return;
		end
	end

	local user = data["user"];
	if user == nil then
		self:onRegisterError();
		return;
	end

	if user.age == nil or user.age < self.age_limit then
		self:showMinorTips();
		return;
	end

	Lua_WindowUtil.openWin("Lua_AgeTipsWindow", Lua_WinParam.ACTION_OPEN);
    PlayerPrefsUtil.instance:SetString(SetUpDefine.USERID, self.accountInput.text, true);
    PlayerPrefsUtil.instance:SetString(SetUpDefine.PASSWORD, self.pwAgainInput.text, true);
	OperateAlert.showLangValue(380020);
	self:hide();
end

function Lua_RegisterWindow:onRegisterError(text)
	text = text == nil and LanUtil.getValue(380022) or text
	OperateAlert.show(text);
end

function Lua_RegisterWindow:showMinorTips()
	local tipsData = {
		titleAtlas = "login_atlas",
		titleSprite = "ui_fcm_title_01",
		des = LanUtil.getValue(380002),
		btnType = 4,
		owner = self,
		sureFun = self.onMinorTipsSureFun
	};
	Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_RegisterWindow:onMinorTipsSureFun()
	self:hide();
end