-- 登录服务器列表
checkRequire("Lua_ServerListItem");
checkRequire("Lua_ServerTitleItem");
checkRequire("Lua_MyServerListItem");
Lua_ServerListWindow = class("Lua_ServerListWindow", Lua_Window);
function Lua_ServerListWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_ServerListWindow";
    self.skinName = "ServerListWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
    self.openSound = nil;
    self.closeSound = nil;
end

function Lua_ServerListWindow:dispose()
    if self.serverList ~= nil then
        self.serverList:dispose();
        self.serverList = nil;
    end
    if self.titleList ~= nil then
        self.titleList:dispose();
        self.titleList = nil;
    end
    if self.myServerList ~= nil then
        self.myServerList:dispose();
        self.myServerList = nil;
    end
    self.serverData = nil;
    self:superCall("dispose");
end

function Lua_ServerListWindow:buildShowItem()
    self:superCall("buildShowItem");
    self:addLuaEvent("SELECTE_SERVER", self, self.onSelectedServer);
    self:addLuaEvent("SELECTE_SERVER_INDEX", self, self.onSelectIndex);
    GlobalVar.isInGame = 0;

    self.showDes:setLangValue(123721);
    self.showDes:setEnable(false);

    self.serverList = Lua_DragList.new(self.content, 362, 820, Lua_AxisDefine.Vertical);
    self.serverList:setLocation(123, -38);
    self.serverList:setListCell(Lua_ServerListItem, 362, 88, 1);
    self.serverList:setCellSpacing(0, 5);

    self.titleList = Lua_DragList.new(self.content, 220, 820, Lua_AxisDefine.Vertical);
    self.titleList:setLocation(-193.5, -38);
    self.titleList:setListCell(Lua_ServerTitleItem, 220, 88, 1);
    self.titleList:setCellSpacing(0, 5);

    self.myServerList = Lua_DragList.new(self.showObject, 362, 730, Lua_AxisDefine.Vertical);
    self.myServerList:setLocation(123, -78);
    self.myServerList:setListCell(Lua_MyServerListItem, 362, 88, 1);
    self.myServerList:setCellSpacing(0, 5);

    Lua_WindowUtil.openWin("Lua_StartWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_LoginWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_ServerListWindow:showWin(param)
    self:superCall("showWin", param);
    self.serverData = param;
    self:updateTitleList();
end

-- 更新左侧列表
function Lua_ServerListWindow:updateTitleList()
    if DataCenter.loginData.bLocalServer and self.serverData ~= nil then
        self.titleList:setArrayData(nil);
        self.serverList:setArrayData(self.serverData.localServerList);
        self.serverList:setEnable(true);
    else
        if self.serverData ~= nil and self.serverData.allZoneList:getSize() > 0 then
            local idx = 0;
            if self.serverData.myServerList:getSize() > 0 then -- 选中我的服务器
                if self.serverData.recommendServerList:getSize() > 0 then
                    idx = self.serverData.allZoneList[2].zone;
                else
                    idx = self.serverData.allZoneList[1].zone;
                end
            elseif self.serverData.recommendServerList:getSize() > 0 then
                idx = self.serverData.allZoneList[1].zone;
            else
                if self.serverData.selectServerData ~= nil then
                    idx = self.serverData.selectServerData.zone;
                else
                    local len = self.serverData.allZoneList:getSize();
                    idx = self.serverData.allZoneList[len].zone;
                end
            end
            self.titleList:setArrayData(self.serverData.allZoneList);
            self.titleList.canDrag = not self.titleList.isTheEnd;

            self:setSelectIndex(idx);
        end
    end
end

function Lua_ServerListWindow:onSelectIndex(idx)
    self:setSelectIndex(idx);
end

function Lua_ServerListWindow:setSelectIndex(idx)
    if self.serverData == nil then
        return;
    end

    if self._selectIdx == nil or self._selectIdx ~= idx then
        self._selectIdx = idx;
        local len = self.serverData.allZoneList:getSize();
        for i = 1, len do -- 更新左侧标题选中
            local sd = self.serverData.allZoneList[i];
            if sd ~= nil then
                sd.selected = sd.zone == idx; 
            end
        end
        self.titleList:updateShowList();

        self.showObject:SetActive(false); -- 默认不显示

        local list = nil;
        if self._selectIdx == 0 then -- 自己服务器
            list = self.serverData.myServerList;
            list:sort("login_time", true);
            self.myServerList:setArrayData(list);
            self.myServerList:moveToIndex(1, true);
            self.serverList:setEnable(false);

            if list:getSize() > 0 then
                local lastLoginServerData = list[1];
                self.stateIcon:setAltas("login_atlas", lastLoginServerData.stateIcon);
                self.prevName.text = lastLoginServerData.name;
                self.showObject:SetActive(true);
            end
        else
            if self._selectIdx == -1 then
                list = self.serverData.recommendServerList;
            else
                list = self.serverData.allServerDic[tostring(idx)]; -- 推荐服务器:其他服务器
            end

            list:sort("open_time", true);
            self.serverList:setArrayData(list);
            self.serverList:moveToIndex(1, true);
            self.serverList:setEnable(true);
        end

        self.showDes:setEnable(list == nil or list:getSize() <= 0);
    end
end

function Lua_ServerListWindow:onSelectedServer(obj)
    self.serverData.selectServerData = obj;
    self:hide();
end