-- 游戏开始界面
Lua_StartWindow = class("Lua_StartWindow", Lua_Window);
function Lua_StartWindow:ctor()
    self:superCall("ctor");
    
    self.windowName = "Lua_StartWindow";
    self.skinName = "StartWindow_skin";
    self.isFullSizeWin = true;
    self.openSound = nil;
    self.closeSound = nil;
end

function Lua_StartWindow:buildShowItem()
    self:superCall("buildShowItem");
    MsgUtil.callFunc(EventsDefine.FPS_UPDATE, 60); -- 暂时先恢复60帧
    DataCenter.gameReported:loginReportedData(Lua_GameReported.REPORT_STARTWINDOW);
    GlobalVar.isInGame = 0;

    self.versionTxt.text = LanUtil.formateStr(123729, PragramVersion.SHOW_VERSION);
    self.btnStart:addClickFuntion(self, self.onStartClick);

    -- 显示著作权信息
    if ServerConfig.bShowZhuzuoInfo then
        self.tipsTtile:setLangValue(123702);
        self.tipsDes:setLangValue(123703);
    else--健康公告
        self.tipsTtile:setLangValue(123700);
        self.tipsDes:setLangValue(123701);
    end

    checkRequire("tb_monster_player");
    checkRequire("tb_monster_player_t1");
    checkRequire("tb_monster");
    checkRequire("tb_monster_t1");

    DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.GetScreenHeight); -- 获取sdk屏幕刘海高度
    Lua_WindowUtil.openWin("Lua_AnnouncementWindow", Lua_WinParam.ACTION_CLOSE);
    -- Lua_WindowUtil.openWin("Lua_CreateRoleAniShowWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_CreateRoleWindow", Lua_WinParam.ACTION_CLOSE);
    -- Lua_WindowUtil.openWin("Lua_LoginPhoneWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_LoginWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_RegisterWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_ServerListWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_UserProtocolWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_ServerSelectWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_StartWindow:dispose()
    self:superCall("dispose");
end

function Lua_StartWindow:doShowWin()
	self:superCall("doShowWin");
    self:checkLogin();
end

function Lua_StartWindow:checkLogin()
    if DataCenter.loginData:checkUpdateApp() then
        return;
    end

    if not UrlManager.serverRes and not UrlManager.bInitRootPath then
        local formData = {
            func = "baseClientConfig",
            package = tostring(ServerConfig.market),
            v = PragramVersion.SHOW_VERSION
        };
        local tokenstr = decodeTabToJson(formData);
        DataCenter.gameReported:loginReportedData(Lua_GameReported.REPORT_BASECLIENTDATA_GET);
        UploadManager.getInstance():uploadPhpPost(UrlManager.prefixRequestReportUrl, tokenstr, self, self.onBaseClientDataLoaded, self.onBaseClientDataLoadErr, true);
        return;
    end

    -- 自动登录
    print("startWindow 自动登录 ");
    print("sh ", PlayerData.instance.phpData.bTishenServer, " init ", UrlManager.bInitRootPath);
    self:autoStartClick();
end

function Lua_StartWindow:onBaseClientDataLoaded(text)
    DataCenter.gameReported:loginReportedData(Lua_GameReported.REPORT_BASECLIENTDATA_SUCCESS);
    if strIsNullOrEmpty(text) then
        UrlManager.serverRootPath = ""; -- 已初始化
    else
        local data = decodeJson(text);
        if data ~= nil then
            if data.closeDebugLog ~= nil then LogManager.bOpenDebugLog = data.closeDebugLog == 0; end
            if data.buglyAppId ~= nil then ServerConfig.buglyAppId = data.buglyAppId; end
            PlayerData.instance.phpData:updatePhpConfigInfo(PlayerData.phpConfigKey, text);
            UrlManager.serverRootPath = (data.cdnRootPath == nil) and "" or data.cdnRootPath;
            ServerConfig.bShowZhuzuoInfo = (data.is_copyright ~= nil) and (data.is_copyright == 1) or false;
            ServerConfig.isSecret = (data.isSecret ~= nil) and (data.isSecret == 1) or false;
            ServerConfig.protocolUrl = data.user_protocol;
            ServerConfig.privacyUrl = data.user_secret;
        else
            UrlManager.serverRootPath = ""; -- 已初始化
        end
    end

    -- 重新检测更新
    self:hide();
    SDKInterface.InitBugly();
    LoadManager.getInstance():clearResource();
    LuaUtil.checkUpdate(); -- 重新检测更新
end

function Lua_StartWindow:onBaseClientDataLoadErr(text)
    DataCenter.gameReported:loginReportedData(Lua_GameReported.REPORT_BASECLIENTDATA_FAIL);
    local tipsData = {};
    tipsData.des = LangDefine.getValue(14); --文本描述
    tipsData.btnType = 4;
    tipsData.sureLabel = LangDefine.getValue(1);
    tipsData.owner = self;
    tipsData.sureFun = self.onRestartCancel;
    tipsData.cancelFun = self.onRestartCancel;
    Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_StartWindow:onRestartCancel()
    self:checkLogin();
end

function Lua_StartWindow:autoStartClick()
    if strIsNullOrEmpty(DataCenter.sdkInterface.login_token) then
        self:onStartClick();
    else 
        Lua_MsgUtil.callFunc("LOGIN_BACK_SEVER_SELECTED");
    end
end

function Lua_StartWindow:onStartClick()
    if DataCenter.loginData:checkUpdateApp() then
        return;
    end

    if Lua_PlatformUtil.IsNoSdk() then
        self:ToLoginPanel();
    else
        self:onDelayLogin();
    end
end

function Lua_StartWindow:onDelayLogin()
	if Lua_PlatformUtil.IsAndroid() or Lua_PlatformUtil.IsIPhonePlayer() then
        print("startWindow SDKInterface Login");
        DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.Login);
	else
        -- 打开手机号码登录验证
        print("startWindow 打开手机号码登录验证 ");
        Lua_WindowUtil.openWin("LoginPhoneWindow", Lua_WinParam.ACTION_OPEN);
        self:hide();
	end
end

function Lua_StartWindow:ToLoginPanel()
    if NoServerUtil.noServer then -- 本地测试
        DataCenter.loginData:enterLocalGame();
        self:hide();
        return;
    end

    self:hide();
    Lua_WindowUtil.openWin("Lua_LoginWindow", Lua_WinParam.ACTION_OPEN);
end