-- 用户协议界面
Lua_UserProtocolWindow = class("Lua_UserProtocolWindow", Lua_Window)
function Lua_UserProtocolWindow:ctor()
    self:superCall("ctor");
    
    self.windowName = "Lua_UserProtocolWindow";
    self.skinName = "UserProtocolWindow_skin";
    self.showBlackMask = true;
    -- self.isClickClose = true;
    self.openSound = nil;
    self.closeSound = nil;
end

function Lua_UserProtocolWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.btnSure:addClickFuntion(self, self.hide);

    self.contentList = Lua_DragContainer.new(self.content, 500, 700, Lua_AxisDefine.Vertical)
    self.contentList:setLocation(0, 15, 0)
end

function Lua_UserProtocolWindow:dispose()
    if self.contentList ~= nil then
        self.contentList:dispose();
        self.contentList = nil;
    end
    self:superCall("dispose");
end

function Lua_UserProtocolWindow:showWin(param)
    self:superCall("showWin", param);

    self.contentList:clearList();
    if param == "user_protocol" then
        self.titelName:setLangValue(123708);
        self.contentList:addSubContainer(Lua_UserProtocolItem, 123735, true);
    elseif param == "user_secret" then
        self.titelName:setLangValue(123709);
        self.contentList:addSubContainer(Lua_UserProtocolItem, 123736, true);
    end
    self.contentList.canDrag = not self.contentList.isTheEnd;
    self.contentList:moveToIndex(1, true);
end










Lua_UserProtocolItem = class("Lua_UserProtocolItem", Lua_DragContainerItem)
function Lua_UserProtocolItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_UserProtocolItem:buildShowItem()
    self:superCall("buildShowItem");

    self.tipsText = UICreate.createLabel(self.content, nil, 0, 0, 500, 0, 20);
    self.tipsText.verticalOverflowValue = 1;
    self.tipsText.colorStr = Lua_ColorDefine.transColorStr("7A7A7A");
end

function Lua_UserProtocolItem:dispose()
    self:superCall("dispose");
end

function Lua_UserProtocolItem:getWidth()
    return self.tipsText.width;
end

function Lua_UserProtocolItem:getHeight()
    return self.tipsText.height;
end

function Lua_UserProtocolItem:setData(data)
    self.tipsText:setLangValue(data);
    self.tipsText:resetSize();
end