-- 登录创角动画数据
checkRequire("Lua_CreateRoleAniVo");
Lua_CreateRoleAniData = class("Lua_CreateRoleAniData");
Lua_CreateRoleAniData.CREATEROLE_DIALOGTYPE_NORMAL = 0;
Lua_CreateRoleAniData.CREATEROLE_DIALOGTYPE_BUBBLES = 1;
function Lua_CreateRoleAniData:ctor()
	self:superCall("ctor");

end

function Lua_CreateRoleAniData:dispose()
	self:resetData();
end

function Lua_CreateRoleAniData:resetData()
	if self._actionList ~= nil and self._actionDic ~= nil then
        local len = self._actionList:getSize();
        for i = 1, len do
            local idx = self._actionList[i];
            if self._actionDic[idx] ~= nil then
                local listLen = self._actionDic[idx]:getSize();
                for j = 1, listLen do
                    self._actionDic[idx][j].bPlayOver = false;
                end
            end
        end
    end
end

function Lua_CreateRoleAniData.Get:actionList()
	if self._actionList == nil then
        self:initActionInfo();
    end
    return _actionList;
end

function Lua_CreateRoleAniData.Get:preLoadActionRes()
    local vo = self:getActionVoByIdx(1);
    return vo == nil and "" or vo.srcUrl;
end

function Lua_CreateRoleAniData:getActionVoByIdx(idx)
    if idx < 1 or self.actionList:getSize() < idx then
        return nil;
    end

    idx = self.actionList[idx];
    if self._actionDic[idx] ~= nil and self._actionDic[idx]:getSize() > 0 then
        return self._actionDic[idx][1];
    end
    return nil;
end

function Lua_CreateRoleAniData:getListByIdx(idx)
    if idx < 1 or self.actionList:getSize() < idx then
        return nil;
    end

    idx = self.actionList[idx];
    return self._actionDic[idx];
end

function Lua_CreateRoleAniData:initActionInfo()
    if self._actionList ~= nil and self._actionDic ~= nil then
        return;
    end

    self._actionDic = {};
    self._actionList = Array();
    local cfg = getConfig("createRoleAction");
    if cfg == nil then
    	return;
    end

    local vo;
    local actionId;
	for k, v in pairs(config) do
		vo = Lua_CreateRoleAniVo.new(v);
		actionId = vo.actionId;
		if self._actionDic[actionId] == nil then
			self._actionDic[actionId] = Array();
			self._actionList:add(actionId);
		end
		self._actionDic[actionId]:add(vo);
	end

	self._actionList:sortf(self, self.actionListSortFun);
	local len = self._actionList:getSize();
	for i = 1, len do
		actionId = self._actionList[i];
		self._actionDic[actionId]:sort("startTime", false);
	end
end

function Lua_CreateRoleAniData:actionListSortFun(a, b)
	if a > b then
		return false;
	end
	return true;
end