-- 登录创角动画数据
Lua_CreateRoleAniVo = class("Lua_CreateRoleAniVo");
function Lua_CreateRoleAniVo:ctor(cfg)
	self:superCall("ctor");
	self.bPlayOver = false;
	self.config = cfg;
end

function Lua_CreateRoleAniVo:dispose()
	self.config = nil;
	self.bPlayOver = false;
end

function Lua_CreateRoleAniVo.Get:actionId()
	if self.config == nil or self.config.actionId == nil then
		return 0;
	end
	return self.config.actionId;
end

function Lua_CreateRoleAniVo.Get:endType()
	if self.config == nil or self.config.endType == nil then
		return 0;
	end
	return self.config.endType;
end

function Lua_CreateRoleAniVo.Get:countTime()
	if self.config == nil or self.config.countTime == nil then
		return 0;
	end
	return self.config.countTime;
end

function Lua_CreateRoleAniVo.Get:srcUrl()
	if self.config == nil or self.config.srcUrl == nil then
		return nil;
	end

	if self._srcUrl == nil then
		local str = self.config.srcUrl;
		if LanUtil.IsNullOrEmpty(str) ~= true then
			self._srcUrl = UrlManager.fixFileSuffix(str);
		end
	end
	return self._srcUrl;
end

function Lua_CreateRoleAniVo.Get:modelName()
	if self.config == nil or self.config.modelName == nil then
		return nil;
	end
	return self.config.modelName;
end

function Lua_CreateRoleAniVo.Get:actionName()
	if self.config == nil or self.config.actionName == nil then
		return nil;
	end
	return self.config.actionName;
end

function Lua_CreateRoleAniVo.Get:startTime()
	if self.config == nil or self.config.startTime == nil then
		return 0;
	end
	return self.config.startTime;
end

function Lua_CreateRoleAniVo.Get:dialogType()
	if self.config == nil or self.config.dialogType == nil then
		return 0;
	end
	return self.config.dialogType;
end

function Lua_CreateRoleAniVo.Get:dialogStr()
	if self.config == nil or self.config.dialog == nil then
		return "";
	end
	return self.config.dialog;
end

function Lua_CreateRoleAniVo.Get:dialogTime()
	if self.config == nil or self.config.dialogTime == nil then
		return 0;
	end
	return self.config.dialogTime;
end

function Lua_CreateRoleAniVo.Get:renderQueue()
	if self.config == nil or self.config.renderQueue == nil then
		return 0;
	end
	return self.config.renderQueue;
end

function Lua_CreateRoleAniVo.Get:dialogSpd()
	if self.config == nil or self.config.dialogSpd == nil then
		return 0;
	end
	return self.config.dialogSpd;
end

function Lua_CreateRoleAniVo.Get:dialogColor()
	if self.config == nil or self.config.dialogColor == nil then
		return nil;
	end
	return self.config.dialogColor;
end

function Lua_CreateRoleAniVo.Get:hangerTime()
	if self.config == nil or self.config.hangerTime == nil then
		return 0;
	end
	return self.config.hangerTime;
end

function Lua_CreateRoleAniVo.Get:bShowSkipBtn()
	if self.config == nil or self.config.skipBtnState == nil then
		return false;
	end
	return self.config.skipBtnState > 0;
end

function Lua_CreateRoleAniVo.Get:bShowSureBtn()
	if self.config == nil or self.config.sureBtnState == nil then
		return false;
	end
	return self.config.sureBtnState > 0;
end

function Lua_CreateRoleAniVo.Get:bShowCancleBtn()
	if self.config == nil or self.config.cancleBtnState == nil then
		return false;
	end
	return self.config.cancleBtnState > 0;
end

function Lua_CreateRoleAniVo.Get:bShowBlackBg()
	if self.config == nil or self.config.blackBgState == nil then
		return false;
	end
	return self.config.blackBgState > 0;
end


function Lua_CreateRoleAniVo.Get:dialogPos()
	if self._dialogPos == nil then
		local px = (self.config ~= nil and self.config.dialogPos ~= nil and #self.config.dialogPos > 0) and self.config.dialogPos[1] or 0;
		local py = (self.config ~= nil and self.config.dialogPos ~= nil and #self.config.dialogPos > 1) and self.config.dialogPos[2] or 0;
		self._dialogPos = Vector2(px, py);
	end
	return self._dialogPos;
end

function Lua_CreateRoleAniVo.Get:hangerPos()
	if self._hangerPos == nil then
		local px = (self.config ~= nil and self.config.hangerPos ~= nil and #self.config.hangerPos > 0) and self.config.hangerPos[1] or 0;
		local py = (self.config ~= nil and self.config.hangerPos ~= nil and #self.config.hangerPos > 1) and self.config.hangerPos[2] or 0;
		self._hangerPos = Vector2(px, py);
	end
	return self._hangerPos;
end

function Lua_CreateRoleAniVo.Get:addMusicList()
	if self._addMusicList == nil then
		self._addMusicList = Array();
		if self.config ~= nil and self.config.addMusic ~= nil then
			for i = 1, #self.config.addMusic do
				self._addMusicList:add(self.config.addMusic[i]);
			end
		end
	end
	return self._addMusicList;
end

function Lua_CreateRoleAniVo.Get:removeMusicList()
	if self._removeMusicList == nil then
		self._removeMusicList = Array();
		if self.config ~= nil and self.config.removeMusic ~= nil then
			for i = 1, #self.config.removeMusic do
				self._removeMusicList:add(self.config.removeMusic[i]);
			end
		end
	end
	return self._removeMusicList;
end