-- 游戏数据上报
Lua_GameReported = class("Lua_GameReported");
Lua_GameReported.REPORT_CODEUPDATE_START = 1000; --codeupdate启动，暂无设备信息
Lua_GameReported.REPORT_PHONE_DEVICE_INFO = 1100; --设备信息
Lua_GameReported.REPORT_GAMEENTER_START = 1200; --gameenter启动，暂无设备信息
Lua_GameReported.REPORT_BASECLIENTDATA_GET = 1300; --客户端基础信息获取，可能暂无设备信息
Lua_GameReported.REPORT_BASECLIENTDATA_SUCCESS = 1400; --客户端基础信息获取成功
Lua_GameReported.REPORT_BASECLIENTDATA_FAIL = 1500; --客户端基础信息获取失败
Lua_GameReported.REPORT_CHECKUPDATE = 1600; --开始检测更新
Lua_GameReported.REPORT_UPDATEEND = 1700; --更新完成
Lua_GameReported.REPORT_STARTWINDOW = 1800; --进入游戏开始界面
Lua_GameReported.REPORT_SDK_LOGIN_SUCCESS = 1900; --sdk登录成功
Lua_GameReported.REPORT_SDK_CHANGEUSER = 2000; --sdk切换用户
Lua_GameReported.REPORT_SDK_LOGOUT = 2100; --sdk注销用户
Lua_GameReported.REPORT_GET_SERVERLIST = 2200; --获取服务器列表
Lua_GameReported.REPORT_GET_SERVERLIST_SUCCESS = 2300; --获取服务器列表成功
Lua_GameReported.REPORT_GET_SERVERLIST_FAIL = 2400; --获取服务器列表失败
Lua_GameReported.REPORT_ENTER_SERVERSELECT_WIN = 2500; --进入选服界面
Lua_GameReported.REPORT_CLICK_SERVERSELECTWIN_ENTERBTN = 2600; --点击选服界面开始游戏按钮
Lua_GameReported.REPORT_LINK_VALIDATION_SOCKET = 2700; --连接验证服socket
Lua_GameReported.REPORT_LINK_VALIDATION_SOCKET_SUCCESS = 2800; --连接验证服socket成功
Lua_GameReported.REPORT_LINK_VALIDATION_SOCKET_FAIL = 2900; --连接验证服socket失败
Lua_GameReported.REPORT_LINK_MAIN_SOCKET = 3000; --连接服务器socket
Lua_GameReported.REPORT_LINK_MAIN_SOCKET_SUCCESS = 3100; --连接服务器socket成功
Lua_GameReported.REPORT_LINK_MAIN_SOCKET_FAIL = 3200; --连接服务器socket失败
Lua_GameReported.REPORT_PLAYERINFO_GET = 3300; --服务器玩家信息下发
Lua_GameReported.REPORT_ENTER_GAME_SCENE = 3400; --进入游戏；
Lua_GameReported.REPORT_ENTER_CREATEROLE_WIN = 3500; --创角界面打开
Lua_GameReported.REPORT_CLICK_CREATEROLE_BTN = 3600; --点击创角
function Lua_GameReported:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_GameReported:dispose()
	
end

--登录部分上报游戏数据
function Lua_GameReported:loginReportedData(pos)
	local postData = {
		func = "device",
		package = ServerConfig.market,
		channel = ServerConfig.channel,
		account = ServerConfig.userID == nil and "" or ServerConfig.userID,
		location = pos,
		custom_device = SDKInfo.CustomDevice,
		mac = ServerConfig.mac,
		device = ServerConfig.device,
		sys_model = ServerConfig.sysModel,
		sys_version = ServerConfig.sysVersion
	};
    local tokenstr = decodeTabToJson(postData);
    UploadManager.getInstance():uploadPhpPost(UrlManager.prefixRequestReportUrl, tokenstr);
end

-- 获取后台客户端信息
-- clickType 1，用户协议；2，隐私政策；
-- function Lua_GameReported:getClientInfoByPhp(clickType)
--     local formData = {
--     	func = "baseClientConfig",
--     	package = tostring(ServerConfig.market),
--     	user_click = clickType
--     };
--     local tokenstr = decodeTabToJson(formData);
--     UploadManager.getInstance():uploadPhpPost(UrlManager.prefixRequestReportUrl, tokenstr, tostring(clickType), self, self.onClientInfoLoaded, self.onClientInfoLoadErr, true);
-- end

-- function Lua_GameReported:onClientInfoLoaded(text, sign)
-- 	if text ~= nil and text ~= "" and sign ~= nil then
-- 		local dic = decodeJson(text);
-- 		if dic ~= nil then
-- 			local infoStr = nil;
-- 			local clickType = tonumber(tostring(sign));
-- 			if clickType == 1 then
-- 		        if dic.user_protocol ~= nil then
-- 		            infoStr = tostring(dic.user_protocol);
-- 		        end
-- 		    elseif clickType == 2 then
-- 		    	if dic.user_secret ~= nil then
-- 		            infoStr = tostring(dic.user_secret);
-- 		        end
-- 		    end

-- 		    if LanUtil.IsNullOrEmpty(infoStr) ~= true then
-- 		    	Lua_WindowUtil.openWin("Lua_UserProtocolWindow", Lua_WinParam.ACTION_OPEN, infoStr);
-- 		    end
-- 		end
-- 	end
-- end

-- function Lua_GameReported:onClientInfoLoadErr(text, sign)
--     LogManager.LogError("====== onClientInfoLoadErr ======"..text, true);
-- end

-- 上报玩家信息
-- Lua_SDKMessageType.UpdatePlayerInfo_SyncInfo = 0; -- 除外等级变化的玩家更新（绕不清楚找sdk）
-- Lua_SDKMessageType.UpdatePlayerInfo_CreateRole = 1; -- 创角
-- Lua_SDKMessageType.UpdatePlayerInfo_EnterGame = 2; -- 进入游戏
-- Lua_SDKMessageType.UpdatePlayerInfo_PlayerUpdate = 3; -- 玩家更新
-- Lua_SDKMessageType.UpdatePlayerInfo_UnCreateRole_PlayerUpdate = 4; -- 未创角玩家更新或进入游戏（绕不清楚找sdk）
function Lua_GameReported:UpdatePlayerInfo(reportType)
	-- print("Lua_GameReported UpdatePlayerInfo", reportType);
	if not Lua_PlatformUtil.IsWindowsEditor() then
	    local dic = {};
	    local data = DataCenter.roleData;
	    if not DataCenter.loginData.isCreateRole then -- 未创角玩家更新或进入游戏（绕不清楚找sdk）
	    	reportType = Lua_SDKMessageType.UpdatePlayerInfo_UnCreateRole_PlayerUpdate;
	    elseif reportType ~= Lua_SDKMessageType.UpdatePlayerInfo_CreateRole 
	    	and self.roleLevel ~= nil 
	    	and data.level == self.roleLevel then -- 创角后除外等级变化的玩家更新（绕不清楚找sdk）
		    reportType = Lua_SDKMessageType.UpdatePlayerInfo_SyncInfo;
	    end
	    self.roleLevel = data.level;
	    dic.reportType = reportType;
	    dic.serverId = ServerConfig.serverId;
	    dic.serverSign = data.server_flag;
		dic.serverName = data.server_name;
	    dic.roleId = data.roleId;
	    dic.roleName = data.name;
	    dic.level = data.level;
	    dic.roleCTime = data.createRoleTime;
	    dic.guildId = data.league_id;
	    dic.guildName = data.league_name;
	    dic.balance = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.DIAMOND);
	    dic.vip = data.vip;
	    dic.strength = data.force;
	    dic.isCreateRole = DataCenter.loginData.isCreateRole;
	    local playerInfo = decodeTabToJson(dic);
	    DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.UpdatePlayerInfo, playerInfo);
	    if reportType == Lua_SDKMessageType.UpdatePlayerInfo_CreateRole then -- sdk要求创角后调用玩家进入游戏的上报
	    	dic.reportType = Lua_SDKMessageType.UpdatePlayerInfo_EnterGame;
	    	playerInfo = decodeTabToJson(dic);
		    DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.UpdatePlayerInfo, playerInfo);
		end
	end
end