--登录单个服务器数据
checkRequire("Lua_ServerRoleData");
Lua_OneServerData = class("Lua_OneServerData");
function Lua_OneServerData:ctor(config)
	self:superCall("ctor");
    self.config = config;
end

function Lua_OneServerData:getStringValue(str)
	if str == nil or str == "" then
		return nil;
	end

	str = self.config[str];
	if str ~= nil then
		return tostring(str);
	end
    return nil;
end

function Lua_OneServerData:getIntValue(str)
	if str == nil or str == "" then
		return 0;
	end

	str = self.config[str];
	if str ~= nil then
		return tonumber(tostring(str));
	end
    return 0;
end

function Lua_OneServerData.Get:domain()
    return self:getStringValue("domain");
end

function Lua_OneServerData.Get:name()
    return self:getStringValue("name");
end

function Lua_OneServerData.Get:real_server_name()
    return self:getStringValue("real_server_name");
end

function Lua_OneServerData.Get:is_create()
    return self:getIntValue("is_create");
end

function Lua_OneServerData.Get:is_create_role()
    return self:getIntValue("is_create_role");
end

function Lua_OneServerData.Get:flag()
    return self:getStringValue("flag");
end

function Lua_OneServerData.Get:server_addr()
    return self:getStringValue("server_addr");
end

function Lua_OneServerData.Get:server_port()
    return self:getIntValue("server_port");
end

function Lua_OneServerData.Get:chat_addr()
    return self:getStringValue("chat_addr");
end

function Lua_OneServerData.Get:text()
    return self:getStringValue("text");
end

function Lua_OneServerData.Get:sign()
    return self:getStringValue("sign");
end

function Lua_OneServerData.Get:open_time()
    if self._open_time == nil then
        local timeStr = self:getStringValue("open_time");
        -- if timeStr ~= nil and string.len(timeStr) > 0 then
        --     self._open_time = TimeTransform.getInstance():getTimeTicks(tonumber(tostring(timeStr)));
        -- end
        if strIsNullOrEmpty(timeStr) then
            self._open_time = 0;
        else
            self._open_time = tonumber(timeStr);
        end
    end
    return self._open_time;
end

function Lua_OneServerData.Get:defaultV()
    return self:getIntValue("default");
end

function Lua_OneServerData.Get:chat_port()
    return self:getIntValue("chat_port");
end

function Lua_OneServerData.Get:login_time()
	return self.showRoleData.login_time;
end

function Lua_OneServerData.Get:roleList()
	if self._roleList == nil then
		self._roleList = Array();
        if self.is_create_role == 1 then
            local list = self.config.role_list;
            if list ~= nil and #list > 0 then
                for i = 1, #list do
                	local obj = list[i];
                    local roleData = Lua_ServerRoleData.new();
                    roleData.role_name = tostring(obj.role_name);
                    roleData.role_id = tonumber(tostring(obj.role_id));
                    roleData.level = tonumber(tostring(obj.level));
                    roleData.avatar = tonumber(tostring(obj.avatar));
                    roleData.login_time = tonumber(tostring(obj.login_time));
                    self._roleList:add(roleData);
                end
            end
        end
        self._roleList:sort("login_time", true);
	end
	return self._roleList;
end

function Lua_OneServerData.Get:showRoleData()
    if self.showRole == nil then
        if self.roleList ~= nil and self.roleList:getSize() > 0 then
            self.showRole = self.roleList[1];
        else
            self.showRole = Lua_ServerRoleData.new();
        end
    end
    return self.showRole;
end

function Lua_OneServerData.Get:is_show()
    return self:getIntValue("is_show");
end

-- 暂时无效
function Lua_OneServerData.Get:online()
    return self:getIntValue("online");
end

-- -1:维护 0:未开服 2:流畅 4:火爆
function Lua_OneServerData.Get:status()
    return self:getIntValue("status");
end

-- 1:新服 2:推荐 3:无
function Lua_OneServerData.Get:ad_status()
    if self.status ~= 2 then
        return 3;
    end
	return self:getIntValue("ad_status");
end

function Lua_OneServerData.Get:max_online()
    return self:getIntValue("max_online");
end

function Lua_OneServerData.Get:max_online()
    return self:getIntValue("max_online");
end

function Lua_OneServerData.Get:zone()
    return self:getIntValue("zone");
end

function Lua_OneServerData.Get:tick()
    return self:getIntValue("tick");
end

function Lua_OneServerData.Get:sort()
    return self:getIntValue("sort");
end

function Lua_OneServerData.Get:is_account_create()
    return self:getIntValue("is_account_create");
end

-- -1:维护 0:未开服 2:流畅 4:火爆
function Lua_OneServerData.Get:stateIcon()
    if self.status == -1 or self.status == 0 then
        return "xui_cjjs_label_3";
    elseif self.status == 4 then
        return "xui_cjjs_label_1";
    end
    return "xui_cjjs_label_2";
end

-- -1:维护 0:未开服 2:流畅 4:火爆
function Lua_OneServerData.Get:stateLangId()
    if self.status == -1 then
        return 123707;
    elseif self.status == 0 then
        return 123734;
    elseif self.status == 4 then
        return 123705;
    end
    return 123706;
end

-- 分服热更资源目录
function Lua_OneServerData.Get:resRoot()
    return self:getStringValue("resRoot");
end