-- 预加载资源数据
Lua_PreLoadResInfo = class("Lua_PreLoadResInfo")
function Lua_PreLoadResInfo:ctor()
	self:superCall("ctor");
	self.resType = -1; -- 资源类型
	self.resName = nil; -- 资源名
	self._keepTime = nil; -- 自动释放时间
	self.openSceneId = 0; -- 打开场景id
	self._fightRecordId = 0; -- 战斗id
	self.sortValue = 0; -- 排序权重
end

function Lua_PreLoadResInfo.Get:fightRecordId()
	return self._fightRecordId;
end

function Lua_PreLoadResInfo.Set:fightRecordId(val)
	if val == nil then val = 0; end
	self._fightRecordId = val;
end

function Lua_PreLoadResInfo.Get:keepTime()
	if self._keepTime == nil then
		if self.resType == Lua_LoadFileType.ATLAS then
            self._keepTime = 30;
        elseif self.resType == Lua_LoadFileType.IMG then
            self._keepTime = 60;
        elseif self.resType == Lua_LoadFileType.UNITY3D then
            self._keepTime = 30;
        elseif self.resType == Lua_LoadFileType.AUDIO then
            self._keepTime = 30;
        elseif self.resType == Lua_LoadFileType.MATS then
            self._keepTime = 60;
        elseif self.resType == Lua_LoadFileType.LUA then
            self._keepTime = 60;
        else
        	self._keepTime = 60;
        end
	end
	return self._keepTime;
end

function Lua_PreLoadResInfo.Set:keepTime(val)
	if val ~= nil then
		if isNumber(val) ~= true then
			val = nil;
		elseif val < 0 then
			val = -1;
		else
			val = Mathf.Ceil(val);
		end
	end
	self._keepTime = val;
end

function Lua_PreLoadResInfo.Get:url()
	if self._url == nil and self.resType ~= nil and not strIsNullOrEmpty(self.resName) then
		if self.resType == Lua_LoadFileType.ATLAS then
			self._url = LanUtil.StringProfile("/uiatlas/", UrlManager.fixFileSuffix(self.resName));
		elseif self.resType == Lua_LoadFileType.IMG then
			self._url = self.resName;
		elseif self.resType == Lua_LoadFileType.UNITY3D then
			self._url = UrlManager.fixFileSuffix(self.resName);
		elseif self.resType == Lua_LoadFileType.AUDIO then
			self._url = UrlManager.fixFileSuffix(self.resName);
		elseif self.resType == Lua_LoadFileType.MATS then
			self._url = UrlManager.fixFileSuffix(self.resName);
		elseif self.resType == Lua_LoadFileType.LUA then
			self._url = UrlManager.getLuaPath(self.resName);
		elseif self.resType == Lua_LoadFileType.LIGHTMAP then
			self._url = UrlManager.fixFileSuffix(self.resName);
		elseif self.resType == Lua_LoadFileType.PLAYABLE then
			self._url = UrlManager.fixFileSuffix(self.resName);
		else
			self._url = self.resName;
		end
	end
	return self._url;
end