-- 预加载数据类
Lua_PreLoadVo = class("Lua_PreLoadVo")
function Lua_PreLoadVo:ctor()
	self:superCall("ctor");
	self:clean();
end

function Lua_PreLoadVo:clean()
	self.loadType = Lua_PreLoadDefine.LOADSHOW_TYPE_NONE;
	self.signStr = nil; -- 标识，界面以窗口名为sign
	self.tab = nil; 
	self.fun = nil;
	self.param = nil;
	self._loadList = nil; -- 预加载资源
	self.resCount = 0;
	self.loadCountNum = 0;
	self.curValue = 0; -- 当前进度
	self._showHeroVo = nil; -- 当前展示模型vo
	self._loadTips = nil;
	self._addStep = nil;
	self._maxValue = nil;
	self.bModelLoaded = false;
	self.loadCountTime = 0;
	self.loadState = 1; -- -1 失败，1 成功
	self:disposeModelScene();
end

function Lua_PreLoadVo:disposeModelScene()
	if self.modelScenePanel ~= nil then
		self.modelScenePanel:dispose();
		self.modelScenePanel = nil;
	end
end

-- 是否加载完成
function Lua_PreLoadVo.Get:isSuccess()
	return self.loadState == 1;
end

-- 执行回调
function Lua_PreLoadVo:executeCallBack()
	if self.tab == nil or self.fun == nil then
		self.tab = nil;
		self.fun = nil;
		return;
	end

	self.fun(self.tab, self.param, self.modelScenePanel, self.isSuccess);
	self.modelScenePanel = nil; -- 给到回调逻辑去销毁，如未回调完成会在clean时候销毁
end

function Lua_PreLoadVo.Get:loadTips()
	if self._loadTips == nil then
		self._loadTips = LanUtil.getValue(107705);
	end
	return self._loadTips;
end

function Lua_PreLoadVo.Set:loadTips(val)
	self._loadTips = val;
end

function Lua_PreLoadVo.Get:loadList()
	return self._loadList;
end

function Lua_PreLoadVo.Set:loadList(val)
	self._loadList = val;
	if val ~= nil then
		self.resCount = val:getSize();
	else
		self.resCount = 0;
	end

	if self.showHeroVo ~= nil then
		self.resCount = self.resCount + 1;
	end
	self.reduiseLoadNum = self.resCount;
end

function Lua_PreLoadVo.Get:showHeroVo()
	return self._showHeroVo;
end

function Lua_PreLoadVo.Set:showHeroVo(val)
	self._showHeroVo = val;
	if self._loadList ~= nil then
		if val == nil then
			self.resCount = self._loadList:getSize();
		else
			self.resCount = self._loadList:getSize() + 1;
		end
	else
		if val == nil then
			self.resCount = 0;
		else
			self.resCount = 1;
		end
	end
end

function Lua_PreLoadVo.Get:maxValue()
	if self.loadCountNum <= 0 then
		return 0;
	end

	if self._maxValue == nil then
		self.addStep = 1;
		self._maxValue = self.loadCountNum;
	end
	return self._maxValue;
end

function Lua_PreLoadVo.Set:maxValue(val)
	self._maxValue = val;
end

function Lua_PreLoadVo.Get:addStep()
	if self.loadCountNum <= 0 then
		return 0;
	end

	if self._addStep == nil then
		self._addStep = self.maxValue / self.loadCountNum;
	else
		local num = self._addStep * self.loadCountNum;
		if num > self.maxValue then
			self._addStep = self.maxValue / self.loadCountNum;
		end
	end
	return self._addStep;
end

function Lua_PreLoadVo.Set:addStep(val)
	self._addStep = val;
end

function Lua_PreLoadVo.Get:leftTime()
	return self.loadCountTime - getTime();
end 

function Lua_PreLoadVo:checkModelScene(sceneId)
	if self.modelScenePanel ~= nil then
		return sceneId ~= nil and sceneId > 0 and self.modelScenePanel.curShowSceneId == sceneId;
	end
	return true;
end

function Lua_PreLoadVo:checkComplete()
	if self.modelScenePanel ~= nil and self.modelScenePanel:checkShowComplete() ~= true then
	-- if self.modelScenePanel ~= nil and self.modelScenePanel.bSceneShow ~= true then
		return false;
	end
	return self.loadCountNum == nil or self.loadCountNum <= 0 or self.curValue <= 0;
end

function Lua_PreLoadVo:startLoad()
	if self.resCount <= 0 then
		return;
	end

	self.curValue = 0;
	self.loadCountNum = 0;
	self.loadCountTime = getTime() + 30;
	if self.showHeroVo ~= nil then -- 模型展示页
		if self.modelScenePanel ~= nil then
			self.modelScenePanel:dispose();
			self.modelScenePanel = nil;
		end
		
		-- self.curValue = self.curValue + 1;
		-- self.loadCountNum = self.loadCountNum + 1;
		self.modelScenePanel = Lua_ModelScenePanel.new();
	    if self.bModelLoaded then
	    	self.modelScenePanel:setModelDir(self.showHeroVo.uiModelDir);
		    self.modelScenePanel:setModelScale(self.showHeroVo.uiModelScale)
		    self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, self.showHeroVo.showActEffs);
		    self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, self.showHeroVo.poseActEffs);
		    self.modelScenePanel:showModelScene(self.showHeroVo.uiSceneId, self.showHeroVo.uiModelUrl, self.showHeroVo.uiModelAvatarName, self.showHeroVo.uiModelCamController, self.bPlanarShadow);
		    self.modelScenePanel:setModelAct(self.showHeroVo.uiShowAct, Lua_ThingDefine.UIWAIT, true);
	    else
	    	self.modelScenePanel:showModelScene(self.showHeroVo.uiSceneId, nil, nil, self.showHeroVo.uiModelCamController);
	    end
	    
	end

	if self.loadList ~= nil then
		local obj;
		for i = 1, self.resCount do
			obj = self.loadList[i];
			
			-- 打开场景
			if obj.openSceneId > 0 and Lua_SceneConfigData.getSceneConfig(obj.openSceneId) ~= nil then
				self.curValue = self.curValue + 1;
				self.loadCountNum = self.loadCountNum + 1;
				if self.loadType == Lua_PreLoadDefine.LOADSHOW_TYPE_SCENEPROGRESS 
					or self.loadType == Lua_PreLoadDefine.LOADSHOW_TYPE_ALLPROGRESS 
					or self.loadType == Lua_PreLoadDefine.LOADSHOW_TYPE_CSHARP_PROGRESS then
					Scene3DManager.instance:OpenSceneBySceneId(obj.openSceneId, obj.fightRecordId, true, self, self.onSceneShow, nil);
				else
					Scene3DManager.instance:OpenSceneBySceneId(obj.openSceneId, obj.fightRecordId, self, self.onSceneShow, nil);
				end
			end

			-- 加载资源
			local url = obj.url;
			if url ~= nil and url ~= "" then
				self.curValue = self.curValue + 1;
				self.loadCountNum = self.loadCountNum + 1;
				-- print("Load", url, obj.keepTime)
				LoadManager.getInstance():Load(obj.resType, url, self, self.onResLoadComplete, self.onResLoadErr, nil, 999, obj.keepTime);
			end
		end
	end

	-- 显示加载表现
	self:updateProgress(self.curValue);
end

-- 加载表现
function Lua_PreLoadVo:updateProgress(val)
	if self.loadCountNum <= 0 then
		return;
	end

	if val > self.loadCountNum then
		val = self.loadCountNum;
	elseif val < 0 then
		val = 0;
	end

	local num = self.loadCountNum - val;
	num = num * self.addStep;
	if self.loadType == Lua_PreLoadDefine.LOADSHOW_TYPE_PROGRESS 
		or self.loadType == Lua_PreLoadDefine.LOADSHOW_TYPE_ALLPROGRESS then -- 加载页
		local data = Lua_LoadingScreenData.getData(self.maxValue, num, self.loadTips);
		Lua_WindowUtil.openWin("Lua_LoadingScreenWindow", Lua_WinParam.ACTION_OPEN, data);
	elseif self.loadType == Lua_PreLoadDefine.LOADSHOW_TYPE_EFFECT then -- 特效
		if val == 0 then
			Lua_MsgUtil.callFunc("PreLoad_EffectShow_Complete");
		else
			Lua_WindowUtil.openWin("Lua_LoadingEffectWindow", Lua_WinParam.ACTION_OPEN);
		end
	elseif self.loadType == Lua_PreLoadDefine.LOADSHOW_TYPE_CSHARP_PROGRESS then -- C#加载页
		-- print("self.maxValue = ", self.maxValue, "num = ", num);
		LuaUtil.showProgressWindow(self.maxValue, num, self.loadTips);
	end
end

function Lua_PreLoadVo:onSceneShow(sceneId)
	self.curValue = self.curValue - 1;
	self:updateProgress(self.curValue);
end

function Lua_PreLoadVo:onResLoadComplete(url)
	self.curValue = self.curValue - 1;
	self:updateProgress(self.curValue);
end

function Lua_PreLoadVo:onResLoadErr(url)
	self.curValue = self.curValue - 1;
	self:updateProgress(self.curValue);
end