Lua_PreLoadUtil = class("Lua_PreLoadUtil");
function Lua_PreLoadUtil:ctor()
	self:superCall("ctor");
    
end

function Lua_PreLoadUtil:dispose()
	
end

function Lua_PreLoadUtil:initPreLoadInfo()
	if self.bInit == true then
		return;
	end

	self.bInit = true;
	self.preLoadDic = {};
	self.funcIdDic = {};
	self.levelDic = {};
	self.taskIdDic = {};
	local list = getConfig("preLoadRes");
	for k, v in pairs(list) do
		self.preLoadDic[k] = v;
		local funcId = v.funId;
		if funcId ~= nil and funcId > 0 then
			if self.funcIdDic[funcId] == nil then
				self.funcIdDic[funcId] = Array();
			end
			self.funcIdDic[funcId]:add(k);
		end

		local level = v.level;
		if level ~= nil then
			if self.levelDic[level] == nil then
				self.levelDic[level] = Array();
			end
			self.levelDic[level]:add(k);
		end

		local taskId = v.taskId;
		if taskId ~= nil and taskId > 0 then
			if self.taskIdDic[taskId] == nil then
				self.taskIdDic[taskId] = Array();
			end
			self.taskIdDic[taskId]:add(k);
		end
	end
end

function Lua_PreLoadUtil:getPreLoadListByLv(level)
	if self.levelDic == nil or level == nil then
		return nil;
	end
	return self.levelDic[level]; 
end

function Lua_PreLoadUtil:getPreLoadInfo(key)
	if self.preLoadDic == nil then
		return nil;
	end
	return self.preLoadDic[key]; 
end