-- 重连提示窗口
Lua_ReconnectWindow = class("Lua_ReconnectWindow", Lua_Window)
function Lua_ReconnectWindow:ctor()
	self:superCall("ctor")

	self.w = 684
	self.h = 408
	self.layer = MainWinDefine.MASK_LAYER
	self.windowName = "Lua_ReconnectWindow"
	self.showBlackMask = true;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "xui_common_window_003";
	self.showTitle = true;
	self.titleText = LanUtil.getValue(100000);
	self.titleNamePosY = 155;
	self.bShowTitleDeco = true;
	self.showClose = false;
	self.openSound = nil;
	self.closeSound = nil;
end

function Lua_ReconnectWindow:buildShowItem()
	self:superCall("buildShowItem")
	Lua_WindowUtil.openWin("Lua_ReconnectingWindow", Lua_WinParam.ACTION_CLOSE);

	local posY = -(self.h / 2 - 91);
	self.btnCancel = UICreate.createButton(self.content, nil, -174, posY, 220, 67)
	self.btnCancel:setStyle(3)
	self.btnCancel:setLangValue(100001)
	self.btnCancel:addClickFuntion(self, self.onCancelClick)
	self.btnCancel:setClickSound("");

	self.btnSure = UICreate.createButton(self.content, nil, 174, posY, 220, 67);
	self.btnSure:setStyle(1);
	self.btnSure:setLangValue(100002);
	self.btnSure:addClickFuntion(self, self.onSureClick);
	self.btnSure:setClickSound("");

	self.des = UICreate.createLabel(self.content, nil, 0, 10, 575, 40, 27);
	self.des.pivotValue = 4;
	self.des.alignmentValue = 4;
	self.des.horizontalOverflowValue = 0;
	self.des.verticalOverflowValue = 1;
	self.des.lineSpacing = 1.2;
	self.des.colorStr = "4285687651";
	self.des:setLangValue(100757);
	self.des:resetSize();
end

function Lua_ReconnectWindow:dispose()
	if not self.bOperate and DataCenter.connectionManager.bReconnecting then
		if self.bBackStartWin then -- 非正常关闭，则直接重登录
			self.bBackStartWin = false;
			DataCenter.connectionManager:relogin();
		else
			DataCenter.connectionManager:restartReconnect();
		end
	end
	self:superCall("dispose")
end

function Lua_ReconnectWindow:showWin(param)
	self:superCall("showWin", param)
	self.bBackStartWin = param;
	if not self.bBackStartWin then -- 
		self.des:setLangValue(100757);
		self.btnCancel:setEnable(true);
		self.btnSure:setLocation(174, -(self.h / 2 - 91), 0);
	else
		self.btnCancel:setEnable(false);
		self.btnSure:setLocation(0, -(self.h / 2 - 91), 0);
		if DataCenter.connectionManager.tempMsg ~= nil then
			self.des:setText(DataCenter.connectionManager.tempMsg);
			DataCenter.connectionManager.tempMsg = nil;
		else
			self.des:setLangValue(10001);
		end
	end
	self.des:resetSize();
end

function Lua_ReconnectWindow:onCancelClick(go)
	self.bOperate = true;
	DataCenter.connectionManager:relogin(); -- 回到登录界面
	self:hide()
end

function Lua_ReconnectWindow:onSureClick(go)
	self.bOperate = true;
	if self.bBackStartWin then -- 回到登录界面
		self.bBackStartWin = false;
		DataCenter.connectionManager:relogin();
	else -- 继续重连
		DataCenter.connectionManager:restartReconnect();
	end
	self:hide()
end