-- 重连转圈窗口
Lua_ReconnectingWindow = class("Lua_ReconnectingWindow", Lua_Window)
function Lua_ReconnectingWindow:ctor()
	self:superCall("ctor")

	self.layer = MainWinDefine.MASK_LAYER
	self.windowName = "Lua_ReconnectingWindow";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showWinBg = false;
	self.showTitle = false;
	self.showClose = false;
	self.rotZ = 0;
	self.curTime = 0;
	self.curStep = 0;
	self.openSound = nil;
	self.closeSound = nil;
end

function Lua_ReconnectingWindow:buildShowItem()
	self:superCall("buildShowItem")

	local bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "login_widget_016", 0, 60, 0, 0);
    bg:resetSize();

    self.spinBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "login_widget_017", 0, 60, 0, 0);
    self.spinBg:resetSize();

    self.contentTxtStr = LanUtil.getValue(100760);
    self.contentTxt = UICreate.createLabel(self.content, nil, 0, 0, 100, 22, 22);
    self.contentTxt.pivotValue = 4;
    self.contentTxt.alignmentValue = 4;
    self.contentTxt.horizontalOverflowValue = 1;
    self.contentTxt.verticalOverflowValue = 1;
    self.contentTxt:setText(self.contentTxtStr);
    self.contentTxt.colorStr = "4294967295";

    self.curTime = getTime() + 0.5;
	Lua_WindowUtil.openWin("Lua_ReconnectWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_CommonUtil.addTimer("Reconnecting", 0.01, self, self.onReconnecting);
end

function Lua_ReconnectingWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.onReconnecting);
	self:superCall("dispose")
end

function Lua_ReconnectingWindow:onReconnecting()
	self.rotZ = self.rotZ - 3;
    self.spinBg:setRot(0, 0, self.rotZ);

    if getTime() >= self.curTime then
    	self.curTime = getTime() + 0.5;
    	self.curStep = self.curStep + 1;
    	if self.curStep > 3 then self.curStep = 0; end
    	if self.curStep == 0 then
    		self.contentTxt:setText(self.contentTxtStr);
    	elseif self.curStep == 1 then
    		self.contentTxt:setText(self.contentTxtStr .. ".");
    	elseif self.curStep == 2 then
    		self.contentTxt:setText(self.contentTxtStr .. "..");
    	elseif self.curStep == 3 then
    		self.contentTxt:setText(self.contentTxtStr .. "...");
    	end
    end
end