-- 文本提示
Lua_ContentTipsWindow = class("Lua_ContentTipsWindow", Lua_Window)
function Lua_ContentTipsWindow:ctor()
	self:superCall("ctor")

	self.w = 642
	self.h = 938
	self.windowName = "Lua_ContentTipsWindow"
	self.showBlackMask = true
	self.showWinBg = true
	self.winBgPath = "/images/common/ui_common_window_011.png"
	self.winBgPosX = 8
	self.winBgPosY = 1
	self.openSound = nil
	self.closeSound = nil
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG)
end

function Lua_ContentTipsWindow:buildShowItem()
	self:superCall("buildShowItem")

	self.titleText = UICreate.createLabel(self.content, nil, 10, 385, 460, 0, 24)
	self.titleText.alignmentValue = 0
	self.titleText.verticalOverflowValue = 1
	self.titleText.colorStr = Lua_ColorDefine.transColorStr("159Ec5")

	self.contentList = Lua_DragContainer.new(self.content, 485, 620, Lua_AxisDefine.Vertical)
	self.contentList:setLocation(8, 15, 0)
	self.contentList.callBackOwner = self
	self.contentList.dragCallBack = self.updateSlider

	self.bar = UICreate.createProgressBar(self.content, nil, nil, nil, nil, 258, 15, 580, 6)
	self.bar:setRot(0, 0, -90)
	self.bar:setBarOffset(0, 0)
	self.bar:createSlider("common_altas_1", "ui_common_label_31", 0, 0)
	self.bar:setSliderRot(0, 0, 90)
	self.bar:setMouseEnable(true)
	self.bar:addSlidingFun(self, self.onSlideingFun)

	self.btnSure = UICreate.createButton(self.content, LanUtil.getValue(11), 0, -374.5, 215, 76)
	self.btnSure:setStyle(5)
	self.btnSure:addClickFuntion(self, self.hide)
end

function Lua_ContentTipsWindow:dispose()
	if self.contentList then
		self.contentList:dispose()
		self.contentList = nil
	end
	self:superCall("dispose")
end

function Lua_ContentTipsWindow:showWin(param)
	self:superCall("showWin", param)

	self.titleText.text = param.title

	self.contentList:addSubContainer(Lua_ContentTipItem, param.des, true)
	self.contentList.canDrag = not self.contentList.isTheEnd
	self.contentList:moveToIndex(1, true)

	self.startValue = self.contentList.subMinPos
	self.endValue = self.contentList.subMaxPox

	local maxValue = Mathf.Abs(self.startValue) + self.endValue
	local value = self.contentList.curSubPos + self.endValue
	self.bar:setMaxValue(maxValue)
	self.bar:setValue(value)
end

function Lua_ContentTipsWindow:onSlideingFun(num)
	self.contentList:setSubPosition(self.startValue + num)
end

function Lua_ContentTipsWindow:updateSlider(pos)
	self.bar:setValue(pos + self.endValue)
end





















Lua_ContentTipItem = class("Lua_ContentTipItem", Lua_DragContainerItem)
function Lua_ContentTipItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_ContentTipItem:buildShowItem()
	self:superCall("buildShowItem")

	self.tipsText = UICreate.createLabel(self.content, nil, 0, 0, 485, 0, 24)
	self.tipsText.verticalOverflowValue = 1
	self.tipsText.colorStr = Lua_ColorDefine.transColorStr("846651")
end

function Lua_ContentTipItem:dispose()
	self:superCall("dispose")
end

function Lua_ContentTipItem:getWidth()
	return self.tipsText.width
end

function Lua_ContentTipItem:getHeight()
	return self.tipsText.height
end

function Lua_ContentTipItem:setData(data)
	self.tipsText.text = data
	self.tipsText:resetSize()
end