-- 登录Tips ESC后退键不会被关闭 热更机制采用独立界面独立代码
Lua_LoginTipsWindow = class("Lua_LoginTipsWindow", Lua_Window)
function Lua_LoginTipsWindow:ctor()
	self:superCall("ctor")

	self.w = 684
	self.h = 408
	self.layer = MainWinDefine.MAX_TOP_LAYER;
	self.windowName = "Lua_LoginTipsWindow"
	self.showBlackMask = true
	self.showWinBg = true
	self.winBgAtlas = "common_altas_1"
	self.winBgSprite = "xui_common_window_003"
	self.showTitle = true
	self.titleText = LanUtil.getValue(100000)
	self.titleNamePosY = 152
	self.bShowTitleDeco = true
	self.showClose = true
	self.btnCloseAtlas = "common_altas_1"
	self.btnCloseSprite = "xui_common_button_003_n"
	self.btnClosePosX = 321
	self.btnClosePosY = 182
	self.openSound = nil;
	self.closeSound = nil;
end

function Lua_LoginTipsWindow:buildShowItem()
	self:superCall("buildShowItem")

	local posY = -(self.h / 2 - 61)
	self.btnCancel = UICreate.createButton(self.content, nil, -174, posY, 220, 67)
	self.btnCancel:setStyle(3)
	self.btnCancel:setLangValue(100001)
	self.btnCancel:addClickFuntion(self, self.onCancelClick)

	self.btnSure = UICreate.createButton(self.content, nil, 174, posY, 220, 67)
	self.btnSure:setStyle(1)
	self.btnSure:setLangValue(100002)
	self.btnSure:addClickFuntion(self, self.onSureClick)

	self.des = UICreate.createLabel(self.content, nil, 0, 0, 100, 40, 27)
	self.des.pivotValue = 4
	self.des.alignmentValue = 4
	self.des.horizontalOverflowValue = 1
	self.des.verticalOverflowValue = 1
	self.des.colorStr = Lua_ColorDefine.transColorStr("726763")
end

function Lua_LoginTipsWindow:dispose()
	self:cleanShowData()
	self:superCall("dispose")
end

function Lua_LoginTipsWindow:showWin(param)
	self:superCall("showWin", param)
	self:updateShowInfo()
end

function Lua_LoginTipsWindow:updateShowInfo()
	if self.showData.titleText then
		self.titleName.text = self.showData.titleText
	else
		self.titleName:setLangValue(100000)
	end
	self.titleName:resetSize()
	self:createTitleDeco()

	self.des.text = self.showData.des
	self.des:resetSize()

	local width = self.showData.width == nil and self.w - 104 or self.showData.width
	local height = self.showData.height == nil and 40 or self.showData.height
	if self.des.width >= width then
		self.des.alignmentValue = 3
		self.des.horizontalOverflowValue = 0
		self.des:SetDimensions(width, height)
	end

	local posX = self.showData.posX == nil and 0 or self.showData.posX
	local posY = self.showData.posY == nil and 8.5 or self.showData.posY
	self.des:setLocation(posX, posY, 0)

	posY = -(self.h / 2 - 61)
	if self.showData.btnType == 1 then
		self.btnCancel:setEnable(true)
		self.btnSure:setEnable(true)
		self.btnCancel.label = self.showData.cancelLabel == nil and LanUtil.getValue(100001) or self.showData.cancelLabel
		self.btnSure.label = self.showData.sureLabel == nil and LanUtil.getValue(100002) or self.showData.sureLabel
		self.btnClose:setEnable(true)
		self.isClickClose = true
	elseif self.showData.btnType == 2 then
		self.btnCancel:setEnable(false)
		self.btnSure:setEnable(true)
		self.btnSure.label = self.showData.sureLabel == nil and LanUtil.getValue(100002) or self.showData.sureLabel
		self.btnSure:setLocation(0, posY, 0)
		self.btnClose:setEnable(true)
		self.isClickClose = true
	elseif self.showData.btnType == 3 then
		self.btnCancel:setEnable(false)
		self.btnSure:setEnable(false)
		self.btnClose:setEnable(false)
		self.isClickClose = false
	elseif self.showData.btnType == 4 then
		self.btnCancel:setEnable(false)
		self.btnSure:setEnable(true)
		self.btnSure.label = self.showData.sureLabel == nil and LanUtil.getValue(100002) or self.showData.sureLabel
		self.btnSure:setLocation(0, posY, 0)
		self.btnClose:setEnable(false)
		self.isClickClose = false
	elseif self.showData.btnType == 5 then
		self.btnCancel:setEnable(true)
		self.btnSure:setEnable(true)
		self.btnCancel.label = self.showData.cancelLabel == nil and LanUtil.getValue(100001) or self.showData.cancelLabel
		self.btnSure.label = self.showData.sureLabel == nil and LanUtil.getValue(100002) or self.showData.sureLabel
		self.btnClose:setEnable(true)
		self.isClickClose = false;
	elseif self.showData.btnType == 6 then
		self.btnCancel:setEnable(true)
		self.btnSure:setEnable(true)
		self.btnCancel.label = self.showData.cancelLabel == nil and LanUtil.getValue(100001) or self.showData.cancelLabel
		self.btnSure.label = self.showData.sureLabel == nil and LanUtil.getValue(100002) or self.showData.sureLabel
		self.btnClose:setEnable(false)
		self.isClickClose = false;
	else
		self.btnCancel:setEnable(false)
		self.btnSure:setEnable(false)
		self.btnClose:setEnable(true)
		self.isClickClose = true
	end
end

function Lua_LoginTipsWindow:cleanShowData()
	if self.showData ~= nil then
		self.showData.owner = nil
		self.showData.cancelFun = nil
		self.showData.sureFun = nil
		self.showData = nil
	end
end

function Lua_LoginTipsWindow:onCancelClick(go)
	if self.showData ~= nil and self.showData.cancelFun ~= nil then
		self.showData.cancelFun(self.showData.owner, self.showData)
	end
	self:hide()
end

function Lua_LoginTipsWindow:onSureClick(go)
	if self.showData ~= nil and self.showData.sureFun ~= nil then
		self.showData.sureFun(self.showData.owner, self.showData)
	end
	self:hide()
end