-- 音效事件监听
checkRequire("Lua_AudioUtil");
checkRequire("Lua_AudioDefine");
checkRequire("Lua_AudioManager");
Lua_AudioProxy = class("Lua_AudioProxy");
function Lua_AudioProxy:ctor()
    self:superCall("ctor");
    DataCenter.audioManager = Lua_AudioManager.new();
    DataCenter.audioUtil = Lua_AudioUtil.new();

    DataCenter.audioManager:play(Lua_AudioDefine.LOGIN_WIN_BG);
    Lua_MsgUtil.addEventListener("player_volume_update", self, self.onUpdateSetUp);

    MsgUtil.addEventListener("Audio_Play_Reset", self, self.onResetAudio); -- 重置已经在播放的音效
    -- MsgUtil.addEventListener("PLAYER_SETUP_UPDATE", self, self.onUpdateSetUp); -- 设置变化
    MsgUtil.addEventListener("Audio_Stop_Dispose_PlayerId", self, self.onStopDisposeAudioByPlayerId);
    MsgUtil.addEventListener("Audio_Stop_PlayerId", self, self.onStopAudioByPlayerId);
    MsgUtil.addEventListener("Audio_Play_Id", self, self.onPlayAudioById);
    MsgUtil.addEventListener("Audio_Fight_Play_Id", self, self.onPlayFightAudioById);
    MsgUtil.addEventListener("CHAT_PLAY_SOUND", self, self.onPlayeChat);
end

function Lua_AudioProxy:onResetAudio(id)
	if DataCenter.audioManager:isPlayingById(id) then
        DataCenter.audioManager:stop(id, true);
        DataCenter.audioManager:play(id);
    end
end

function Lua_AudioProxy:onUpdateSetUp(key)
	if key == Lua_SetUpDefine.is_play_music then -- 
		DataCenter.audioManager:resetMusicVolume();
	elseif key == Lua_SetUpDefine.music_volume then -- 音乐音量
		DataCenter.audioManager:resetMusicVolume();
	elseif key == Lua_SetUpDefine.is_play_sound then
		DataCenter.audioManager:resetSoundVolume();
	elseif key == Lua_SetUpDefine.sound_volume then -- 音效音量
		DataCenter.audioManager:resetSoundVolume();
	elseif key == Lua_SetUpDefine.is_play_voice then -- 
		DataCenter.audioManager:resetVolume(Lua_AudioDefine.PLAYER_CHAT);
	elseif key == Lua_SetUpDefine.voice_volume then -- 语音音量
		DataCenter.audioManager:resetVolume(Lua_AudioDefine.PLAYER_CHAT);
 	end
end

function Lua_AudioProxy:onStopDisposeAudioByPlayerId(playerId)
	DataCenter.audioManager:stopByPlayerId(playerId, true);
end

function Lua_AudioProxy:onStopAudioByPlayerId(playerId)
	DataCenter.audioManager:stopByPlayerId(playerId, false);
end

function Lua_AudioProxy:onPlayAudioById(id)
	DataCenter.audioManager:play(id);
end

function Lua_AudioProxy:onPlayFightAudioById(id)
	if id == nil then return; end
	local vo = DataCenter.fightData.curPlayRecordVo;
	if vo == nil then return; end
	DataCenter.audioManager:play(id, vo.recordId, vo.speed, vo.speedRate);
end

function Lua_AudioProxy:onPlayeChat(voiceId)
	DataCenter.audioManager:playChat(voiceId);
end