Lua_AudioDefine = {};
Lua_AudioDefine.MUSIC = 1;     -- 音乐
Lua_AudioDefine.SOUND = 2;     -- 音效
Lua_AudioDefine.CHAT = 3;      -- 聊天语音
Lua_AudioDefine.LOGIN = 4;     -- 登录背景音乐

Lua_AudioDefine.PLAYER_BG = 1; -- 背景音乐 
Lua_AudioDefine.PLAYER_SCENE = 2; -- 区域音乐，用于场景不同位置的，有距离效果
Lua_AudioDefine.PLAYER_SOUND = 3; -- 音效
Lua_AudioDefine.PLAYER_UI = 4; -- ui音效
Lua_AudioDefine.PLAYER_NPC = 5; -- npc音效
Lua_AudioDefine.PLAYER_CHAT = 6; -- 聊天音效
Lua_AudioDefine.PLAYER_OTHER = 7; -- 其他

Lua_AudioDefine.chatAudioIdConst = "chat_audio"; -- 聊天音频id

-- 未加载到配置之前的声音
Lua_AudioDefine.LOGIN_WIN_BG = "LOGIN_WIN_BG";
Lua_AudioDefine.LOGIN_CLICK = "LOGIN_CLICK";

function Lua_AudioDefine.getPlayerCount(playerId)
    if playerId == Lua_AudioDefine.PLAYER_BG then
    	return 1;
    elseif playerId == Lua_AudioDefine.PLAYER_SCENE then
    	return 3;
    elseif playerId == Lua_AudioDefine.PLAYER_SOUND then
    	return 5;
    elseif playerId == Lua_AudioDefine.PLAYER_UI then
    	return 3;
    elseif playerId == Lua_AudioDefine.PLAYER_NPC then
    	return 1;
    elseif playerId == Lua_AudioDefine.PLAYER_CHAT then
    	return 1;
    elseif playerId == Lua_AudioDefine.PLAYER_OTHER then
    	return 1;
    end
    return 0;
end

Lua_AudioDefine.loginWinConfig = 
	{
		id = Lua_AudioDefine.LOGIN_WIN_BG, 
	 	kind = Lua_AudioDefine.LOGIN,
	 	player_id = Lua_AudioDefine.PLAYER_BG,
	 	fileName = "bgm_denglu",
	 	play_rate = 100,
	 	priority = 0,
	 	unique = 1,
	 	loop = 1
	}

Lua_AudioDefine.loginClickConfig = 
	{
		id = Lua_AudioDefine.LOGIN_CLICK, 
	 	kind = Lua_AudioDefine.LOGIN,
	 	player_id = Lua_AudioDefine.PLAYER_UI,
	 	fileName = "ui_click_01",
	 	play_rate = 100,
	 	priority = 0,
	 	loop = 0
	}