Lua_WinConfigData = class("Lua_WinConfigData");
function Lua_WinConfigData.getConfigData(winName)
    if strIsNullOrEmpty(winName) then
        return nil;
    end

    if Lua_WinConfigData.configs == nil then
        Lua_WinConfigData.configs = {};
    end

    if Lua_WinConfigData.configs[winName] == nil then
        local config = getConfig("window_config", winName);
        if config == nil then
            return nil;
        end
        Lua_WinConfigData.configs[winName] = Lua_WinConfigData.new(winName, config);
    end
    return Lua_WinConfigData.configs[winName];
end

function Lua_WinConfigData:ctor(winName, config)
    self:superCall("ctor");
    self.config = config;
    if config == nil then
        self.config = getConfig("window_config", winName);
    end
end

-------------------- 配置数据 --------------------

function Lua_WinConfigData.Get:winName()
    return self.config.win_name;
end

function Lua_WinConfigData.Get:tweenId()
    return self.config.tween_id;
end

function Lua_WinConfigData.Get:chatPos()
    if self.config == nil or self.config.chat_pos == nil then
        return nil;
    end

    if self._chatPos == nil then
        local x = #self.config.chat_pos > 0 and self.config.chat_pos[1] or 0;
        local y = #self.config.chat_pos > 1 and self.config.chat_pos[2] or 0;
        self._chatPos = {x, y};
    end
    return self._chatPos;
end

function Lua_WinConfigData.Get:popupType()
    if self.config == nil then
        return 0;
    end
    return self.config.popup_type or 0;
end

function Lua_WinConfigData.Get:popupSort()
    if self.config == nil then
        return 0;
    end
    return self.config.popup_sort or 0;
end

function Lua_WinConfigData.Get:popupOverlap()
    if self.config == nil then
        return false;
    end
    return self.config.popup_overlap == 1;
end

function Lua_WinConfigData.Get:unPopupLineup()
    if self.config == nil then
        return 0;
    end
    return self.config.unPopupLineup or 0;
end

function Lua_WinConfigData.Get:expectScenes()
    if self.config == nil then
        return nil;
    end
    return self.config.expectScenes;
end

function Lua_WinConfigData.Get:allowScenes()
    if self.config == nil then
        return nil;
    end
    return self.config.allowScenes;
end

function Lua_WinConfigData.Get:unPopupWin()
    if self.config == nil then
        return nil;
    end
    return self.config.un_popup_win;
end

function Lua_WinConfigData.Get:popupGuideIds()
    if self.config == nil then
        return nil;
    end
    return self.config.popup_guideIds;
end