-- 位操作封装
Lua_BitOperation = { }

-- 与 
function Lua_BitOperation.andBit(val1, val2)
    return(val1 == 1 and val2 == 1) and 1 or 0
end
-- 或
function Lua_BitOperation.orBit(val1, val2)
    return(val1 == 1 or val2 == 1) and 1 or 0
end
-- 异或 
function Lua_BitOperation.xorBit(val1, val2)
    return(val1 + val2) == 1 and 1 or 0
end
-- 对每一位进行op运算，然后将值返回 
function Lua_BitOperation.base(val1, val2, op)
    if val1 < val2 then
        val1, val2 = val2, val1
    end
    local res = 0
    local shift = 1
    while val1 ~= 0 do
        local ra = val1 % 2
        -- 取得每一位(最右边)
        local rb = val2 % 2
        res = shift * op(ra, rb) + res
        shift = shift * 2
        val1 = Mathf.Modf(val1 / 2)
        -- 右移
        val2 = Mathf.Modf(val2 / 2)
    end
    return res
end
-- 与操作 
function Lua_BitOperation.andOp(val1, val2)
    return Lua_BitOperation.base(val1, val2, Lua_BitOperation.andBit)
end
-- 或操作 
function Lua_BitOperation.orOp(val1, val2)
    return Lua_BitOperation.base(val1, val2, Lua_BitOperation.orBit)
end
-- 异或操作
function Lua_BitOperation.xorOp(val1, val2)
    return Lua_BitOperation.base(val1, val2, Lua_BitOperation.xorBit)
end
-- 非操作
function Lua_BitOperation.notOp(val)
    return val > 0 and -(val + 1) or - val - 1
end
-- val左移num位
function Lua_BitOperation.lShift(val, num)
    return Mathf.Floor(val *(2 ^ num))
end
-- val右移num位
function Lua_BitOperation.rShift(val, num)
    return Mathf.Floor(val /(2 ^ num))
end