-- 查找目标object，配合GameFindObjMananger
Lua_GameFindObjUtil = class("Lua_GameFindObjUtil");
function Lua_GameFindObjUtil:ctor()
	self:superCall("ctor");
	
	self.findInstance = GameFindObjMananger.instance;
	self.findCallBackKeys = Array();
	self.findCallBackDic = {};
end

function Lua_GameFindObjUtil:dispose()
	local len = self.findCallBackKeys:getSize();
	while (len > 0) do
		local t = self.findCallBackKeys[len];
		self.findInstance:removeFindInfo(t);
		self.findCallBackKeys:remove(len);
		local obj = self.findCallBackDic[t];
		self.findCallBackDic[t] = nil;
		if obj ~= nil and obj.tab ~= nil and obj.fun ~= nil then
			obj.tab = nil;
			obj.fun = nil;
		end
		len = len - 1;
	end
end

-- 移除
function Lua_GameFindObjUtil:removeFind(t)
	local obj = self.findCallBackDic[t];
	if obj ~= nil then
		self.findCallBackDic[t] = nil;
		self.findCallBackKeys.removeItem(t);
		if obj.tab ~= nil and obj.fun ~= nil then
			obj.tab = nil;
			obj.fun = nil;
		end
	end
	return self.findInstance:removeFindInfo(t);
end

-- 是否找到目标
function Lua_GameFindObjUtil:bFindedTarget(t)
	return self.findInstance:bFindedTarget(t);
end

-- 目标
function Lua_GameFindObjUtil:getTarget(t)
	return self.findInstance:getTarget(t);
end

-- 目标tf
function Lua_GameFindObjUtil:getTargetTf(t)
	return self.findInstance:getTargetTf(t);
end

-- 位置x
function Lua_GameFindObjUtil:getTargetPosX(t, obj)
	return self.findInstance:getTargetPosX(t, obj)
end

-- 位置y
function Lua_GameFindObjUtil:getTargetPosY(t, obj)
	return self.findInstance:getTargetPosY(t, obj)
end

-- 宽
function Lua_GameFindObjUtil:getTargetWidth(t)
	return self.findInstance:getTargetWidth(t);
end

-- 高
function Lua_GameFindObjUtil:getTargetHeight(t)
	return self.findInstance:getTargetHeight(t);
end

-- 查找界面对象
function Lua_GameFindObjUtil:findWinObject(winName, path)
	return self:findWinObject(winName, path, nil, true, 0, 0, nil, nil);
end

-- 查找界面对象
function Lua_GameFindObjUtil:findWinObject(winName, path, ignoreStr)
	return self:findWinObject(winName, path, ignoreStr, true, 0, 0, nil, nil);
end

-- 查找界面对象
-- bImmediately 立即查找
-- findLimitTime 查找总时间
-- delayTime 延迟查找时间
function Lua_GameFindObjUtil:findWinObject(winName, path, ignoreStr, bImmediately, findLimitTime, delayTime, tab, fun)
	if bImmediately == nil then bImmediately = true; end
	if findLimitTime == nil then findLimitTime = 0; end
	local t = self.findInstance:findWinObject(winName, path, ignoreStr, bImmediately, findLimitTime, delayTime);
	if t > 0 and not self:bFindedTarget(t) then -- 在找，已找到直接根据返回值判断
		if tab ~= nil and fun ~= nil then
			self.findCallBackKeys:add(t);
			self.findCallBackDic[t] = {tab = tab, fun = fun};
		end
	end
	return t;
end

-- 查找场景对象
function Lua_GameFindObjUtil:findSceneObject(sceneId, fightId, path)
	return self:findSceneObject(sceneId, fightId, path, nil, true, 0, 0, nil, nil);
end

-- 查找场景对象
function Lua_GameFindObjUtil:findSceneObject(sceneId, fightId, path, ignoreStr)
	return self:findSceneObject(sceneId, fightId, path, ignoreStr, true, 0, 0, nil, nil);
end

-- 查找场景对象
function Lua_GameFindObjUtil:findSceneObject(sceneId, fightId, path, ignoreStr, bImmediately, findLimitTime, delayTime, tab, fun)
	if bImmediately == nil then bImmediately = true; end
	if findLimitTime == nil then findLimitTime = 0; end
	if fightId == nil or fightId < 0 then fightId = DataCenter.fightData.curPlayFightRecordId; end
	if sceneId == nil or sceneId <= 0 then sceneId = DataCenter.sceneData.openSceneId; end
	local t = self.findInstance:findSceneObject(sceneId, fightId, path, ignoreStr, bImmediately, findLimitTime, delayTime);
	if t > 0 and not self:bFindedTarget(t) then -- 在找，已找到直接根据返回值判断
		if tab ~= nil and fun ~= nil then
			self.findCallBackKeys:add(t);
			self.findCallBackDic[t] = {tab = tab, fun = fun};
		end
	end
	return t;
end

-- 查找子对象
function Lua_GameFindObjUtil:findContainer(parent, path)
	return self:findContainer(parent, path, nil, true, 0, 0, nil, nil);
end

-- 查找子对象
function Lua_GameFindObjUtil:findContainer(parent, path, ignoreStr)
	return self:findContainer(parent, path, ignoreStr, true, 0, 0, nil, nil);
end

-- 查找子对象
function Lua_GameFindObjUtil:findContainer(parent, path, ignoreStr, bImmediately, findLimitTime, delayTime, tab, fun)
	if bImmediately == nil then bImmediately = true; end
	if findLimitTime == nil then findLimitTime = 0; end
	local t = self.findInstance:findContainer(parent, path, ignoreStr, bImmediately, findLimitTime, delayTime);
	if t > 0 and not self:bFindedTarget(t) then -- 在找，已找到直接根据返回值判断
		if tab ~= nil and fun ~= nil then
			self.findCallBackKeys:add(t);
			self.findCallBackDic[t] = {tab = tab, fun = fun};
		end
	end
	return t;	
end

-- 查找子对象
function Lua_GameFindObjUtil:findContainerTf(parentTf, path)
	return self:findContainerTf(parentTf, path, nil, true, 0, 0, nil, nil);
end

-- 查找子对象
function Lua_GameFindObjUtil:findContainerTf(parentTf, path, ignoreStr)
	return self:findContainerTf(parentTf, path, ignoreStr, true, 0, 0, nil, nil);
end

-- 查找子对象
function Lua_GameFindObjUtil:findContainerTf(parentTf, path, ignoreStr, bImmediately, findLimitTime, delayTime, tab, fun)
	if bImmediately == nil then bImmediately = true; end
	if findLimitTime == nil then findLimitTime = 0; end
	local t = self.findInstance:findContainerTf(parentTf, path, ignoreStr, bImmediately, findLimitTime, delayTime);
	if t > 0 and not self:bFindedTarget(t) then -- 在找，已找到直接根据返回值判断
		if tab ~= nil and fun ~= nil then
			self.findCallBackKeys:add(t);
			self.findCallBackDic[t] = {tab = tab, fun = fun};
		end
	end
	return t;	
end

-- 查找到目标的回调（非外部调用方法）
function Lua_GameFindObjUtil:callFinded(t)
	Lua_MsgUtil.callFunc("GameFindObj_Complete", t);
	local obj = self.findCallBackDic[t];
	if obj ~= nil then
		self.findCallBackDic[t] = nil;
		self.findCallBackKeys.removeItem(t);
		if obj.tab ~= nil and obj.fun ~= nil then
			obj.fun(obj.tab, t);
			obj.tab = nil;
			obj.fun = nil;
		end
	end
end