Lua_MsgUtil = {};
Lua_MsgUtil.dic = {};
Lua_MsgUtil.key = 0;
Lua_MsgUtil.msgListenerTab = {};
function Lua_MsgUtil.callFunc(name, data)
	local arr = Lua_MsgUtil.dic[name];
	if arr ~= nil then
		local len = arr:getSize();
		for i=1,len do
			if arr[i] ~= nil and arr[i].isDispose ~= true then
				local owner = arr[i].owner;
				if owner ~= nil and owner.skinBuilded ~= nil and owner.windowName ~= nil then
					if owner.skinBuilded ~= true then -- 延迟创建
						Lua_MsgUtil.addDelayCall(owner, arr[i].func, data);
					else
						arr[i].func(owner, data);
					end
				else
					arr[i].func(owner, data);
				end	
			end
		end
	end
end

function Lua_MsgUtil.addDelayCall(owner, func, data)
	if owner == nil or func == nil then
		return;
	end

	-- 非窗口类
	local windowName = owner.windowName;
	if windowName == nil or windowName == "" then
		return;
	end

	if Lua_MsgUtil.delayCallDic == nil then
		Lua_MsgUtil.delayCallDic = {};
	end
	
	if Lua_MsgUtil.delayCallDic[windowName] == nil then
		Lua_MsgUtil.delayCallDic[windowName] = Array();
	end
	Lua_MsgUtil.delayCallDic[windowName]:add({data = data, func = func, owner = owner});
end

function Lua_MsgUtil.callDelayFuns(windowName)
	if Lua_MsgUtil.delayCallDic == nil or Lua_MsgUtil.delayCallDic[windowName] == nil then
		return;
	end

	local arr = Lua_MsgUtil.delayCallDic[windowName];
	while arr:getSize() > 0 do
		local obj = arr:remove();
		if obj ~= nil then
			obj.func(obj.owner, obj.data);
			obj.func = nil;
			obj.owner = nil;
			obj.data = nil;
			obj = nil;
		end
	end
	arr:dispose();
	arr:clear();
	arr = nil;
	Lua_MsgUtil.delayCallDic[windowName] = nil;
end

function Lua_MsgUtil.clearDelayFuns(windowName)
	if Lua_MsgUtil.delayCallDic == nil or Lua_MsgUtil.delayCallDic[windowName] == nil then
		return;
	end

	local arr = Lua_MsgUtil.delayCallDic[windowName];
	while arr:getSize() > 0 do
		local obj = arr:remove();
		if obj ~= nil then
			obj.func = nil;
			obj.owner = nil;
			obj.data = nil;
			obj = nil;
		end
	end
	arr:dispose();
	arr:clear();
	arr = nil;
	Lua_MsgUtil.delayCallDic[windowName] = nil;
end

function Lua_MsgUtil.traceListenerList()
	print("----------------------");
	for k, v in pairs(Lua_MsgUtil.dic) do
		print(k, v:getSize())
	end
end

function Lua_MsgUtil.hasEventListener(name, owner, func)
	local arr = Lua_MsgUtil.dic[name];
	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do
			if arr[i].owner == owner and arr[i].func == func then
				return true;
			end
		end
	end
	return false;
end

function Lua_MsgUtil.addEventListener(name, owner, func)
	local has = Lua_MsgUtil.hasEventListener(name, owner, func);
	if has == true then
		return false;
	end
	
	local arr = Lua_MsgUtil.dic[name];
	if arr == nil then
		arr = Array();
		Lua_MsgUtil.dic[name] = arr;
	end
	Lua_MsgUtil.key = Lua_MsgUtil.key + 1;
	arr:add({key = Lua_MsgUtil.key, func = func, owner = owner});
	return true;
end

function Lua_MsgUtil.removeEventListener(name, owner, func)
	local arr = Lua_MsgUtil.dic[name];
	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do
			if arr[i].owner == owner and arr[i].func == func then
				arr[i].owner = nil;
				arr[i].func = nil;
				arr[i].isDispose = true;
				break;
			end
		end
	end
end

function Lua_MsgUtil.checkRemoveEvent()
	if Lua_MsgUtil.time == nil or DataCenter.frameStartTime - Lua_MsgUtil.time > 0.5 then
		Lua_MsgUtil.time = DataCenter.frameStartTime;
		for k, v in pairs(Lua_MsgUtil.dic) do
			local len = v:getSize();
			while (len > 0) do
				local item = v[len];
				if item ~= nil and item.isDispose == true then
					v:remove(len);
				end
				len = len - 1;
			end

			if v:getSize() == 0 then
				Lua_MsgUtil.dic[k] = nil;
			end
		end
	end
end

function Lua_MsgUtil.clearAllFun()
	if Lua_MsgUtil.delayCallDic ~= nil then
		for winName, arr in pairs(Lua_MsgUtil.delayCallDic) do
			while arr:getSize() > 0 do
				local obj = arr:remove();
				if obj ~= nil then
					obj.owner = nil;
					obj.data = nil;
					obj.func = nil;
					obj = nil;
				end
			end
			arr:dispose();
			arr:clear();
			arr = nil;
			Lua_MsgUtil.delayCallDic[winName] = nil;
		end
		Lua_MsgUtil.delayCallDic = nil;
	end

	for k, arr in pairs(Lua_MsgUtil.dic) do
		while arr:getSize() > 0 do
			local obj = arr:remove();
			if obj ~= nil then
				obj.owner = nil;
				obj.key = nil;
				obj.func = nil;
				obj = nil;
			end
		end
		arr:dispose();
		arr:clear();
		arr = nil;
		Lua_MsgUtil.dic[k] = nil;
	end
	Lua_MsgUtil.dic = {};
	Lua_MsgUtil.clearCSharpEventAct();
end

-- 添加消息监听
function Lua_MsgUtil.addLuaMsg(msgid, tab, func)
	if msgid == nil then return false; end
	if func == nil then return false; end
	local list = Lua_MsgUtil.msgListenerTab[msgid];
	if list == nil then 
		list = Array();
		list:add({tab = tab, func = func});
		Lua_MsgUtil.msgListenerTab[msgid] = list;
	else
		local len = list:getSize();
		for i = 1, len do
			local obj = list[i];
			if obj ~= nil and obj.tab == tab and obj.func == func then
				return false;
			end
		end
		list:add({tab = tab, func = func});
	end
	return true;
end

-- 移除消息监听
function Lua_MsgUtil.removeLuaMsg(msgid, tab, func)
	if msgid == nil then return false; end
	local list = Lua_MsgUtil.msgListenerTab[msgid];
	if list == nil then return false; end
	local len = list:getSize();
	local bRemove = false;
	while (len > 0) do
		local obj = list[len];
		if tab == nil and func == nil then
			list:remove(len);
			bRemove = true;
		elseif obj.tab == tab then
			if func == nil then
				list:remove(len);
				bRemove = true;
			elseif obj.func == func then
				list:remove(len);
				return true;
			end
		end
		len = len - 1;
	end
	return bRemove;
end

-- 消息是否监听，false则无lua监听
function Lua_MsgUtil.checkMsgListener(msgid)
	if msgid == nil then return false; end
	local list = Lua_MsgUtil.msgListenerTab[msgid];
	return list ~= nil and list:getSize() > 0;
end

-- 消息下行，返回False则会执行对应C#消息号监听
function Lua_MsgUtil.receiveMsg(mp)
	if mp == nil then return false; end
	local list = Lua_MsgUtil.msgListenerTab[mp.id];
	if list == nil then return false; end
	Lua_MsgUtil.receivingMsgId = mp.id;
	local len = list:getSize();
	local disC = false;
	local msg = nil;
	for i = 1, len do
		local obj = list[i];
		if obj ~= nil then
			local msgObj, bDisc = obj.func(obj.tab, mp, msg);
			if bDisc == nil then bDisc = true; end
			if msg == nil then msg = msgObj; end
			disC = bDisc or disC;
		end
	end

	Lua_MsgUtil.receivingMsgId = nil;
	return disC;
end