Lua_TimeTransform = { };

-- 根据秒 算出时间  格式 大于一天 显示 0天00时00分00秒,小于一天显示 00时00分00秒
function Lua_TimeTransform.transSeconds1(_second, showHour, showMinute, showSecond)
    local _day = _second % 86400;
    local day = Mathf.Modf(_second/86400);
    if day >= 1 then
        return day..LanUtil.getValue(23)..Lua_TimeTransform.transSeconds9(_day, showHour, showMinute, showSecond);
    end
    return Lua_TimeTransform.transSeconds9(_day, showHour, showMinute, showSecond);
end


-- 根据秒 算出时间  格式  00:00:00
function Lua_TimeTransform.transSeconds6(_second, showHour, showMinute, showSecond)
    showHour = showHour == nil and true or showHour;
    showSecond = showSecond == nil and true or showSecond;
    local _hour = _second%3600;

    local hour = Mathf.Modf(_second/3600);
    local minute = Mathf.Modf(_hour/60);
    local second = _hour%60;

    if showHour and hour < 10 then
        hour = "0"..hour;
    end

    if minute < 10 then
    	minute = "0"..minute;
    end

    if showSecond and second < 10 then
        second = "0"..second;
    end

    local show_second = "";
    if showSecond then
        show_second = ":"..second;
    end
    return hour..":"..minute..show_second;
end

-- 根据时间戳计算日期： xxxx年xx月xx日 xx:xx:xx
function Lua_TimeTransform.transSeconds7(timestamp)
    timestamp = tonumber(timestamp);
    return os.date("%Y"..LanUtil.getValue(46).."%m"..LanUtil.getValue(47).."%d"..LanUtil.getValue(48)..Lua_SpaceDefine.SPACE_1 .."%H:%M:%S", timestamp);
end

-- 根据时间戳计算日期： xxxx-xx-xx xx:xx:xx
function Lua_TimeTransform.transSeconds8(timestamp)
    timestamp = tonumber(timestamp);
    return os.date("%Y-%m-%d %H:%M:%S", timestamp);
end

-- 根据秒 算出时间  格式  00时00分00秒
function Lua_TimeTransform.transSeconds9(_second, showHour, showMinute, showSecond, isSpecial)
    showHour = showHour == nil and true or showHour;
    showMinute = showMinute == nil and true or showMinute;
    showSecond = showSecond == nil and true or showSecond;
    local _hour = _second % 3600;

    local hour = Mathf.Modf(_second / 3600);
    local minute = Mathf.Modf(_hour / 60);
    local second = _hour % 60;

    local hour_str = "";
    if showHour and hour >= 0 then
        if hour < 10 then
            hour_str = "0"..hour..LanUtil.getValue(24);
        else
            hour_str = hour..LanUtil.getValue(24);
        end
    end

    local minute_str = "";
    if showMinute then
        if minute < 10 then
            minute_str = "0"..minute..LanUtil.getValue(25);
        else
            minute_str = minute..LanUtil.getValue(25);
        end
    end

    local second_str = "";
    if showSecond then
        if second < 10 then
            second_str = "0"..second..LanUtil.getValue(26);
        else
            second_str = second..LanUtil.getValue(26);
        end
    end
    -- isSpecial = true 小于天 xx时xx分，小于时 xx分xx秒
    if isSpecial then
        if hour <= 24 and hour >= 1 then
            return hour_str..minute_str;
        elseif hour < 1 then
            return minute_str..second_str;
        end
    end

    return hour_str..minute_str..second_str;
end

-- 根据秒 算出时间  格式  0天00时00分00秒
function Lua_TimeTransform.transSeconds16(_second, showHour, showMinute, showSecond)
	local _day = _second % 86400;
	local day = Mathf.Modf(_second / 86400);
	return day..LanUtil.getValue(23)..Lua_TimeTransform.transSeconds9(_day, showHour, showMinute, showSecond);
end

-- 根据秒 算出时间  格式 大于一天 显示 0天,小于0天 显示 00时00分00秒
function Lua_TimeTransform.transSeconds17(_second, showHour, showMinute, showSecond)
	local _day = _second % 86400;
	local day = Mathf.Modf(_second / 86400);
	if day >= 1 then
		return day..LanUtil.getValue(23);
	end

	return Lua_TimeTransform.transSeconds9(_day, showHour, showMinute, showSecond);
end

-- 根据秒 格式 大于一天 显示 x天x时，小于一天 显示 00时00分00秒  (isSpecial = true 小于1天 xx时xx分，小于1时 xx分xx秒)
function Lua_TimeTransform.transSeconds18(_second, showHour, showMinute, showSecond, isSpecial)
    local _day = _second % 86400;
    local day = Mathf.Modf(_second / 86400);
    local hour = Mathf.Modf(_day / 3600);
    if day >= 1 then
        local hour_str = hour;
        if isSpecial then
            if hour < 10 and hour >= 0 then
                hour_str = "0"..hour;
            end
        end

        return day..LanUtil.getValue(23)..hour_str..LanUtil.getValue(24);
    end

    return Lua_TimeTransform.transSeconds9(_day, showHour, showMinute, showSecond, isSpecial);
end

-- 根据秒 算出时间  格式 大于一天 显示 0天00:00:00,小于一天显示 00:00:00
function Lua_TimeTransform.transSeconds20(_second,showHour,showSecond)
    local _day = _second % 86400;
    local day = Mathf.Modf(_second / 86400);
    if day >= 1 then
        return day..LanUtil.getValue(23)..Lua_TimeTransform.transSeconds6(_day, showHour, showSecond);
    end

    return Lua_TimeTransform.transSeconds6(_day,showHour,showSecond);
end

-- 根据秒显示0时0分钟， showMin为false时分钟等于0则不显示分钟否则显示0分钟
function Lua_TimeTransform.transSeconds21(_second, showMin)
    showMin = showMin == nil and true or showMin;
    showSecond = showSecond == nil and true or showSecond;
    local _hour = _second % 3600;

    local hour = Mathf.Modf(_second / 3600);
    local minute = Mathf.Modf(_hour / 60);

    local hour_str = tostring(hour)..LanUtil.getValue(24);

    if minute <= 0 then
        if showMin then
            minute = "0"..LanUtil.getValue(25);
        else
            minute = "";
        end
    else
        minute = minute..LanUtil.getValue(25);
    end

    return hour_str..minute;
end

-- 根据秒 算出时间格式 0天00时00分00秒,如天时分秒四个档位中有任一档位为0,则不显示该档位
function Lua_TimeTransform.transSeconds22(totalTime)
    if totalTime <= 0 then
        return "00" .. LanUtil.getValue(26);
    end

    local day = Mathf.Modf(totalTime / 86400);
    local remainHour = totalTime % 86400;

    local hour = Mathf.Modf(remainHour / 3600);
    local remainMinute = remainHour % 3600;

    local minute = Mathf.Modf(remainMinute / 60);
    local second = remainMinute % 60;

    local showDay = "";
    if day > 0 then
        showDay = day .. LanUtil.getValue(23);
    end

    local showHour = "";
    if hour < 10 and hour > 0 then
        showHour = "0" .. hour .. LanUtil.getValue(24);
    elseif hour > 10 then
        showHour = hour .. LanUtil.getValue(24);
    end

    local showMinute = "";
    if minute < 10 and minute > 0 then
        showMinute = "0" .. minute .. LanUtil.getValue(25);
    elseif minute > 10 then
        showMinute = minute .. LanUtil.getValue(25);
    end

    local showSecond = "";
    if second < 10 then
        showSecond = "0" .. second .. LanUtil.getValue(26);
    else
        showSecond = second .. LanUtil.getValue(26);
    end

    return showDay .. showHour .. showMinute .. showSecond;
end

-- 根据秒显示n小时n分钟n秒
function Lua_TimeTransform.transSeconds23(_second, showMin, showSecond)
    local hour = Mathf.Modf(_second / 3600);
    local hour_str = tostring(hour)..LanUtil.getValue(44);

    local minute_str = "";
    if showMin then
        local minute = Mathf.Modf(_second % 3600 / 60);
        minute_str = minute..LanUtil.getValue(45);
    end
    
    local second_str = "";
    if showSecond then
        local second = _second % 3600 % 60;
        second_str = second..LanUtil.getValue(26);
    end
    
    return hour_str..minute_str..second_str;
end

-- >=1天:n天 <1天:n小时 <1小时:n分钟 <1分钟:n秒
function Lua_TimeTransform.transSeconds24(_second)
    if _second <= 0 then
        return "0"..LanUtil.getValue(26);
    end

    local day = Mathf.Modf(_second / 86400);
    if day >= 1 then
        return day..LanUtil.getValue(23);
    end

    local hour = Mathf.Modf(_second / 3600);
    if hour >= 1 then
        return hour..LanUtil.getValue(24);
    end

    local _hour = _second % 3600;
    local minute = Mathf.Modf(_hour / 60);
    if minute >= 1 then
        return minute..LanUtil.getValue(45);
    end

    local second = _hour % 60;
    return second..LanUtil.getValue(26);
end

-- 根据时间戳计算日期： xxxx年xx月xx日 isShowYear:是否显示xxxx年
function Lua_TimeTransform.transSeconds25(timestamp, isShowYear)
    isShowYear = isShowYear == nil and true or isShowYear;
    timestamp = tonumber(timestamp);
    local year = "";
    if isShowYear then
        year = os.date("%Y"..LanUtil.getValue(46), timestamp);
    end
    return year..os.date("%m"..LanUtil.getValue(47).."%d"..LanUtil.getValue(48), timestamp);
end

-- 根据秒 算出时间  格式 大于一天 显示 0天00时00分,小于一天显示 00时00分00秒
function Lua_TimeTransform.transSeconds26(_second, showHour, showMinute)
    local _day = _second % 86400;
    local day = Mathf.Modf(_second / 86400);
    if day >= 1 then
        return day .. LanUtil.getValue(23) .. Lua_TimeTransform.transSeconds9(_day, showHour, showMinute, false);
    end

    return Lua_TimeTransform.transSeconds9(_day, showHour, showMinute, true);
end

-- 根据时间戳计算日期： xxxx年xx月xx日(不足10不填0) isShowYear:是否显示xxxx年
function Lua_TimeTransform.transSeconds27(timestamp, isShowYear)
    isShowYear = isShowYear == nil and true or isShowYear;
    timestamp = tonumber(timestamp);
    local year = "";
    if isShowYear then
        year = os.date("%Y"..LanUtil.getValue(46), timestamp);
    end
    return year..tonumber(os.date("%m", timestamp))..LanUtil.getValue(47)..tonumber(os.date("%d", timestamp))..LanUtil.getValue(48);
end