Lua_TouchControler = class("Lua_TouchControler");
function Lua_TouchControler.getInstance()
	if Lua_TouchControler.instance == nil then
		Lua_TouchControler.instance = Lua_TouchControler.new();
	end
	return Lua_TouchControler.instance;
end
function Lua_TouchControler:startTouchCheck()
	Lua_CommonUtil.addTimer("Lua_TouchControler", 0.01, self, self.onEnterFrame);
end
function Lua_TouchControler:stopTouchCheck()
	self.tempPosition1 = nil;
	self.tempPosition2 = nil;
	Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
end
function Lua_TouchControler:onEnterFrame()
	if CommonUtil.isApplePlatform == true then
		self:onPhoneRunning();
	else
		if Lua_PlatformUtil.IsWindowsEditor() or Lua_PlatformUtil.IsWindowsPlayer() then
			self:onPcRunning();
		else
			self:onPhoneRunning();
		end
	end
end
function Lua_TouchControler:onPhoneRunning()
	if UnityEngine.Input.touchCount > 1 then
		if self.tempPosition1 == nil or self.tempPosition2 == nil then
			self.tempPosition1 = UnityEngine.Input.GetTouch(0).position;
			self.tempPosition2 = UnityEngine.Input.GetTouch(1).position;
		end
		local newPos1 = UnityEngine.Input.GetTouch(0).position;
		local newPos2 = UnityEngine.Input.GetTouch(1).position;
		local newLen = self:caculateDis(newPos1, newPos2);
		local oldLen = self:caculateDis(self.tempPosition1, self.tempPosition2);
		if newLen > oldLen then
			Lua_MsgUtil.callFunc("TOUCH_CHANGE", true);
		elseif newLen < oldLen then
			Lua_MsgUtil.callFunc("TOUCH_CHANGE", false);
		end
		
		self.tempPosition1 = newPos1;
		self.tempPosition2 = newPos2;
	else
		self.tempPosition1 = nil;
		self.tempPosition2 = nil;
	end
end
function Lua_TouchControler:caculateDis(p1, p2)
	local dx = p1.x - p2.x;
	local dy = p1.y - p2.y;
	return Mathf.Sqrt(dx*dx + dy * dy);
end
function Lua_TouchControler:onPcRunning()
	if UnityEngine.Input.GetAxis("Mouse ScrollWheel") ~= 0 then
		local v = UnityEngine.Input.GetAxis("Mouse ScrollWheel");
		Lua_MsgUtil.callFunc("TOUCH_CHANGE", v > 0);
	end
end