Lua_WindowUtil = {};
Lua_WindowUtil.UI_CONTAINER = 1;
Lua_WindowUtil.UI_SPRITE = 2;
Lua_WindowUtil.UI_TEXT = 3;
Lua_WindowUtil.UI_CHECKBOX = 4;
Lua_WindowUtil.UI_BUTTON = 5;
Lua_WindowUtil.UI_COSTOM = 6;
Lua_WindowUtil.UI_TEXTINPUT = 7;
Lua_WindowUtil.UI_IMAGE = 8;
Lua_WindowUtil.UI_PB = 9;
Lua_WindowUtil.UI_MODEL = 10;
Lua_WindowUtil.UI_EDIT_AUX = 999; -- UI编辑辅助组件，不进行UI皮肤导出
Lua_WindowUtil.winActiveState = {}; -- 用于界面状态变更记录
Lua_WindowUtil.windowMananger = WindowMananger.getInstance();
function Lua_WindowUtil.openWin(winName, act, data, ignoreCheckPopup)
	if act == nil or act == Lua_WinParam.ACTION_AUTO then
		if Lua_WindowUtil.isWindowShowing(winName) == false then
			act = Lua_WinParam.ACTION_OPEN;
		else
			act = Lua_WinParam.ACTION_CLOSE;
		end
	end

	-- 处理弹窗逻辑
	if ignoreCheckPopup ~= true then
		-- local guideCommonData = DataCenter.guideCommonData; -- 防止弹窗跳转
		-- if act == Lua_WinParam.ACTION_OPEN and 
		-- 	guideCommonData ~= nil and 
		-- 	guideCommonData.bStopGuide and 
		-- 	DataCenter.guideData.isGuiding and 
		-- 	not guideCommonData:checkGuideUsePopupWin(winName) then
		-- 		local configData = Lua_WinConfigData.getConfigData(winName);
		-- 		if configData == nil or (configData ~= nil and configData.popupType == 0) then
		-- 			LogManager.showLog("引导中停止打开窗口"..winName, false);
		-- 			print("222引导中",winName)
		-- 			return;
		-- 		end
		-- end

		local bWait = DataCenter.popupWinManager:checkPopupWinData(winName, act, data)
		if bWait == true then -- 等待前一个弹框结束
			return
		end
	end

	if act == Lua_WinParam.ACTION_OPEN then
		if Lua_PlatformUtil.IsWindowsEditor() and ServerConfig.isLuaPack then
			LuaUtil.RefreshLuaFile(winName);
			updateRequire(winName);
		end
		-- Lua_MsgUtil.callFunc("Guide_WinLoading_Open", true);
		DataCenter.guideCommonData:syncPopupWinState(winName, 1);
		Lua_WindowUtil.addWinData(winName, data);
		LuaUtil.winShowHide(winName, act);
		-- MsgUtil.callFunc(EventsDefine.WIN_SHOW_HIDE, WinParam.getWinParam(winName, act, nil));

		if DataCenter.bConfigLoaded then
			local iconId = DataCenter.mainMenuData:getIconIdByWinName(winName);
			DataCenter.mainMenuData:setMainIconSelected(iconId);
		end
	elseif act == Lua_WinParam.ACTION_CLOSE then
		Lua_WindowUtil.clearWinData(winName)
		LuaUtil.winShowHide(winName, act);
		-- MsgUtil.callFunc(EventsDefine.WIN_SHOW_HIDE, WinParam.getWinParam(winName, act, nil));
		if ignoreCheckPopup ~= true then
			DataCenter.popupWinManager:checkPopupWin() -- 继续打开下一个弹框
		end
	end
end

-- 有界面加载中
function Lua_WindowUtil.bLoadingWindow()
	-- local mi = WindowMananger.getInstance();
	return Lua_WindowUtil.windowMananger.bLoadingWindow;
end

function Lua_WindowUtil.isOpenWin(winName)
	-- local mi = WindowMananger.getInstance();
	return Lua_WindowUtil.windowMananger:isOpenWin(winName);
end

function Lua_WindowUtil.isWindowShowing(winName)
	-- local mi = WindowMananger.getInstance();
	return Lua_WindowUtil.windowMananger:isWindowShowing(winName);
end

function Lua_WindowUtil.isWinInitComplete(winName)
	-- local mi = WindowMananger.getInstance();
	return Lua_WindowUtil.windowMananger:isWinInitComplete(winName);
end

function Lua_WindowUtil.isActiveWin(winName)
	-- local mi = WindowMananger.getInstance();
	return Lua_WindowUtil.windowMananger:isWindowShowing(winName) and Lua_WindowUtil.windowMananger:isActiveWin(winName);
end

function Lua_WindowUtil.isNoActiveWin(winName)
	-- local mi = WindowMananger.getInstance();
	return Lua_WindowUtil.windowMananger:isWindowShowing(winName) and not Lua_WindowUtil.windowMananger:isActiveWin(winName);
end

function Lua_WindowUtil.clearAllWinData()
	if Lua_WindowUtil.winListData ~= nil then
		for key, arr in pairs(Lua_WindowUtil.winListData) do
			local len = arr:getSize();
			for i = 1, len do
				if type(arr[i]) == "table" and arr[i].modelScenePanel ~= nil then
					arr[i].modelScenePanel:dispose();
					arr[i].modelScenePanel = nil;
				end
			end
			arr:dispose();
			arr:clear();
			arr = nil;
			Lua_WindowUtil.winListData[key] = nil;
		end
		Lua_WindowUtil.winListData = nil;
	end
end

function Lua_WindowUtil.addWinData(winName, data)
	if data == nil then
		return;
	end

	if Lua_WindowUtil.winListData == nil then
		Lua_WindowUtil.winListData = {};
	end

	if Lua_WindowUtil.winListData[winName] == nil then
		Lua_WindowUtil.winListData[winName] = Array();
	end
	Lua_WindowUtil.winListData[winName]:add(data);
end

function Lua_WindowUtil.clearWinData(winName)
	if strIsNullOrEmpty(winName) then
		return;
	end
	if Lua_WindowUtil.winListData == nil then
		return;
	end
	local arr = Lua_WindowUtil.winListData[winName];
	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do
			if type(arr[i]) == "table" and arr[i].modelScenePanel ~= nil then
				arr[i].modelScenePanel:dispose();
				arr[i].modelScenePanel = nil;
			end
		end
		arr:dispose();
		arr:clear();
		Lua_WindowUtil.winListData[winName] = nil;
	end
end

function Lua_WindowUtil.getWinListData(winName, doRemove)
	if Lua_WindowUtil.winListData == nil then
		return nil;
	end
	local o = Lua_WindowUtil.winListData[winName];
	if doRemove == true then
		Lua_WindowUtil.winListData[winName] = nil;
	end
	return o;
end

function Lua_WindowUtil.buildFromSkin(showTable, skinStr, rootObj)
	skinTable = checkRequire(skinStr);
	local conTable = {};
	conTable["content"] = showTable["content"];
	for i,v in ipairs(skinTable) do
		Lua_WindowUtil:buildOneSkin(showTable, conTable, v);
	end
end

function Lua_WindowUtil.buildFromSkinEachFrame(showTable, skinTable, conTable, index)
	if index > #skinTable then
		return true;
	else
		Lua_WindowUtil:buildOneSkin(showTable, conTable, skinTable[index]);
		return false;
	end
end

function Lua_WindowUtil:buildOneSkin(showTable, conTable, v)
	if v.type == Lua_WindowUtil.UI_CONTAINER then
		showTable[v.name] = Lua_WindowUtil.createContainerByVec(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name];
	elseif v.type == Lua_WindowUtil.UI_SPRITE then
		showTable[v.name] = Lua_WindowUtil.createUIAtlasImage(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_CHECKBOX then
		showTable[v.name] = Lua_WindowUtil.createCheckBox(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_TEXT then
		showTable[v.name] = Lua_WindowUtil.createLabel(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_BUTTON then
		showTable[v.name] = Lua_WindowUtil.createButton(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_TEXTINPUT then
		showTable[v.name] = Lua_WindowUtil.createInput(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_IMAGE then
		showTable[v.name] = Lua_WindowUtil.createImage(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_PB then
		showTable[v.name] = Lua_WindowUtil.createProgressBar(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	end

	if showTable[v.name] == nil then
		return;
	end

	showTable[v.name].name = v.name;
	if v.type == Lua_WindowUtil.UI_CONTAINER then
		if v.anchor then
			LuaUtil.setObjAnchor(showTable[v.name], v.anchor);
		end
		if v.pivot then
			LuaUtil.setObjPivor(showTable[v.name], v.pivot);
		end
		UIUtils.setObjSiblingIndex(showTable[v.name], v.siblingIndex);
	else
		showTable[v.name].anchorValue = v.anchor;
		showTable[v.name].pivotValue = v.pivot;
		showTable[v.name].siblingIndex = v.siblingIndex;
	end
	if v.show == 0 then
		if v.type == Lua_WindowUtil.UI_CONTAINER then
			showTable[v.name]:SetActive(false);
		else
			showTable[v.name]:setEnable(false);
		end
	end
end

function Lua_WindowUtil.createContainer(p)
	local go = UICreate.createGameObject(p, 0, 0, 0);
	go:AddComponent(typeof(UnityEngine.RectTransform));
	LuaUtil.setRectSize(go, 0, 0);
	return go;
end

function Lua_WindowUtil.createContainerByVec(p, v)
	local go = UICreate.createGameObject(p, v.x, v.y, v.z);
	go:AddComponent(typeof(UnityEngine.RectTransform));
	LuaUtil.setRectSize(go, 0, 0);
	return go;
end

function Lua_WindowUtil.createUIAtlasImage(p, v)
	local atlasImg = UICreate.createUIAtlasImage(p, v.atlas, v.spriteName, v.x, v.y, v.width, v.height);
	atlasImg:setRot(v.rx, v.ry, v.rz, v.rw);
	atlasImg:setScale(v.sx, v.sy);
	atlasImg.typeValue = v.spriteType;
	if v.color ~= nil then
		atlasImg.colorStr = v.color;
	end
	return atlasImg;
end

function Lua_WindowUtil.createLabel(p, v)
	local text = UICreate.createLabel(p, nil, v.x, v.y, v.width, v.height, v.fontSize);
	text:setRot(v.rx, v.ry, v.rz, v.rw);
	text:setScale(v.sx, v.sy);
	Lua_WindowUtil.initTextFieldStyle(text, v);
	text.text = Lua_WindowUtil.getUILan(v);
	return text;
end

function Lua_WindowUtil.initTextFieldStyle(obj, v)
	if v.txtWidth ~= nil and v.txtHeight ~= nil then
		obj:SetDimensions(v.txtWidth, v.txtHeight);
	end

	if v.fontStyle ~= nil then
		obj.fontStyleValue = v.fontStyle;
	end

	if v.fontName ~= nil then
		obj.fontName = v.fontName;
	end

	if v.fontSize ~= nil then
		obj.fontSize = v.fontSize;
	end

	if v.lineSpacing ~= nil then
		obj.lineSpacing = v.lineSpacing;
	end

	if v.richText ~= nil then
		obj.bSupportRichText = v.richText == 1 and true or false;
	end

	if v.alignment ~= nil then
		obj.alignmentValue = v.alignment;
	end

	if v.horizontalOverflow ~= nil then
		obj.horizontalOverflowValue = v.horizontalOverflow;
	end

	if v.verticalOverflow ~= nil then
		obj.verticalOverflowValue = v.verticalOverflow;
	end

	if v.color ~= nil then
		obj.colorStr = v.color;
	end
	
	if v.useGradientColor == 1 then
		obj.bApplyGradient = true;
		obj.gradientTop = v.gradientTop;
		obj.gradientBottom = v.gradientBottom;
	end

	if v.wordSpace ~= nil then
		obj.wordSpacing = v.wordSpace;
	end

	if v.effectStyle ~= nil then
		obj.effectStyle = v.effectStyle;
	end

	if v.effectColor ~= nil then
		obj.effectColorStr = v.effectColor;
	end

	if v.effectDistanceX ~= nil and v.effectDistanceY ~= nil then
		obj:setEffectDistance(v.effectDistanceX, v.effectDistanceY);
	end
end

function Lua_WindowUtil.getUILan(v)
	if v.resetTxt == 1 then
		return uilang[v.text];
	else
		return v.text;
	end
end

function Lua_WindowUtil.createButton(p, v)
	local btn = UICreate.createButton(p, nil, v.x, v.y, v.width, v.height);
	btn:setRot(v.rx, v.ry, v.rz, v.rw);
	btn:setScale(v.sx, v.sy);
	btn:setStyle(v.style);
	Lua_WindowUtil.initTextFieldStyle(btn.txt, v);
	btn.label = Lua_WindowUtil.getUILan(v);
	if v.bgSx and v.bgSy and v.bgSz then
		btn:setBgScale(v.bgSx, v.bgSy, v.bgSz);
	end
	if v.txtX and v.txtY and v.txtZ then
		btn.txt:setLocation(v.txtX, v.txtY, v.txtZ);
	end
	if v.style == 5 or v.style == 7 then -- 临时处理
		btn:SetDimensions(v.width, 67);
	end
	return btn;
end

function Lua_WindowUtil.createInput(p, v)
	local textInput = UICreate.createInput(p, nil, v.x, v.y, v.width, v.height, v.fontSize);
	textInput:setRot(v.rx, v.ry, v.rz, v.rw);
	textInput:setScale(v.sx, v.sy);
	textInput.fontName = v.fontName;
	textInput.fontStyleValue = v.fontStyle;
	textInput.lineSpacing = v.lineSpacing;
	textInput.alignmentValue = v.alignment;
	textInput.horizontalOverflowValue = v.horizontalOverflow;
	textInput.verticalOverflowValue = v.verticalOverflow;
	textInput.colorStr = v.color;
	textInput.text = Lua_WindowUtil.getUILan(v);
	return textInput;
end

function Lua_WindowUtil.createCheckBox(p, v)
	local cbox = UICreate.createCheckBox(p, nil, v.x, v.y, v.width, v.height);
	cbox:setRot(v.rx, v.ry, v.rz, v.rw);
	cbox:setScale(v.sx, v.sy);
	cbox:setStyle(v.style);
	Lua_WindowUtil.initTextFieldStyle(cbox.txt, v);
	cbox.label = Lua_WindowUtil.getUILan(v);
	if v.txtX and v.txtY and v.txtZ then
		cbox.txt:setLocation(v.txtX, v.txtY, v.txtZ);
	end
	return cbox;
end

function Lua_WindowUtil.createImage(p, v)
	local img = UICreate.createImage(p, v.url, v.x, v.y, v.width, v.height);
	img:setScale(v.sx, v.sy);
	img:setRot(v.rx, v.ry, v.rz, v.rw);
	return img;
end

function Lua_WindowUtil.createProgressBar(p, v)
	local pb = UICreate.createProgressBar(p, v.bgAtlas, v.bgSpriteName, v.barAtlas, v.barSpriteName, v.x, v.y, v.width, v.height);
	pb:setRot(v.rx, v.ry, v.rz, v.rw);
	pb:setScale(v.sx, v.sy);
	pb:setBarOffset(v.offsetWidth, v.offsetHeight);
	Lua_WindowUtil.initTextFieldStyle(pb.txt, v);
	pb:setText(Lua_WindowUtil.getUILan(v));
	return pb;
end

function Lua_WindowUtil.getAnchor(v)
	if v == 0 then
		return UIUtils.Anchor.TopLeft;
	elseif v == 1 then
		return UIUtils.Anchor.Top;
	elseif v == 2 then
		return UIUtils.Anchor.TopRight;
	elseif v == 3 then
		return UIUtils.Anchor.Left;
	elseif v == 4 then
		return UIUtils.Anchor.Center;
	elseif v == 5 then
		return UIUtils.Anchor.Right;
	elseif v == 6 then
		return UIUtils.Anchor.BottomLeft;
	elseif v == 7 then
		return UIUtils.Anchor.Bottom;
	elseif v == 8 then
		return UIUtils.Anchor.BottomRight;
	end
    return UIUtils.Anchor.Center;
end

function Lua_WindowUtil.getPivot(v)
	if v == 0 then
		return UIUtils.Pivot.TopLeft;
	elseif v == 1 then
		return UIUtils.Pivot.Top;
	elseif v == 2 then
		return UIUtils.Pivot.TopRight;
	elseif v == 3 then
		return UIUtils.Pivot.Left;
	elseif v == 4 then
		return UIUtils.Pivot.Center;
	elseif v == 5 then
		return UIUtils.Pivot.Right;
	elseif v == 6 then
		return UIUtils.Pivot.BottomLeft;
	elseif v == 7 then
		return UIUtils.Pivot.Bottom;
	elseif v == 8 then
		return UIUtils.Pivot.BottomRight;
	end
	return UIUtils.Pivot.TopLeft;
end

-- function Lua_WindowUtil.getImageType(v)
-- 	if v == 0 then
-- 		return UnityEngine.UI.Image.Type.Simple;
-- 	elseif v == 1 then
-- 		return UnityEngine.UI.Image.Type.Sliced;
-- 	elseif v == 2 then
-- 		return UnityEngine.UI.Image.Type.Tiled;
-- 	elseif v == 3 then
-- 		return UnityEngine.UI.Image.Type.Filled;
-- 	end
-- 	return UnityEngine.UI.Image.Type.Simple;
-- end

-- function Lua_WindowUtil.getImageFillMethod(v)
-- 	if v == 0 then
-- 		return UnityEngine.UI.Image.FillMethod.Horizontal;
-- 	elseif v == 1 then
-- 		return UnityEngine.UI.Image.FillMethod.Vertical;
-- 	elseif v == 2 then
-- 		return UnityEngine.UI.Image.FillMethod.Radial90;
-- 	elseif v == 3 then
-- 		return UnityEngine.UI.Image.FillMethod.Radial180;
-- 	elseif v == 4 then
-- 		return UnityEngine.UI.Image.FillMethod.Radial360;
-- 	end
-- 	return UnityEngine.UI.Image.FillMethod.Simple;
-- end

-- function Lua_WindowUtil.getFontStyle(v)
-- 	if v == 0 then
-- 		return UnityEngine.FontStyle.Normal;
-- 	elseif v == 1 then
-- 		return UnityEngine.FontStyle.Bold;
-- 	elseif v == 2 then
-- 		return UnityEngine.FontStyle.Italic;
-- 	elseif v == 3 then
-- 		return UnityEngine.FontStyle.BoldAndItalic;
-- 	else
-- 		return UnityEngine.FontStyle.Normal;
-- 	end
-- end

function Lua_WindowUtil.getPreLoadList(skinStr)
	local skinTable = checkRequire(skinStr);
	local arr = {};
	local index = 1;
	local resTab = {};
	for i, v in ipairs(skinTable) do
		if v.type == Lua_WindowUtil.UI_SPRITE then
			if resTab[v.type] == nil then
				resTab[v.type] = {};
			end
			if resTab[v.type][v.atlas] == nil then
				resTab[v.type][v.atlas] = v.atlas;
				arr[index] = {resName = v.atlas, type = Lua_WindowUtil.UI_SPRITE};
				index = index + 1;
			end
		end
	end
	return arr, resTab;
end

function Lua_WindowUtil.initWinSkinPreLoadInfo(winName, skinStr)
	if winName == nil or skinStr == nil then
		return;
	end
	
	local skinTable = checkRequire(skinStr);
	for i, v in ipairs(skinTable) do
		if v.type == Lua_WindowUtil.UI_SPRITE then
			Lua_WindowUtil.windowMananger:addWinPreLoadResInfo(winName, Lua_LoadFileType.ATLAS, v.atlas);
		elseif v.type == Lua_WindowUtil.UI_IMAGE then
			if not strIsNullOrEmpty(v.url) then
				Lua_WindowUtil.windowMananger:addWinPreLoadResInfo(winName, Lua_LoadFileType.IMG, v.url);
			end
		end
	end
end